// AtomRendererGL.cpp: AtomRendererGL NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include <string.h>
#include <math.h>
#include "AtomRendererGL.h"
#include "io64.h"

#pragma warning(disable : 4996)


#define FAD_FLAG_J		(0x1)		//GlM[f[^.
#define FAD_FLAG_SIMBOX	(0x2)	//simbox̎w肪.
#define FAD_FLAG_NONORTHOGONALBOX	(0x20)	//simbox񒼌ł.
#define FAD_FLAG_TEMPERATURE		(0x4)	//x񂪂.
#define FAD_FLAG_STEP		(0x8)		//int4^step񂪂.
#define FAD_FLAG_ATOMEXT		(0x10)		//qid̔z񂪂.

	const BYTE atom_colors[] = { 51, 205, 205, 255,	//C_custom
						255, 255, 255, 255,	//H
						255, 240, 30, 255, //He
						255, 20, 151, 255, //Li
						255, 20, 151, 255, //Be
						255, 20, 151, 255, //B
						51, 205, 205, 255, //C
						143, 143, 255, 255, //N
						255, 0, 0, 255, //O
						255, 20, 151, 255, //F
						255, 240, 30, 255, //Ne
						0, 0, 255, 255, //Na
						255, 20, 151, 255, //Mg
						255, 20, 151, 255, //Al
						255, 20, 151, 255, //Si
						255, 128, 0, 255, //P
						255, 255, 51, 255, //S
						0, 255, 0, 255, //Cl
						0, 100, 255, 255, //Ar
						255, 20, 151, 255, //K
						51, 77, 77, 255, //Ca
						255, 20, 151, 255, //the others						
						};
	
	const BYTE bondnum_colors[] = { 128, 128, 128, 255,	//single atom
						0, 128, 255, 255,	//tip
						255, 220, 0, 255, //sp1
						0, 255, 192, 255, //sp2
						255, 0, 0, 255, //sp3
						192, 64, 255, 255, //5 bonds
						255, 255, 255, 255, //6 bonds
						};


#define		ATOM_RADIUS		(0.25)
/*
template<class T> void renew(T** p, int num, int newnum){
	T* vp = new T[newnum];
	if (num <= newnum){
		memcpy(vp, *p, sizeof(T) * num);
	}else{
		memcpy(vp, *p, sizeof(T) * newnum);
	}

	delete [] (*p);
	(*p) = vp;
}
*/
//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////



AtomRendererGL::AtomRendererGL(){
/*	
	m_frameNo = 0;

//	stockFPL = NULL;
//	m_fpos_first = NULL;
	m_wfp = NULL;
*/
	m_maxAtomCount = 1024;
	m_maxBondCount = 4096;

	m_prev_render_dat = NULL;

	m_vbo_positions = NULL;
	m_vbo_normals = NULL;
	m_vbo_colors = NULL;
	m_vbo_indexes = NULL;

	m_visual_atom = VISUAL_ATOM_SPHERE;
	m_visual_bond = VISUAL_BOND_PIPE;
	m_visual_atomcolor =  VISUAL_ATOMCOLOR_Z;
	m_color_table = NULL;
	m_visual_atompoly = 4;

	m_sphere_pos = NULL;
	m_sphere_nor = NULL;
	m_sphere_idx = NULL;
	m_bond_pos = NULL;
	m_bond_nor = NULL;
	m_bond_idx = NULL;

	//|Sf̏
	InitSphere( ATOM_RADIUS, 6, 8);
	InitBond( 0.05f, 8 );

}


AtomRendererGL::~AtomRendererGL(){

	delete [] m_vbo_positions;
	delete [] m_vbo_normals;
	delete [] m_vbo_colors;
	delete [] m_vbo_indexes;

	delete [] m_sphere_pos;
	delete [] m_sphere_nor;
	delete [] m_sphere_idx;
	delete [] m_bond_pos;
	delete [] m_bond_nor;
	delete [] m_bond_idx;
	delete [] m_color_table;

}


/////////////////////////////////////////////////////////////////
//
//Rendering by OpenGL
//
/////////////////////////////////////////////////////////////////


//VBO̐ݒ
void AtomRendererGL::Rendering(ATOMS_DATA* dat){	//int j_mode, float Jmax
	

	//ATOMS_DATA* dat = GetDataPointer();
	if (dat == NULL) return;
	

	//|Cg`.
	if (m_visual_atom == VISUAL_ATOM_POINT){

		//vboZbg(J[̂)
		if(dat != m_prev_render_dat){
			m_prev_render_dat = dat;
			delete [] m_vbo_colors;
			m_vbo_colors = new BYTE[dat->pcnt * 4];

			UINT* v = (UINT*)m_vbo_colors;
			for(int i = 0; i < dat->pcnt; i++){
				v[i] = 0x4DB3B3B3;				
			}
			//memset(m_vbo_colors, 255, dat->pcnt * 4);
		}


		glDisable(GL_LIGHTING);
		glDisable(GL_DEPTH_TEST);
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		//glEnable(GL_ALPHA_TEST);

		glPointSize(2.0);
		//glColor4f( 0.7f, 0.7f, 0.7f, 1.0f );
		glDisable(GL_CULL_FACE);
		
		glEnableClientState(GL_VERTEX_ARRAY);
		//glEnableClientState(GL_NORMAL_ARRAY);
		glEnableClientState(GL_COLOR_ARRAY);
		glEnable(GL_COLOR_MATERIAL);//_J[𔽉f
		glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
		
					//glBindBuffer(GL_ARRAY_BUFFER, 0);
					//glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);

		glVertexPointer(3, GL_FLOAT, 0, (float*)(dat->r));
		//glNormalPointer(GL_FLOAT, 0, (float*)m_vbo_normals);
		glColorPointer(4, GL_UNSIGNED_BYTE, 0, (BYTE*)m_vbo_colors);	//l͕K4ł
		
		glDrawArrays(GL_POINTS, 0, dat->pcnt);
		GLenum err = glGetError();
		if(err){
			char buf[1024];
			sprintf(buf, "%s", gluErrorString(err));
			printf("%s\n", buf);
		}

		glFlush();
		glDisableClientState(GL_VERTEX_ARRAY);
		//glDisableClientState(GL_NORMAL_ARRAY);
		glDisableClientState(GL_COLOR_ARRAY);
		glDisable(GL_COLOR_MATERIAL);//_J[𔽉f
		//glEnable(GL_CULL_FACE);
		
		glPointSize(1.0);

		glDisable(GL_ALPHA_TEST);
		glDisable(GL_BLEND);
		glEnable(GL_DEPTH_TEST);
		glEnable(GL_LIGHTING);




	//|S`.
	}else{
		//vbõZbg
		if(dat != m_prev_render_dat){
			CreateSphereArray(dat);
			m_prev_render_dat = dat;
		}
		
		glDisable(GL_BLEND);
				
			glColor4f( 1.0f, 1.0f, 1.0f, 1.0f );
		glDisable(GL_CULL_FACE);
		
		glEnableClientState(GL_VERTEX_ARRAY);
		glEnableClientState(GL_NORMAL_ARRAY);
		glEnableClientState(GL_COLOR_ARRAY);
		glEnable(GL_COLOR_MATERIAL);//_J[𔽉f
		glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
		
					//glBindBuffer(GL_ARRAY_BUFFER, 0);
					//glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);

		glVertexPointer(3, GL_FLOAT, 0, (float*)m_vbo_positions);
		glNormalPointer(GL_FLOAT, 0, (float*)m_vbo_normals);
		glColorPointer(4, GL_UNSIGNED_BYTE, 0, (BYTE*)m_vbo_colors);	//l͕K4ł
		
		glDrawElements(GL_TRIANGLES, m_vbo_icount, GL_UNSIGNED_INT, (GLuint*)m_vbo_indexes);
		GLenum err = glGetError();
		if(err){
			char buf[1024];
			sprintf(buf, "%s", gluErrorString(err));
			printf("%s\n", buf);
		}

		glFlush();
		glDisableClientState(GL_VERTEX_ARRAY);
		glDisableClientState(GL_NORMAL_ARRAY);
		glDisableClientState(GL_COLOR_ARRAY);
		glDisable(GL_COLOR_MATERIAL);//_J[𔽉f
		glEnable(GL_CULL_FACE);

	}
}


void AtomRendererGL::CreateSphereArray(ATOMS_DATA* dat){

	//ATOMS_DATA* dat = GetDataPointer();
	if (m_maxAtomCount < dat->pcnt) {m_maxAtomCount = dat->pcnt;}
	if (m_maxBondCount < dat->bondInsideCnt) {m_maxBondCount = dat->bondInsideCnt;}

	//vboTCY
	int vbo_v_sz = m_maxAtomCount * m_sphere_vcnt + m_maxBondCount * m_bond_vcnt;
	int vbo_i_sz = m_maxAtomCount * m_sphere_icnt + m_maxBondCount * m_bond_icnt;

	delete [] m_vbo_positions;
	m_vbo_positions = new vec3f[vbo_v_sz];
	delete [] m_vbo_normals;
	m_vbo_normals = new vec3f[vbo_v_sz];
	delete [] m_vbo_colors;
	m_vbo_colors = new BYTE[vbo_v_sz*4];
	delete [] m_vbo_indexes;
	m_vbo_indexes = new int[vbo_i_sz];

	m_vbo_vcount = 0;
	m_vbo_icount = 0;
	int i;

	
	//J[e[u
	if(m_visual_atomcolor ==  VISUAL_ATOMCOLOR_BONDNUM){
		CheckColorByBondNum(dat);
	}else{	//MODE_COLOR_ATOMIC
		CheckColorByAtomKind(dat);
	}
	


	//q()̃Zbg
	if( m_visual_atom ){
		
		for(i=0;i<dat->pcnt;i++){

			SetSphere(dat->r[i], m_color_table[i],
						m_vbo_vcount,	//_ԍoffset
						m_vbo_positions + m_vbo_vcount,
						m_vbo_normals + m_vbo_vcount,
						m_vbo_colors + m_vbo_vcount * 4,
						m_vbo_indexes + m_vbo_icount);

			m_vbo_vcount += m_sphere_vcnt;
			m_vbo_icount += m_sphere_icnt;
			
		}
	}

	//{h̃Zbg
	if( m_visual_bond ){
		
		for (SIMPLE_IJ* b = dat->bonds; b != dat->bonds + dat->bondInsideCnt;b++){
			int li = b->i;
			int lj = b->j;

			
			SetBond(dat->r[li], dat->r[lj], 
					m_color_table[li],
					m_color_table[lj],
					m_vbo_vcount,
					m_vbo_positions + m_vbo_vcount,
					m_vbo_normals + m_vbo_vcount,
					m_vbo_colors + m_vbo_vcount*4,
					m_vbo_indexes + m_vbo_icount);
			
			m_vbo_vcount += m_bond_vcnt;
			m_vbo_icount += m_bond_icnt;
			
		}
	}	
	
}

///////////////////////////////////////////////
//
//VBOɃ|SZbg@\
//
////////////////////////////////////////////////
	
void AtomRendererGL::InitSphere(float radius, int slices, int stacks){
	int i, k;
	double daXY = 2.0*PI/double(stacks);
	double daZX = PI/double(slices);
	double angleZX;
	double angleXY;
	float cosZX, sinZX;
	float *cosXY, *sinXY;
	

	
	cosXY = new float[stacks];
	sinXY = new float[stacks];
	
	angleXY = daXY;
	cosXY[0] = 1.f;
	sinXY[0] = 0.f;
	for (i = 1; i < stacks; i++){
		cosXY[i] = (float)cos(angleXY);
		sinXY[i] = (float)sin(angleXY);
		angleXY += daXY;
	}

	m_sphere_vcnt = (slices - 1) * stacks + 2;
	delete [] m_sphere_pos;
	delete [] m_sphere_nor;
	vec3f *pos = m_sphere_pos = new vec3f[m_sphere_vcnt];
	vec3f *nor = m_sphere_nor = new vec3f[m_sphere_vcnt];


	nor->Set(0.0f, 0.0f, 1.0f);
	nor++;
	pos->Set(0.0f,0.0f,(float)radius);
	pos++;

	angleZX = daZX;
	for (i = 1; i < slices; i++){
		cosZX = (float)cos(angleZX);
		sinZX = (float)sin(angleZX);

		for (k = 0; k < stacks; k++){
			
			nor->Set(sinZX * cosXY[k], sinZX * sinXY[k], cosZX);
			pos->x = nor->x * radius;
			pos->y = nor->y * radius;
			pos->z = nor->z * radius;

			nor++;
			pos++;
		}
		angleZX += daZX;
	}
	
	nor->Set(0.0f, 0.0f, -1.0f);
	pos->Set(0.0f,0.0f, -radius);
	
	delete [] cosXY;
	delete [] sinXY;


	//CfbNXz̃Zbg
	m_sphere_icnt = (slices - 1)*stacks*6;
	delete [] m_sphere_idx;
	int* idx = m_sphere_idx = new int[m_sphere_icnt];
	int offset = 1;
	for(i=0; i < stacks; i++){
		*idx = 0;
		idx++;
		*idx = i + offset;
		idx++;
		*idx = ((i + 1) % stacks) + offset;
		idx++;
	}
	//offset += stacks;
	
	
	for (k = 0; k < slices - 2; k++){
		for(i=0; i < stacks; i++){
			*idx = i + offset;
			idx++;
			*(idx + 3) = *idx = i + offset + stacks;
			idx++;
			*(idx + 1) = *idx = ((i + 1) % stacks) + offset;
			idx+=3;
			*idx = ((i + 1) % stacks) + offset + stacks;
			idx++;
		}
		offset += stacks;
	}

	for(i=0; i < stacks; i++){
		*idx = i + offset;
		idx++;
		*idx = m_sphere_vcnt - 1;
		idx++;
		*idx = ((i + 1) % stacks) + offset;
		idx++;
	}
	
};

inline void AtomRendererGL::SetSphere(vec3f& orgin, unsigned int onecolor, int index_offset, vec3f* positions, vec3f* normals, BYTE* colors, int* indexes){
	int i;
	unsigned int *cols = (unsigned int*)colors;
	
	for( i = 0; i < m_sphere_vcnt; i++){
		positions[i] = m_sphere_pos[i] + orgin;
		*cols = onecolor;
		cols++;		
	}
	
	memcpy(normals, m_sphere_nor, m_sphere_vcnt * sizeof(vec3f));
	
	for( i = 0; i < m_sphere_icnt; i++){
		indexes[i] = m_sphere_idx[i] + index_offset;
	}	

}



void AtomRendererGL::InitBond(float radius, int stacks){
	int i, k;
	double daXY = 2.0*PI/double(stacks);
	double angleXY;
	float *cosXY, *sinXY;
	

	
	cosXY = new float[stacks];
	sinXY = new float[stacks];
	
	angleXY = daXY;
	cosXY[0] = 1.f;
	sinXY[0] = 0.f;
	for (i = 1; i < stacks; i++){
		cosXY[i] = (float)cos(angleXY);
		sinXY[i] = (float)sin(angleXY);
		angleXY += daXY;
	}

	m_bond_vcnt = stacks * 2;
	vec3f *pos = m_bond_pos = new vec3f[m_bond_vcnt];
	vec3f *nor = m_bond_nor = new vec3f[m_bond_vcnt];


	for (k = 0; k < stacks; k++){
			
		nor->Set(cosXY[k], sinXY[k], 0.f);
		pos->x = nor->x * radius;
		pos->y = nor->y * radius;
		pos->z = nor->z * radius;
		
		nor++;
		pos++;
		
	}

	memcpy(nor, m_bond_nor, sizeof(vec3f)*stacks);
	memcpy(pos, m_bond_pos, sizeof(vec3f)*stacks);

	for (k = 0; k < stacks; k++){
		pos->z += 1.f;
		pos++;
	}

	delete [] cosXY;
	delete [] sinXY;


	//CfbNXz̃Zbg
	m_bond_icnt = stacks * 6;
	int* idx = m_bond_idx = new int[m_bond_icnt];
	
	for(i=0; i < stacks; i++){
		*idx = i;
		idx++;
		*(idx + 3) = *idx = ((i + 1) % stacks);
		idx++;
		*(idx + 1) = *idx = i + stacks;
		idx+=3;
		*idx = ((i + 1) % stacks) + stacks;
		idx++;	
	}		
	
	
	
};


void AtomRendererGL::InitCone(float radius, int stacks){
	int k;

	InitBond(radius, stacks);
	vec3f *pos = m_bond_pos;
	for (k = 0; k < stacks; k++){
			
		pos->x *= 3.f;
		pos->y *= 3.f;
		pos->z = ATOM_RADIUS;
		pos++;
		
	}

	for (k = 0; k < stacks; k++){
		pos->x = 0.f;
		pos->y = 0.f;
		pos->z -= ATOM_RADIUS;
		pos++;
	}

};

inline void AtomRendererGL::SetBond(vec3f& v1, vec3f& v2, unsigned int onecolor, unsigned int othercolor, int index_offset, vec3f* positions, vec3f* normals, BYTE* colors, int* indexes){
	int i;
	//int m[16];

	unsigned int *cols = (unsigned int*)colors;
	

	vec3f axis = v2 - v1;
	double dlength = (double)(axis.x * axis.x + axis.y * axis.y);
	float sxy = (float)sqrt(dlength);
	float flength = (float)sqrt((dlength + (double)(axis.z * axis.z)));
	//flength = 

	//	memcpy(positions, m_bond_pos, m_bond_vcnt * sizeof(vec3f));
	//memcpy(normals, m_bond_nor, m_bond_vcnt * sizeof(vec3f));

	sxy /= flength;
	if (sxy < 0.00001f){	//ւ̗O
		if(axis.z < -0.f){
			for( i = 0; i < m_bond_vcnt; i++){
				positions[i].x = -m_bond_pos[i].x  + v1.x;
				positions[i].y = m_bond_pos[i].y  + v1.y;
				positions[i].z = -m_bond_pos[i].z * flength + v1.z;
				normals[i].x = -m_bond_nor[i].x;
				normals[i].y = m_bond_nor[i].y;
				normals[i].z = -m_bond_nor[i].z;
			}
		}else{
			//memcpy(positions, m_bond_pos, m_bond_vcnt * sizeof(vec3f));
			memcpy(normals, m_bond_nor, m_bond_vcnt * sizeof(vec3f));
			for( i = 0; i < m_bond_vcnt; i++){
				positions[i].x = m_bond_pos[i].x  + v1.x;
				positions[i].y = m_bond_pos[i].y  + v1.y;
				positions[i].z = m_bond_pos[i].z * flength + v1.z;
				
			}
		}
	}else{
		vec3f m1, m2, m3;
		//axis *= 1.f/flength;
		float xdsxy = axis.x / (sxy * flength); 
		float ydsxy = axis.y / (sxy * flength);
		m1.Set(axis.z / flength * xdsxy, -ydsxy, axis.x);
		m2.Set(axis.z / flength * ydsxy, xdsxy, axis.y);
		m3.Set(-sxy, 0.f, axis.z);

		for( i = 0; i < m_bond_vcnt; i++){
			positions[i].x = m1 * m_bond_pos[i] + v1.x;
			positions[i].y = m2 * m_bond_pos[i] + v1.y;
			positions[i].z = m3 * m_bond_pos[i] + v1.z;
			normals[i].x = m1 * m_bond_nor[i];
			normals[i].y = m2 * m_bond_nor[i];
			normals[i].z = m3 * m_bond_nor[i];
		}
	}

	//color̃Zbg	
	for( i = 0; i < m_bond_vcnt / 2; i++){
		*cols = onecolor;
		cols++;
	}

	for( i = 0; i < m_bond_vcnt / 2; i++){
		*cols = othercolor;
		cols++;
	}
		

	//CfbNX̃Zbg	
	for( i = 0; i < m_bond_icnt; i++){
		indexes[i] = m_bond_idx[i] + index_offset;
	}
		
	
	memcpy(normals, m_bond_nor, m_bond_vcnt * sizeof(vec3f));
	
	
}


void AtomRendererGL::SetMode(int type, int mode, ATOMS_DATA* dat){
	switch(type){
	case VISUAL_TYPE_ATOM:	//q\

		switch(mode){
		case VISUAL_ATOM_SPHERE:
			m_visual_atom = mode;
			InitSphere(ATOM_RADIUS, m_visual_atompoly, m_visual_atompoly*2);	//6,8
			break;
		case VISUAL_ATOM_LARGE:
			m_visual_atom = mode;
			InitSphere(ATOM_RADIUS * 4.0, m_visual_atompoly, m_visual_atompoly*2);
			break;
		case VISUAL_ATOM_POINT:
			m_visual_atom = mode;
			delete [] m_sphere_pos;
			m_sphere_pos = NULL;
			delete [] m_sphere_nor;
			m_sphere_nor = NULL;
			break;
		case VISUAL_ATOM_NONE:
			m_visual_atom = mode;
			break;
		}
		break;
	case VISUAL_TYPE_BOND:	//{h\
		switch(mode){
		case VISUAL_BOND_PIPE:
			m_visual_bond = mode;
			InitBond( 0.05f , 8 );
			break;
		case VISUAL_BOND_ENERGYJ:
			m_visual_bond = mode;
			InitCone( 0.05f , 8 );
			break;
		case VISUAL_BOND_NONE:
			m_visual_bond = mode;
			break;
		}
		break;
	case VISUAL_TYPE_ATOMCOLOR:	//\F
		switch(mode){
		case VISUAL_ATOMCOLOR_Z:
			m_visual_atomcolor = mode;
			CheckColorByAtomKind(dat);
			break;
		case VISUAL_ATOMCOLOR_BONDNUM:
			m_visual_atomcolor = mode;
			CheckColorByBondNum(dat);
			break;
		}
		break;
		
	case VISUAL_TYPE_ATOMPOLY:	//q̃|S(ܓx̕)

		if(mode >= 2){
			m_visual_atompoly = mode;
			InitSphere(ATOM_RADIUS, m_visual_atompoly, m_visual_atompoly*2);	//6,8
		}
		break;
		
	case VISUAL_TYPE_BONDPOLY:	//q̃|S(ܓx̕)

		if(mode >= 3){
			m_visual_bondpoly = mode;
			InitBond( 0.05f , m_visual_bondpoly );
		}
		break;
	}

	m_prev_render_dat = NULL;
}
	

//qԍɃJ[vZ
void AtomRendererGL::CheckColorByAtomKind( ATOMS_DATA* dat){
	
	//ATOMS_DATA* dat = GetDataPointer();

	delete [] m_color_table;
	m_color_table = new unsigned int[dat->pcnt];
	
	//FQ
	int i;
	for(i = 0; i < dat->pcnt; i++){
		m_color_table[i] = *(((unsigned int*)atom_colors) + dat->knd[i]);
	}
}

//{hɃJ[vZ
void AtomRendererGL::CheckColorByBondNum( ATOMS_DATA* dat){
	
	//ATOMS_DATA* dat = GetDataPointer();

	delete [] m_color_table;
	m_color_table = new unsigned int[dat->pcnt];
	memset(m_color_table, 0, sizeof(unsigned int) * dat->pcnt);

	//bondvZ
	
	for (SIMPLE_IJ* b = dat->bonds; b != dat->bonds + dat->bcnt;b++){
		m_color_table[b->i] ++;
		m_color_table[b->j] ++;
	}
	//FQ
	for(int i = 0; i < dat->pcnt; i++){
		m_color_table[i] = *(((unsigned int*)bondnum_colors) + m_color_table[i]);
	}
}

void AtomRendererGL::ClearVRAM(){
	m_prev_render_dat = NULL;

}

void AtomRendererGL::UpdateVertexBuffer(LPVOID pBuffer, UINT count, UINT stride){

		
		glEnableClientState(GL_VERTEX_ARRAY);
		glEnableClientState(GL_NORMAL_ARRAY);
		//glEnableClientState(GL_COLOR_ARRAY)
		//glEnable(GL_COLOR_MATERIAL);//_J[𔽉f
		//glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);

					//VBOgꍇ.
					//glBindBuffer(GL_ARRAY_BUFFER, 0);
					//glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);

		glVertexPointer(3, GL_FLOAT,  sizeof(float)*6, (float*)pBuffer);
		glNormalPointer(GL_FLOAT, sizeof(float)*6, (float*)pBuffer + 3);
		//glColorPointer(4, GL_UNSIGNED_BYTE, 0, (BYTE*)m_vbo_colors);	//l͕K4ł
		
}
void AtomRendererGL::UpdateIndexBuffer(LPVOID pBuffer, UINT count, UINT stride){

	switch(stride){
	case 4:
		m_index_type = GL_UNSIGNED_INT;
		break;
	case 2:
		m_index_type = GL_UNSIGNED_SHORT;
		break;
	case 1:
		m_index_type = GL_UNSIGNED_BYTE;
		break;
	} 
	m_vbo_indexes = (int*)pBuffer;
	m_vbo_icount = count;

}

void AtomRendererGL::Draw(UINT index_count, vec3f* position){

	glDisable(GL_BLEND);
	glColor4f( 1.0f, 1.0f, 1.0f, 1.0f );
	glDisable(GL_CULL_FACE);

					
	glDrawElements(GL_TRIANGLES, index_count, m_index_type, m_vbo_indexes);
	glFlush();

	//n.
	glDisableClientState(GL_VERTEX_ARRAY);
	glDisableClientState(GL_NORMAL_ARRAY);
	glDisableClientState(GL_COLOR_ARRAY);
	glDisable(GL_COLOR_MATERIAL);//_J[𔽉f
	glEnable(GL_CULL_FACE);

}