// AtomRendererGL.h: AtomRendererGL NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#ifndef __AtomRendererGL_h__
#define __AtomRendererGL_h__

#pragma once

#include <stdio.h>

#include "MDLoader.h"

#include "sdkwgl.h"
#include "vec3.h"
#include "mat33.h"
#include "mat44.h"
#include "io64.h"
#include "mod.h"

#define TXT_INITIAL_ATOM 4096
#define TXT_INITIAL_BOND 8192


#include "visual.h"

#define KIND_ALL (255)


class AtomRendererGL  
{
private:



//OpenGLp_f[^
	int m_maxAtomCount;
	int m_maxBondCount;
	int m_vbo_vcount;
	vec3f* m_vbo_positions;
	vec3f* m_vbo_normals;
	BYTE* m_vbo_colors;
	int m_vbo_icount;
	int* m_vbo_indexes;
	unsigned int m_index_type;

	unsigned int *m_color_table;	//qƂ̐F

	ATOMS_DATA* m_prev_render_dat;	//O񃌃_Of[^
	void CreateSphereArray(ATOMS_DATA* dat);

//|Sfp̃obt@
	vec3f* m_sphere_pos;
	vec3f* m_sphere_nor;
	int* m_sphere_idx;
	int m_sphere_vcnt, m_sphere_icnt;
	void InitSphere(float radius, int slices, int stacks);
	void SetSphere(vec3f& orgin, unsigned int onecolor, int index_offset, vec3f* positions, vec3f* normals, BYTE* colors, int* indexes);
	
	
	vec3f* m_bond_pos;
	vec3f* m_bond_nor;
	int* m_bond_idx;
	int m_bond_vcnt, m_bond_icnt;
	void InitBond(float radius, int stacks);
	void InitCone(float radius, int stacks);
	void SetBond(vec3f& v1, vec3f& v2, unsigned int onecolor, unsigned int othercolor, int index_offset, vec3f* positions, vec3f* normals, BYTE* colors, int* indexes);

	void CheckColorByBondNum( ATOMS_DATA* dat);
	void CheckColorByAtomKind( ATOMS_DATA* dat);
	
	//\[h
	int m_visual_atom;	//q̕\TCY
	int m_visual_bond;	//{h̕\
	int m_visual_atomcolor;	//q̐F(qԍZ or {h)
	int m_visual_atompoly;	//q̃|S(ܓx̕B2ȏBox͈̕ܓx̔{ɂȂ)
	int m_visual_bondpoly;



public:
	float Jmax;

	AtomRendererGL();
	virtual ~AtomRendererGL();


	void Rendering(ATOMS_DATA* dat);

	void SetMode(int type, int mode, ATOMS_DATA* dat);
	void ClearVRAM();	

//ROWDOG///////////////////////
	
	void UpdateVertexBuffer(LPVOID pBuffer, UINT count, UINT stride);
	void UpdateIndexBuffer(LPVOID pBuffer, UINT count, UINT stride);
	virtual void Draw(UINT index_count, vec3f* position);

	
	void SetViewMatrixPointer(mat44f* pViewMatrix );
	void SetProjectionMatrixPointer(mat44f* pProjectionMatrix );

	
};





#endif // AtomRendererGL

