// GLObj_MD.cpp: GLObj_MD NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "GLObj_MD.h"
#include <string.h>
#include <math.h>
#include "io64.h"

#pragma warning(disable : 4996)


#define FAD_FLAG_J		(0x1)		//GlM[f[^.
#define FAD_FLAG_SIMBOX	(0x2)	//simbox̎w肪.
#define FAD_FLAG_NONORTHOGONALBOX	(0x20)	//simbox񒼌ł.
#define FAD_FLAG_TEMPERATURE		(0x4)	//x񂪂.
#define FAD_FLAG_STEP		(0x8)		//int4^step񂪂.
#define FAD_FLAG_ATOMEXT		(0x10)		//qid̔z񂪂.

	BYTE atom_colors[] = { 51, 205, 205, 255,	//C_custom
						255, 255, 255, 255,	//H
						255, 20, 151, 255, //He
						255, 20, 151, 255, //Li
						255, 20, 151, 255, //Be
						255, 20, 151, 255, //B
						120, 120, 120, 255, //C
						143, 143, 255, 255, //N
						255, 0, 0, 255, //O
						255, 20, 151, 255, //F
						255, 20, 151, 255, //Ne
						0, 0, 255, 255, //Na
						255, 20, 151, 255, //Mg
						255, 20, 151, 255, //Al
						255, 20, 151, 255, //Si
						255, 128, 0, 255, //P
						255, 255, 51, 255, //S
						0, 255, 0, 255, //Cl
						255, 20, 151, 255, //Ar
						255, 20, 151, 255, //K
						51, 77, 77, 255, //Ca
						255, 20, 151, 255, //the others						
						};
	
	BYTE bondnum_colors[] = { 128, 128, 128, 255,	//single atom
						0, 128, 255, 255,	//tip
						255, 220, 0, 255, //sp1
						0, 255, 192, 255, //sp2
						255, 0, 0, 255, //sp3
						192, 64, 255, 255, //5 bonds
						255, 255, 255, 255, //6 bonds
						};


#define		ATOM_RADIUS		(0.25)

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////


template<class T> AutoArray<T>::AutoArray(int initial_size, int ratio){
	buffer = new T[initial_size];
	size = initial_size;
	count = 0;
	m_ratio = ratio;
};

template<class T> AutoArray<T>::~AutoArray(){
	delete [] buffer;
};

template<class T> void AutoArray<T>::Add(T& t){
	if(size == count){
		T* old = buffer;
		size *= m_ratio;
		buffer = new T[size];
		memcpy(buffer, old, sizeof(T) * count);
		delete [] old;
	}
	buffer[count] = t;
	count++;
};



GLObj_MD::GLObj_MD(const TCHAR *filename){
	
	m_frame_buf = new AutoArray<FRAME_POS>(1024, 2);
	
	m_frameNo = 0;

//	stockFPL = NULL;
//	m_fpos_first = NULL;
	m_wfp = NULL;

	m_maxAtomCount = 0;
	m_maxBondCount = 0;
	m_prev_render_dat = NULL;

	m_vbo_positions = NULL;
	m_vbo_normals = NULL;
	m_vbo_colors = NULL;
	m_vbo_indexes = NULL;

	m_mode_atom = MODE_ATOM_SMALL;
	m_mode_bond = MODE_BOND_PIPE;
	m_mode_color = MODE_COLOR_ATOMIC;
	m_color_table = NULL;

	m_sphere_pos = NULL;
	m_sphere_nor = NULL;
	m_sphere_idx = NULL;
	m_bond_pos = NULL;
	m_bond_nor = NULL;
	m_bond_idx = NULL;

	Load(filename);

		//|Sf̏
	InitSphere( ATOM_RADIUS, 6, 8);
	InitBond( 0.05f, 8 );

}


GLObj_MD::~GLObj_MD(){
	if(fp){ fclose64(fp);}
	//delete [] stockFPL;
	clearBuffer();

	closeWriteFile();
}



void GLObj_MD::Load(const TCHAR *filename){
//	nowDat = fstDat = NULL;
	
	//long64 filelen;
	int mcnt;

	size_t outlen = _tcslen(filename);
	if(_tcscmp(filename + outlen - 4,_T(".dat")) == 0){

		fp = fopen64(filename,_T("rb"));
		if( fp == NULL ){  // ֐sĂȂ
			printf( "t@C̃I[vɎs܂ : %s\n",filename);	
			readMode = -1;
			return;  // ُI͂OȊOԂ
		}
	
		//fseek64(fp, LONG64_ZERO, SEEK_END);
		//filelen = ftell64(fp);

		mcnt = readBIN(fp, 1);
	//	m_fpos_current = m_fpos_first;
	
	}else if(_tcscmp(filename + outlen - 4,_T(".fad")) == 0){

		fp = fopen64(filename,_T("rb"));
		//fp = _tfopen(filename,_T("rb"));
		if( fp == NULL ){  // ֐sĂȂ
			printf( "t@C̃I[vɎs܂ : %s\n",filename);	
			readMode = -1;
			return;  // ُI͂OȊOԂ
		}
	
		//fseek64(fp, LONG64_ZERO, SEEK_END);
		//filelen = ftell64(fp);

		mcnt = readBIN(fp, 2);
	//	m_fpos_current = m_fpos_first;

	}else if(_tcscmp(filename + outlen - 4, _T(".pdb")) == 0){
		//eLXg`̂Ƃ
		//64rbgł͓ǂ܂ȂB

		FILE* fp32 = _tfopen(filename,_T("r"));
		if( fp32 == NULL ){  // ֐sĂȂ
			printf( "t@C̃I[vɎs܂ : %s\n",filename);	
			readMode = -1;
			return;  // ُI͂OȊOԂ
		}
	
		mcnt = readTXT(fp32, 3);
	//	m_fpos_current = m_fpos_first;
		fclose(fp32);
		readMode = 0;
		return;
	}else if(_tcscmp(filename + outlen - 4,_T(".xyz")) == 0){

		FILE* fp32 = _tfopen(filename,_T("r"));
		if( fp32 == NULL ){  // ֐sĂȂ
			printf( "t@C̃I[vɎs܂ : %s\n",filename);	
			readMode = -1;
			return;  // ُI͂OȊOԂ
		}
	
		mcnt = readTXT(fp32, 4);
	//	m_fpos_current = m_fpos_first;
		fclose(fp32);
		readMode = 0;
		return;
	}

	
	if(readMode > 0){
	/*	stockCnt = mcnt;
		stockFPL = new FILEPOS_LIST*[stockCnt];
		for(stockIdx = 0; stockIdx < stockCnt; stockIdx++){
			stockFPL[stockIdx] = m_fpos_current;
			m_fpos_current = m_fpos_current->next;
		}
		m_fpos_current = m_fpos_first;
		stockIdx = 0;
		*/
	}else if(readMode == 0){
		fclose64(fp);
		fp=NULL;
		fp_pos = LONG64_FULL;
	}
}


int GLObj_MD::readBIN(FILE64 *fp, int mode){

//	FILEPOS_LIST* fa;
//	FILEPOS_LIST* fb;
	ATOMS_DATA *a;

	int mcnt;
		
//	fb = NULL;
	mcnt = 0;
	fp_pos = LONG64_ZERO;
	m_unknown_pos = LONG64_ZERO;
	Jmax = -1.0;

	readMode = 0;

	//rewind(fp);
	fseek64(fp, LONG64_ZERO, SEEK_SET);
	
	switch(mode){
	case 1:
		a = readFrameDAT(fp,fp_pos);
		break;
	case 2:
		a = readFrameFAD(fp,fp_pos);
		break;
	default:
		return 0;
	}

	while(a){
		

//		fa = new FILEPOS_LIST;
//		fa->prev = fb;
//		if (fb) {fb->next = fa;}
//		else{m_fpos_first=fa;}

		//fa->atmdat = a;
		if(a->no == -1){ a->no = mcnt;}
		FRAME_POS frame;
		frame.filepos = fp_pos;
		frame.atmdat = a;
		frame.keep = 0;
		m_frame_buf->Add(frame);
		//fa->pos = fp_pos;
		
		//fb=fa;
		
		//pos = jumplen + sizeof(int) * 3;
		fp_pos = ftell64(fp);
		//printf("model %d, particle %d, bond %d\n",mcnt,pcnt,bcnt);


//		if(mcnt % 1000 == 0 ){	printf("read now %d", mcnt);}
		mcnt ++;

		if(fp_pos > READLIMIT){
			//obt@[t
			//rf̈
			m_unknown_pos = fp_pos;
			readMode = mode;			
			break;
		}

		switch(mode){
		case 1:
			a = readFrameDAT(fp,fp_pos);
			break;
		case 2:
			a = readFrameFAD(fp,fp_pos);
			break;
		}

	}
	//fb->next = NULL;
	//a->prev = b;
	if (m_unknown_pos) {
		//rf
		printf("buffer fulls halfway\n");
	}

	
//	stockCnt = mcnt;
//	stock = new FILEPOS_LIST*[stockCnt];
//	stockIdx = 0;
		
	printf("%d frame loaded\n",mcnt);
//	printf("%d atom exist\n",m_fpos_first->atmdat->pcnt);
	
	return mcnt;
	
}





ATOMS_DATA* GLObj_MD::readFrameDAT(FILE64* fp, long64 filepos){
	//ǂݍݐFGLObj_MDԂ
	//sFNULLԂ
	//t@CI[œǂ߂ȂƂFNULLԂ

	ATOMS_DATA *a = new ATOMS_DATA;
	
	int i;//,j,dmyi;
	int pcnt,bcnt;
	float rr,xx,yy,zz;
	const float bondmax[] = {2.0f*2.0f, 1.8f*1.8f, 1.7f*1.7f};//{1.85*1.85, 1.55*1.55, 1.4*1.4};
	
		
	//float boxx, boxy, boxz;
	mat33f boxaxis;
	vec3f boxorg;
	float tempave, tempvar;
	int istep;


	int* knd = NULL;
	float* rx = NULL;
	float* ry = NULL;
	float* rz = NULL;
	vec3f* r = NULL;
	int* li = NULL;
	int* lj = NULL;
	float* Jij = NULL;
	char* bond = NULL;
	
	

	int flag_J;

	if(filepos != fp_pos){
		fseek64(fp, filepos, SEEK_SET);
	}

	if(fread64(&pcnt, sizeof(int), 1, fp) == 1){
		fread64(&bcnt, sizeof(int), 1, fp);
		fread64(&flag_J, sizeof(int), 1, fp);

		knd = new int[pcnt];
		rx = new float[pcnt];
		ry = new float[pcnt];
		rz = new float[pcnt];
		
		li = new int[bcnt];
		lj = new int[bcnt];
		bond = new char[bcnt];
		if(flag_J & FAD_FLAG_J){ Jij = new float[bcnt];}

		fread64(knd,	sizeof(char)*pcnt, 1, fp);
		fread64(rx,	sizeof(float)*pcnt, 1, fp);
		fread64(ry,	sizeof(float)*pcnt, 1, fp);
		fread64(rz,	sizeof(float)*pcnt, 1, fp);
		r = new vec3f[pcnt];
		for (i = 0; i < pcnt; i++){
			r[i].x = rx[i];
			r[i].y = ry[i];
			r[i].z = rz[i];
		}
		delete [] rx; rx = NULL;
		delete [] ry; ry = NULL;
		delete [] rz; rz = NULL;

		fread64(li,	sizeof(int)*bcnt, 1, fp);
		fread64(lj,	sizeof(int)*bcnt, 1, fp);

		if(flag_J & FAD_FLAG_J){
			fread64(Jij, sizeof(float)*bcnt, 1, fp);
		
			for(i=0;i<bcnt;i++){
				if(Jij[i] < 0.0){
					int dmyi = li[i];
					li[i] = lj[i];
					lj[i] = dmyi;
					Jij[i] = - (Jij[i]);
				}
				if (Jmax < Jij[i]) {Jmax=Jij[i];}
			}
		}
		
		for(i=0;i<bcnt;i++){
			xx = rx[li[i]] - rx[lj[i]];
			yy = ry[li[i]] - ry[lj[i]];
			zz = rz[li[i]] - rz[lj[i]];
			rr = xx * xx + yy*yy + zz*zz;
			if (rr <= bondmax[(knd[li[i]] & 0x01) + (knd[lj[i]] & 0x01)] ){
				bond[i] = 1;
			}else{
				bond[i] = 0;
			}
		}

		if (flag_J & FAD_FLAG_SIMBOX) { //simbox̎w肪
			if (flag_J & FAD_FLAG_NONORTHOGONALBOX){//ɂsimboxw.
				
			}else{
				boxaxis.Clear();
				fread64(&(boxaxis.m11),	sizeof(float), 1, fp);
				fread64(&(boxaxis.m22),	sizeof(float), 1, fp);
				fread64(&(boxaxis.m33),	sizeof(float), 1, fp);
				boxorg.x = - 0.5f * boxaxis.m11;
				boxorg.y = - 0.5f * boxaxis.m22;
				boxorg.z = - 0.5f * boxaxis.m33;
			}
		}else{
			boxaxis.Clear();
			boxorg.Clear();
		}
		
		if(flag_J & FAD_FLAG_TEMPERATURE){
			fread64(&tempave,	sizeof(float), 1, fp);
			fread64(&tempvar,	sizeof(float), 1, fp);
		}else{
			tempave = tempvar = 0.0;
		}
		if(flag_J & FAD_FLAG_STEP){
			fread64(&istep,	sizeof(int), 1, fp);
		}else{
			istep = -1;
		}
		
		if(a==NULL){
			a = new ATOMS_DATA;
		}
		//a->no=mcnt;
		
		a->pcnt=pcnt;
		a->bcnt=bcnt;
		a->boxaxis=boxaxis;
		a->boxorg=boxorg;
		a->tempave = tempave;
		a->tempvar = tempvar;
		a->no = -1;
		a->istep = istep;

		a->knd = knd;
		//a->rx = rx;
		//a->ry = ry;
		//a->rz = rz;
		a->r = r;
		a->li = li;
		a->lj = lj;
		if(flag_J & FAD_FLAG_J){
			a->Jij = Jij;
		}else{
			a->Jij = NULL;
		}
		a->bond = bond;
		a->info = NULL;

		if(m_maxAtomCount < pcnt){ m_maxAtomCount = pcnt;}
		if(m_maxBondCount < bcnt){ m_maxBondCount = bcnt;}
		//long64 ll = ftell64(fp);
		//a->prev = a->next = NULL;
		//printf("model %d, particle %d, bond %d\n",mcnt,pcnt,bcnt);
		return a;
	}
	
	return NULL;

}



ATOMS_DATA* GLObj_MD::readFrameFAD(FILE64* fp, long64 filepos){
	//ǂݍݐFGLObj_MDԂ
	//sFNULLԂ
	//t@CI[œǂ߂ȂƂFNULLԂ

	ATOMS_DATA *a = new ATOMS_DATA;
	
	int i;//,j,dmyi;
	int pcnt,bcnt;
	float rr;
	vec3f r_ij;
	const float bondmax[] = {2.0f*2.0f, 1.8f*1.8f, 1.7f*1.7f};//{1.85*1.85, 1.55*1.55, 1.4*1.4};
	
		
	//float boxx, boxy, boxz;
	mat33f boxaxis;
	vec3f boxorg;
	float tempave, tempvar;
	int istep,no;
	int fortsize;	//binary data has header of array size in fortran
	float realtm;

	int* knd = NULL;
	//int* knd_sub = NULL;
	int* id = NULL;
	vec3f* r = NULL;
	vec3f* p = NULL;
	int* li = NULL;
	int* lj = NULL;
	float* Jij = NULL;
	char* bond = NULL;
	

	int flag_J;

	if(filepos != fp_pos){
		fseek64(fp, filepos, SEEK_SET);
	}


	if(fread64(&fortsize, sizeof(int), 1, fp) == 1){
		fread64(&pcnt, sizeof(int), 1, fp);
		fread64(&bcnt, sizeof(int), 1, fp);
		fread64(&flag_J, sizeof(int), 1, fp);
			fread64(&fortsize, sizeof(int), 1, fp);

		knd = new int[pcnt];
		float* rx = new float[pcnt];
		float* ry = new float[pcnt];
		float* rz = new float[pcnt];

		if(bcnt>0){
			li = new int[bcnt];
			lj = new int[bcnt];
			bond = new char[bcnt];
			if(flag_J & FAD_FLAG_J){Jij = new float[bcnt];}
		}
		
		
		
			fread64(&fortsize, sizeof(int), 1, fp);
		fread64(knd, sizeof(int)*pcnt, 1, fp);
			fread64(&fortsize, sizeof(int), 1, fp);
		
		
		
		if(flag_J & FAD_FLAG_ATOMEXT){
			id = new int[pcnt];
				fread64(&fortsize, sizeof(int), 1, fp);
			fread64(id,	sizeof(id)*pcnt, 1, fp);
				fread64(&fortsize, sizeof(int), 1, fp);
		}


			fread64(&fortsize, sizeof(int), 1, fp);
		fread64(rx,	sizeof(float)*pcnt, 1, fp);
			fread64(&fortsize, sizeof(int), 1, fp);
			fread64(&fortsize, sizeof(int), 1, fp);
		fread64(ry,	sizeof(float)*pcnt, 1, fp);
			fread64(&fortsize, sizeof(int), 1, fp);
			fread64(&fortsize, sizeof(int), 1, fp);
		fread64(rz,	sizeof(float)*pcnt, 1, fp);
			fread64(&fortsize, sizeof(int), 1, fp);
		
		r = new vec3f[pcnt];
		for (i = 0; i < pcnt; i++){
			r[i].x = rx[i];
			r[i].y = ry[i];
			r[i].z = rz[i];
		}
		delete [] rx; rx = NULL;
		delete [] ry; ry = NULL;
		delete [] rz; rz = NULL;

			
		if(flag_J & FAD_FLAG_ATOMEXT){
			float* px = new float[pcnt];
			float* py = new float[pcnt];
			float* pz = new float[pcnt];

				fread64(&fortsize, sizeof(int), 1, fp);
			fread64(px,	sizeof(float)*pcnt, 1, fp);
				fread64(&fortsize, sizeof(int), 1, fp);
				fread64(&fortsize, sizeof(int), 1, fp);
			fread64(py,	sizeof(float)*pcnt, 1, fp);
				fread64(&fortsize, sizeof(int), 1, fp);
				fread64(&fortsize, sizeof(int), 1, fp);
			fread64(pz,	sizeof(float)*pcnt, 1, fp);
				fread64(&fortsize, sizeof(int), 1, fp);
			
			p = new vec3f[pcnt];
			for (i = 0; i < pcnt; i++){
				p[i].x = px[i];
				p[i].y = py[i];
				p[i].z = pz[i];
			}
			delete [] px; px = NULL;
			delete [] py; py = NULL;
			delete [] pz; pz = NULL;

			
		}

		if(bcnt>0){
				fread64(&fortsize, sizeof(int), 1, fp);
			fread64(li,	sizeof(int)*bcnt, 1, fp);
				fread64(&fortsize, sizeof(int), 1, fp);
				fread64(&fortsize, sizeof(int), 1, fp);
			fread64(lj,	sizeof(int)*bcnt, 1, fp);
				fread64(&fortsize, sizeof(int), 1, fp);
				
			

			if(flag_J & FAD_FLAG_J){
					fread64(&fortsize, sizeof(int), 1, fp);
				fread64(Jij, sizeof(float)*bcnt, 1, fp);
					fread64(&fortsize, sizeof(int), 1, fp);

				for(i=0;i<bcnt;i++){
					if(Jij[i] < 0.0){
						int dmyi = li[i];
						li[i] = lj[i];
						lj[i] = dmyi;
						Jij[i] = - (Jij[i]);
					}
					if (Jmax < Jij[i]) {Jmax=Jij[i];}
				}
			}
				
		
			for(i=0;i<bcnt;i++){
				li[i]--;lj[i]--;
				r_ij = r[li[i]] - r[lj[i]];
				rr = r_ij * r_ij;
				if (rr <= bondmax[(knd[li[i]] & 0x01) + (knd[lj[i]] & 0x01)] ){
					bond[i] = 1;
				}else{
					bond[i] = 0;
				}
			}
		}

		if (flag_J & FAD_FLAG_SIMBOX) { //simbox̎w肪
			if (flag_J & FAD_FLAG_NONORTHOGONALBOX){//ɂsimboxw.
				
					fread64(&fortsize, sizeof(int), 1, fp);
				fread64(&boxaxis,	sizeof(float) * 9, 1, fp);
				fread64(&boxorg,	sizeof(float) * 3, 1, fp);
				//fread64(&boxz,	sizeof(float), 1, fp);
					fread64(&fortsize, sizeof(int), 1, fp);
			}else{
				boxaxis.Clear();
					fread64(&fortsize, sizeof(int), 1, fp);
				fread64(&(boxaxis.m11),	sizeof(float), 1, fp);
				fread64(&(boxaxis.m22),	sizeof(float), 1, fp);
				fread64(&(boxaxis.m33),	sizeof(float), 1, fp);
					fread64(&fortsize, sizeof(int), 1, fp);
				boxorg.x = - 0.5f * boxaxis.m11;
				boxorg.y = - 0.5f * boxaxis.m22;
				boxorg.z = - 0.5f * boxaxis.m33;
					
			}
		}else{
			boxaxis.Clear();
			boxorg.Clear();
		}
		
		if(flag_J & FAD_FLAG_TEMPERATURE){
				fread64(&fortsize, sizeof(int), 1, fp);
			fread64(&tempave,	sizeof(float), 1, fp);
			fread64(&tempvar,	sizeof(float), 1, fp);
				fread64(&fortsize, sizeof(int), 1, fp);
		}else{
			tempave = tempvar = 0.0;
		}
		if(flag_J & FAD_FLAG_STEP){
				fread64(&fortsize, sizeof(int), 1, fp);
				if (fortsize==8){
					fread64(&no,	sizeof(int), 1, fp);
					fread64(&istep,	sizeof(int), 1, fp);
					realtm = ((float)istep) * 5E-18f;
				}else{
					fread64(&no,	sizeof(int), 1, fp);
					fread64(&istep,	sizeof(int), 1, fp);
					fread64(&realtm,sizeof(float), 1, fp);
				}
				fread64(&fortsize, sizeof(int), 1, fp);
		}else{
			no = istep = -1;
		}
		
		if(a==NULL){
			a = new ATOMS_DATA;
		}
		//a->no=mcnt;
		
		a->pcnt=pcnt;
		a->bcnt=bcnt;
		a->boxaxis=boxaxis;
		a->boxorg = boxorg;
		a->tempave = tempave;
		a->tempvar = tempvar;
		a->no = no;
		a->istep = istep;
		a->realtm = realtm;
		
		a->knd = knd;
		a->id = id;
		//a->rx = rx;
		//a->ry = ry;
		//a->rz = rz;
		a->r = r;
		//a->px = px;
		//a->py = py;
		//a->pz = pz;
		a->p = p;
		a->li = li;
		a->lj = lj;
		if(flag_J & 0x1){
			a->Jij = Jij;
		}else{
			a->Jij = NULL;
		}
		a->bond = bond;
		a->info = NULL;

		if(m_maxAtomCount < pcnt){ m_maxAtomCount = pcnt;}
		if(m_maxBondCount < bcnt){ m_maxBondCount = bcnt;}
		//long64 ll = ftell64(fp);
		//a->prev = a->next = NULL;
		//printf("model %d, particle %d, bond %d\n",mcnt,pcnt,bcnt);
		return a;
	}
	
	return NULL;

}


long64 GLObj_MD::skipFrameFAD(FILE64* fp, long64 filepos){
	//ǂݍݐF݂̃t@C|C^Ԃ
	//sFLONG64_ZEROԂ
	//t@CI[œǂ߂ȂƂFLONG64_ZEROԂ

	int skipsz = 0;
	int pcnt,bcnt;
	
		
	int fortsize;	//binary data has header of array size in fortran

	int flag_J;

	if(filepos != fp_pos){
		fseek64(fp, filepos, SEEK_SET);
	}


	if(fread64(&fortsize, sizeof(int), 1, fp) == 1){
		fread64(&pcnt, sizeof(int), 1, fp);
		fread64(&bcnt, sizeof(int), 1, fp);
		fread64(&flag_J, sizeof(int), 1, fp);
			fread64(&fortsize, sizeof(int), 1, fp);
		
		skipsz = sizeof(int) * 5;	//wb_[
		skipsz += sizeof(int) * 2 + sizeof(int)*pcnt;	//knd
		
		if(flag_J & FAD_FLAG_ATOMEXT){
			skipsz += sizeof(int) * 2 + sizeof(int)*pcnt;	//id
		}

		
		skipsz += (sizeof(int) * 2 + sizeof(float)*pcnt ) * 3;	//rx,ry,rz

		if(flag_J & FAD_FLAG_ATOMEXT){
			skipsz += (sizeof(int) * 2 + sizeof(float)*pcnt ) * 3;	//px,py,pz
		}

		if(bcnt>0){
			skipsz += (sizeof(int) * 2 + sizeof(int)*bcnt ) * 2;	//li,lj
			
			if(flag_J & FAD_FLAG_J){
				skipsz += sizeof(int) * 2 + sizeof(float)*bcnt;		//Jij
			}
		}

		if(flag_J & FAD_FLAG_SIMBOX){
			if (flag_J & FAD_FLAG_NONORTHOGONALBOX){//ɂsimboxw.
				skipsz += sizeof(int) * 2 + sizeof(mat33f) + sizeof(vec3f);	//boxaxis,boxorg
			}else{
				skipsz += sizeof(int) * 2 + sizeof(float) * 3;	//boxx,boxy,boxz
			}
		}
		
		if(flag_J & FAD_FLAG_TEMPERATURE){
			skipsz += sizeof(int) * 2 + sizeof(float) * 2;	//tempave,tempvar
		}
		
		if(flag_J & FAD_FLAG_STEP){
			skipsz += sizeof(int) * 2 + sizeof(float) * 3;	//no,istep,realtm
		}

		fseek64(fp, filepos + skipsz, SEEK_SET);
		return filepos + skipsz;
	}
	
	return LONG64_ZERO;
}



int GLObj_MD::readTXT(FILE *fp, int mode){

//	FILEPOS_LIST* fa;
//	FILEPOS_LIST* fb;
	ATOMS_DATA *a;
	ATOMS_DATA *readBuf= new ATOMS_DATA;

	int mcnt;
		
//	fb = NULL;
	mcnt = 0;
	Jmax = -1.0;

	readMode = 0;

	
	readBuf->pcnt = TXT_INITIAL_ATOM;
	readBuf->bcnt = TXT_INITIAL_BOND;



	readBuf->knd = new int[TXT_INITIAL_ATOM];
	//readBuf->rx = new float[TXT_INITIAL_ATOM];
	//readBuf->ry = new float[TXT_INITIAL_ATOM];
	//readBuf->rz = new float[TXT_INITIAL_ATOM];
	readBuf->r = new vec3f[TXT_INITIAL_ATOM];
	readBuf->li = new int[TXT_INITIAL_BOND];
	readBuf->lj = new int[TXT_INITIAL_BOND];
	readBuf->Jij = new float[TXT_INITIAL_BOND];
	readBuf->bond = new char[TXT_INITIAL_BOND];

	memset(&(readBuf->boxaxis), 0, sizeof(mat33f));
	memset(&(readBuf->boxorg), 0, sizeof(vec3f));
	readBuf->tempave = readBuf->tempvar = -1.0;
	readBuf->no = 1;
	readBuf->info = NULL;
	
	switch(mode){
	case 3:
		a = readFramePDB(fp,readBuf);
		break;
	case 4:
		a = readFrameXYZ(fp,readBuf);
		break;
	default:
		return 0;
	}

	while(a){
		
/*
		fa = new FILEPOS_LIST;
		fa->prev = fb;
		if (fb) {fb->next = fa;}
		else{m_fpos_first=fa;}

		fa->atmdat = a;		
		//fa->pos = fp_pos;
		fa->pos = 0;
		if(fa->atmdat->no == -1){ fa->atmdat->no = mcnt;}


		fb=fa;
*/

		if(a->no == -1){ a->no = mcnt;}
		FRAME_POS frame;
		frame.filepos = fp_pos;
		frame.atmdat = a;
		frame.keep = 0;
		m_frame_buf->Add(frame);

		//pos = jumplen + sizeof(int) * 3;
		//fp_pos = ftell64(fp);

		//printf("model %d, particle %d, bond %d\n",mcnt,pcnt,bcnt);


//		if(mcnt % 1000 == 0 ){	printf("read now %d", mcnt);}
		mcnt ++;
		readBuf->no++;
//		if(fp_pos > READLIMIT){
//			//obt@[t
//			//rf̈
//			unknown_pos = fp_pos;
//			readMode = mode;			
//			break;
//		}

		switch(mode){
		case 3:
			a = readFramePDB(fp,readBuf);
			break;
		case 4:
			a = readFrameXYZ(fp,readBuf);
			break;
		}

	}

	if (m_unknown_pos) {
		//rf
		printf("buffer fulls halfway\n");
	}

	
//	stockCnt = mcnt;
//	stock = new FILEPOS_LIST*[stockCnt];
//	stockIdx = 0;
		
	printf("%d frame loaded\n",mcnt);
	
	return mcnt;
	
}



void renew(char** p, int num, int newnum){
	char* vp = new char[newnum];
	if (num <= newnum){
		memcpy(vp, *p, sizeof(char) * num);
	}else{
		memcpy(vp, *p, sizeof(char) * newnum);
	}

	delete [] (*p);
	(*p) = vp;
}


void renew(int** p, int num, int newnum){
	int* vp = new int[newnum];
	if (num <= newnum){
		memcpy(vp, *p, sizeof(int) * num);
	}else{
		memcpy(vp, *p, sizeof(int) * newnum);
	}

	delete [] (*p);
	(*p) = vp;
}


void renew(float** p, int num, int newnum){
	float* vp = new float[newnum];
	if (num <= newnum){
		memcpy(vp, *p, sizeof(float) * num);
	}else{
		memcpy(vp, *p, sizeof(float) * newnum);
	}

	delete [] (*p);
	(*p) = vp;
}

ATOMS_DATA* GLObj_MD::readFramePDB(FILE* fp, ATOMS_DATA* readBuf){
	
	char chbuf[256];
	char kndch[256];
	char line[256];

	int dmyi;
	int pcnt,bcnt;
	float rr,Jmax;
	vec3f dr;
	const float bondmax[] = {2.0f*2.0f, 1.8f*1.8f, 1.7f*1.7f};//{1.85*1.85, 1.55*1.55, 1.4*1.4};
	
	int istep;
	short int* pkindint; 

	
	int* knd = readBuf->knd;
	//float* rx = readBuf->rx;
	//float* ry = readBuf->ry;
	//float* rz = readBuf->rz;
	vec3f* r = readBuf->r;
	int* li = readBuf->li;
	int* lj = readBuf->lj;
	float* Jij = readBuf->Jij;
	char* bond = readBuf->bond;


	int flag_J;	//0: energy currentL, 1: 
	
	ATOMS_DATA *a;



	Jmax = -1.0;
	if(fgets(line,255,fp) == NULL){ return NULL;}
	if (strncmp(line,"MODEL",5) != 0){ return NULL;}

		sscanf(line,"%s %d",chbuf, &istep);
			flag_J = 0x8;

		pcnt = 0;
		bcnt=0;
		

		while (fgets(line,255,fp) != NULL){
			if(strncmp(line,"ENDMDL",6) == 0){break;}
			if(strncmp(line,"ATOM",4) == 0){
				sscanf(line,"%s%s%s%s %f %f %f",chbuf,chbuf,kndch,chbuf,
					&(r[pcnt].x), &(r[pcnt].y), &(r[pcnt].z));

				pkindint = (short int*)kndch;
				if (strcmp(kndch,"Cc") == 0){	//C_custom
					knd[pcnt] = 0;
				//}else if (strcmp(kndch,"H")==0){
				}else if (*pkindint == 72){
					knd[pcnt] = 1;
				}else if (strcmp(kndch,"He")==0){
					knd[pcnt] = 2;
				}else if (strcmp(kndch,"Li")==0){
					knd[pcnt] = 3;
				}else if (strcmp(kndch,"Be")==0){
					knd[pcnt] = 4;
				}else if (strcmp(kndch,"B")==0){
					knd[pcnt] = 5;
				}else if (strcmp(kndch,"C")==0){
					knd[pcnt] = 6;
				}else if (strcmp(kndch,"N")==0){
					knd[pcnt] = 7;
				}else if (strcmp(kndch,"O")==0){
					knd[pcnt] = 8;
				}else if (strcmp(kndch,"F")==0){
					knd[pcnt] = 9;
				}else if (strcmp(kndch,"N")==0){
					knd[pcnt] = 10;
				}else if (strcmp(kndch,"Na")==0){
					knd[pcnt] = 11;
				}else if (strcmp(kndch,"Mg")==0){
					knd[pcnt] = 12;
				}else if (strcmp(kndch,"Al")==0){
					knd[pcnt] = 13;
				}else if (strcmp(kndch,"Si")==0){
					knd[pcnt] = 14;
				}else if (strcmp(kndch,"P")==0){
					knd[pcnt] = 15;
				}else if (strcmp(kndch,"S")==0){
					knd[pcnt] = 16;
				}else if (strcmp(kndch,"Cl")==0){
					knd[pcnt] = 17;
				}else if (strcmp(kndch,"Ar")==0){
					knd[pcnt] = 18;
				}else if (strcmp(kndch,"K")==0){
					knd[pcnt] = 19;
				}else if (strcmp(kndch,"Ca")==0){
					knd[pcnt] = 20;
				}else{
					knd[pcnt] = 21;
				}

				pcnt ++ ;
				//obt@I[o[t[
				if (pcnt == readBuf->pcnt){
					
					readBuf->pcnt *= 4;
					
					renew(&knd, pcnt, readBuf->pcnt);
					renew((float**)&r, pcnt*3, readBuf->pcnt*3);
					
					readBuf->knd = knd;
					readBuf->r = r;
				}

			}else if(strncmp(line,"CONECT",6) == 0){
				sscanf(line,"%s %d %d %f",chbuf,li + bcnt, lj + bcnt, Jij + bcnt);
				
				li[bcnt]--; lj[bcnt]--;
				if(Jij[bcnt] < 0.0){
					dmyi = li[bcnt];
					li[bcnt] = lj[bcnt];
					lj[bcnt] = dmyi;
					Jij[bcnt] = -Jij[bcnt];
				}
				if (Jmax < Jij[bcnt]) {Jmax=Jij[bcnt];}
					
				dr = r[li[bcnt]] - r[lj[bcnt]];
				rr = dr * dr;
				if (rr <= bondmax[(knd[li[bcnt]] & 0x01) + (knd[lj[bcnt]] & 0x01)] ){
					bond[bcnt] = 1;
				}else{
					bond[bcnt] = 0;
				}
				bcnt++;
				//obt@I[o[t[
				if (bcnt == readBuf->bcnt){
					
					readBuf->bcnt *= 4;
					
					renew(&li, bcnt, readBuf->bcnt);
					renew(&lj, bcnt, readBuf->bcnt);
					renew(&Jij, bcnt, readBuf->bcnt);
					renew(&bond, bcnt, readBuf->bcnt);

					readBuf->li = li;
					readBuf->lj = lj;
					readBuf->Jij = Jij;
					readBuf->bond = bond;


				}
				flag_J |= 0x1;
				
/*
			}else if(strncmp(line,"BOX",3) == 0){
				sscanf(line,"%s %f %f %f",chbuf,&(readBuf->boxaxis.x),&(readBuf->boxy),&(readBuf->boxz));
				flag_J |= 0x2;
			}else if(strncmp(line,"TEMP",4) == 0){
				sscanf(line,"%s %f %f",chbuf,&(readBuf->tempave),&(readBuf->tempvar));
				flag_J |= 0x4;
				*/
			}
			
		}
		


		//AI_atomdatɃRs[
		a = new ATOMS_DATA;
		
		a->pcnt=pcnt;
		a->bcnt=bcnt;
		//a->boxaxis=readBuf->boxaxis.Clear();
		//a->boxorg=readBuf->boxorg.Clear();
		a->tempave = readBuf->tempave;
		a->tempvar = readBuf->tempvar;
		a->no = readBuf->no;
		a->istep = istep;
		a->realtm = 0.0;
		
		a->knd = new int[pcnt];
		memcpy(a->knd, knd, sizeof(char) * pcnt);
		a->r = new vec3f[pcnt];
		memcpy(a->r, r, sizeof(vec3f) * pcnt);
		a->li = new int[bcnt];
		memcpy(a->li, li, sizeof(int) * bcnt);
		a->lj = new int[bcnt];
		memcpy(a->lj, lj, sizeof(int) * bcnt);
		if(flag_J & 0x1){
			a->Jij = new float[bcnt];
			memcpy(a->Jij, Jij, sizeof(float) * bcnt);
		}else{
			a->Jij = NULL;
		}
		a->bond = new char[bcnt];
		memcpy(a->bond, bond, sizeof(char) * bcnt);
		a->info = NULL;

		if(m_maxAtomCount < pcnt){ m_maxAtomCount = pcnt;}
		if(m_maxBondCount < bcnt){ m_maxBondCount = bcnt;}

	return a;


}



ATOMS_DATA* GLObj_MD::readFrameXYZ(FILE* fp, ATOMS_DATA* readBuf){
	
	char kndch[256];
	char line[256];

	int pcnt,bcnt;
	float Jmax;
	const float BOND_LENGTH_SQUARE = 2.0f*2.0f;
	

	
	int* knd = NULL;
	vec3f* r = NULL;
	int* li = readBuf->li;
	int* lj = readBuf->lj;
	float* Jij = readBuf->Jij;
	char* bond = readBuf->bond;
	short int* pkindint; 

	
	ATOMS_DATA *a;



	Jmax = -1.0;
	if(fgets(line,255,fp) == NULL){ return NULL;}
		sscanf(line,"%d", &pcnt);
		if(pcnt<=0){return NULL;}
		bcnt=0;

		
		if(fgets(line,255,fp) == NULL){ return NULL;}
		//epictureƂtitle̓ǂݎ

		a = new ATOMS_DATA;
		a->knd = knd = new int[pcnt];
		a->r = r = new vec3f[pcnt];
		a->pcnt = pcnt;
		pcnt = 0;
		
		a->info = _strdup(line);

		while (fgets(line,255,fp) != NULL){
			sscanf(line,"%s %f %f %f",kndch, &(r[pcnt].x), &(r[pcnt].y), &(r[pcnt].z));
			
			pkindint = (short int*)kndch;
			switch (*pkindint){
			case 0x6343:
			case 0x4343:
				knd[pcnt] = 0;
				break;
			case 'H':
			case 'h':
				knd[pcnt] = 1;
				break;
			case 0x6548:
			case 0x6568:
				knd[pcnt] = 2;
				break;
			case 0x694C:
			case 0x696C:
				knd[pcnt] = 3;
				break;
			case 0x6542:
			case 0x6562:
				knd[pcnt] = 4;
				break;
			case 'B':
			case 'b':
				knd[pcnt] = 5;
				break;
			case 'C':
			case 'c':
				knd[pcnt] = 6;
				break;
			case 'N':
			case 'n':
				knd[pcnt] = 7;
				break;
			case 'O':
			case 'o':
				knd[pcnt] = 8;
				break;
			case 'F':
			case 'f':
				knd[pcnt] = 9;
				break;
			case 0x654E:
			case 0x656E:
				knd[pcnt] = 10;
				break;
			case 0x614E:
			case 0x616E:
				knd[pcnt] = 11;
				break;
			case 0x674D:
			case 0x676D:
				knd[pcnt] = 12;
				break;
			case 0x6c41:
			case 0x6c61:
				knd[pcnt] = 13;
				break;
			case 0x6953:
			case 0x6973:
				knd[pcnt] = 14;
				break;
			case 'P':
			case 'p':
				knd[pcnt] = 15;
				break;
			case 'S':
			case 's':
				knd[pcnt] = 16;
				break;
			case 0x6C43:
			case 0x6C63:
				knd[pcnt] = 17;
				break;
			case 0x7241:
			case 0x7261:
				knd[pcnt] = 18;
				break;
			case 'k':
			case 'K':
				knd[pcnt] = 19;
				break;
			case 0x6145:
			case 0x6165:
				knd[pcnt] = 17;
				break;
			default:
				knd[pcnt] = 21;
			}
		
				pcnt ++ ;
				//obt@I[o[t[
				if (pcnt == a->pcnt){break;}
		}


		//AI_atomdatɃRs[		
		a->bcnt=bcnt;
//		a->boxaxis=readBuf->boxaxis.Clear();
//		a->boxorg=readBuf->boxorg.Clear();
		a->tempave = readBuf->tempave;
		a->tempvar = readBuf->tempvar;
		a->no = readBuf->no;
		a->istep = 0;
		a->realtm = 0.0;
		
		a->li = new int[bcnt];
		memcpy(a->li, li, sizeof(int) * bcnt);
		a->lj = new int[bcnt];
		memcpy(a->lj, lj, sizeof(int) * bcnt);
		a->Jij = NULL;
		a->bond = new char[bcnt];
		memcpy(a->bond, bond, sizeof(char) * bcnt);

		if(m_maxAtomCount < pcnt){ m_maxAtomCount = pcnt;}
		if(m_maxBondCount < bcnt){ m_maxBondCount = bcnt;}

	return a;


}


void GLObj_MD::clearBuffer(){
	
	for( int i = 0; i < m_frame_buf->count; i++){
		if (m_frame_buf->buffer[i].atmdat){
			DeleteFrame(m_frame_buf->buffer[i].atmdat);
			m_frame_buf->buffer[i].atmdat = NULL;
		}
	}
	delete m_frame_buf;
}


int GLObj_MD::goNext(){
	//1Ԃ
	ATOMS_DATA* dat;
//	FILEPOS_LIST* fa;
	
	if (readMode == -1){ return 0;}

	

	if(m_frameNo + 1 < m_frame_buf->count ){
		//݂Aǂݍݍς݂ł
		m_frameNo++;
		return 1;
	}
	
	if(m_unknown_pos == LONG64_ZERO){
		//t@CI[
		return 0;
	}

	if(readMode > 0){	//ꉞ. ̈s͏ȂĂOK

		switch (readMode){
		case 1:
			dat = readFrameDAT(fp, m_unknown_pos);
			break;
		case 2:
			dat = readFrameFAD(fp, m_unknown_pos);
			break;
		}
		fp_pos = ftell64(fp);
		
		if (dat == NULL){
			//t@C̏I[
			m_unknown_pos = LONG64_ZERO;
			return 0;
		}
		
		//ȉ, ǂݍݐ
				
		FRAME_POS frame;
		frame.atmdat = dat;		
		frame.filepos = m_unknown_pos;
		m_unknown_pos = fp_pos;
		frame.keep = 0;
		m_frame_buf->Add(frame);
		
		//buffer̈ڍs
		UnloadStock();

		m_frameNo++;
		return 1;
	}
	return 0;
	
}


int GLObj_MD::goNext(int num){
	int i;
	int res;
	ATOMS_DATA* dat;

	//printf("pointers %x, %x\n",(stockFPL[stockIdx]->atm)->istep, (stockFPL[stockIdx]->atm)->li);

	if(num<=0){return -1;}
	if (readMode == -1){ return 0;}

	for(i=0;i<num - 1;i++){
		
		if(m_frameNo + 1 < m_frame_buf->count ){
			//݂
			m_frameNo++;
			
		}else{

			switch (readMode){
			case 1:
				dat = readFrameDAT(fp, m_unknown_pos);
				if( ! dat){
					m_unknown_pos = LONG64_ZERO;
					return 0;
				}
				break;
			case 2:
				fp_pos = skipFrameFAD(fp, m_unknown_pos);
				if ( fp_pos == LONG64_ZERO) {
					return 0;
				}
				dat = NULL;
				break;
			}
				
			FRAME_POS frame;
			frame.atmdat = dat;		
			frame.filepos = m_unknown_pos;
			m_unknown_pos = fp_pos;
			frame.keep = 0;
			m_frame_buf->Add(frame);
					
			m_frameNo++;
		}
	}
	
	res = goNext();

	return res;
}

int GLObj_MD::goPrev(){
	if (readMode == -1){ return 0;}

	if(m_frameNo > 0){
		m_frameNo--;
		return 1;
	}
	return 0;
}


int GLObj_MD::goPrev(int num){

	if(num<=0){return -1;}
	if (readMode == -1){ return 0;}

	if(m_frameNo == 0){return 0;}
	m_frameNo-=num;
	if(m_frameNo < 0){
		m_frameNo = 0;
	}
	return 1;
}

void GLObj_MD::goFirst(){
	if (readMode == -1){ return;}
	
	m_frameNo = 0;
	
}

ATOMS_DATA* GLObj_MD::GetDataPointer(){
	if (readMode == -1){ return NULL;}

	if(m_frame_buf->buffer[m_frameNo].atmdat == NULL){
		if(readMode>0){
			switch (readMode){
			case 1:
				m_frame_buf->buffer[m_frameNo].atmdat = readFrameDAT(fp, m_frame_buf->buffer[m_frameNo].filepos);
				break;
			case 2:
				m_frame_buf->buffer[m_frameNo].atmdat = readFrameFAD(fp, m_frame_buf->buffer[m_frameNo].filepos);
				break;
			}
			fp_pos = ftell64(fp);
				

			if(m_frame_buf->buffer[m_frameNo].atmdat){
				//ǂ߂Ƃ({IɕKǂ߂邱ƂۏႳĂ͂)
				UnloadStock();
			}
		}
	}
	return m_frame_buf->buffer[m_frameNo].atmdat;
	
}

void GLObj_MD::KeepCurrentFrame(){
	m_frame_buf->buffer[m_frameNo].keep = 1;

}


void GLObj_MD::openWriteFile(const TCHAR* filename){
	if(m_wfp){ return;}
	m_wfp = _tfopen(filename, _T("w"));
}

void GLObj_MD::writeFrameXYZ(){
	
	ATOMS_DATA* dat = m_frame_buf->buffer[m_frameNo].atmdat;
	int i;
		
	int* knd = dat->knd;
	vec3f* r = dat->r;
	
	fprintf(m_wfp, "%d\n", dat->pcnt);
	fprintf(m_wfp, "TimeStep %d\n", dat->istep);
	
	for(i = 0; i < dat->pcnt; i++){

		switch (knd[i]){
		case 0:
			fprintf(m_wfp, "C\t");
			break;
		case 1:
			fprintf(m_wfp, "H\t");
			break;
		default:
			fprintf(m_wfp, "X\t");
		
		}	

		fprintf(m_wfp, "%12.6f\t%12.6f\t%12.6f\n", r[i].x, r[i].y, r[i].z);
		
	}

}

void GLObj_MD::closeWriteFile(){
	if(m_wfp == NULL){ return;}
	fclose(m_wfp);
	m_wfp = NULL;
}


int GLObj_MD::GetFrameNum(){
	return m_frameNo;
}


void GLObj_MD::DeleteFrame(ATOMS_DATA *dat){
	
	if (dat){
		/*
		if (dat->knd){delete [] dat->knd;}
		if (dat->id){delete [] dat->id;}
		if (dat->r){delete [] dat->r;}
		if (dat->p){delete [] dat->p;}
		if (dat->li){delete [] dat->li;}
		if (dat->lj){delete [] dat->lj;}
		if (dat->Jij){delete [] dat->Jij;}
		if (dat->bond){delete [] dat->bond;}
		if (dat->info){delete [] dat->info;}
		*/
		delete dat;
	}
}


void GLObj_MD::UnloadStock(){
	for (int i = 0; i < m_frame_buf->count; i++){
		if( i != m_frameNo){
			if(m_frame_buf->buffer[i].atmdat){
				if(m_frame_buf->buffer[i].keep == 0){
					DeleteFrame(m_frame_buf->buffer[i].atmdat);
					m_frame_buf->buffer[i].atmdat = NULL;
					break;
				}
				
			}
		}
	}
}



/////////////////////////////////////////////////////////////////
//
//Rendering by OpenGL
//
/////////////////////////////////////////////////////////////////

//VBO̐ݒ
void GLObj_MD::Rendering(){	//int j_mode, float Jmax
	

	ATOMS_DATA* dat = GetDataPointer();
	if (dat == NULL) return;
	
	//vbõZbg
	if(dat != m_prev_render_dat){
		CreateSphereArray();
		m_prev_render_dat = dat;
	}
	
	glDisable(GL_BLEND);

			
		glColor4f( 1.0f, 1.0f, 1.0f, 1.0f );
	glDisable(GL_CULL_FACE);
	
	glEnableClientState(GL_VERTEX_ARRAY);
	glEnableClientState(GL_NORMAL_ARRAY);
	glEnableClientState(GL_COLOR_ARRAY);
	glEnable(GL_COLOR_MATERIAL);//_J[𔽉f
	glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
	
				//glBindBuffer(GL_ARRAY_BUFFER, 0);
				//glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);

	glVertexPointer(3, GL_FLOAT, 0, (float*)m_vbo_positions);
	glNormalPointer(GL_FLOAT, 0, (float*)m_vbo_normals);
	glColorPointer(4, GL_UNSIGNED_BYTE, 0, (BYTE*)m_vbo_colors);	//l͕K4ł
	
	glDrawElements(GL_TRIANGLES, m_vbo_icount, GL_UNSIGNED_INT, (GLuint*)m_vbo_indexes);

	glFlush();
	glDisableClientState(GL_VERTEX_ARRAY);
	glDisableClientState(GL_NORMAL_ARRAY);
	glDisableClientState(GL_COLOR_ARRAY);
	glDisable(GL_COLOR_MATERIAL);//_J[𔽉f
	glEnable(GL_CULL_FACE);


}


void GLObj_MD::CreateSphereArray(){

	ATOMS_DATA* dat = GetDataPointer();
	if (m_maxBondCount < dat->bcnt) {m_maxBondCount = dat->bcnt;}

	//vboTCY
	int vbo_v_sz = m_maxAtomCount * m_sphere_vcnt + m_maxBondCount * m_bond_vcnt;
	int vbo_i_sz = m_maxAtomCount * m_sphere_icnt + m_maxBondCount * m_bond_icnt;

	delete [] m_vbo_positions;
	m_vbo_positions = new vec3f[vbo_v_sz];
	delete [] m_vbo_normals;
	m_vbo_normals = new vec3f[vbo_v_sz];
	delete [] m_vbo_colors;
	m_vbo_colors = new BYTE[vbo_v_sz*4];
	delete [] m_vbo_indexes;
	m_vbo_indexes = new int[vbo_i_sz];

	m_vbo_vcount = 0;
	m_vbo_icount = 0;
	int i;

	
	//J[e[u
	if(m_mode_color == MODE_COLOR_BONDNUM){
		CheckColorByBondNum();
	}else{	//MODE_COLOR_ATOMIC
		CheckColorByAtomKind();
	}
	


	//q()̃Zbg
	if( m_mode_atom != MODE_ATOM_NONE){
		vec3f origin;
		for(i=0;i<dat->pcnt;i++){

			origin = dat->r[i];
			//origin.Set(0.f,0.f,0.f);
			SetSphere(origin, m_color_table[i],
						m_vbo_vcount,	//_ԍoffset
						m_vbo_positions + m_vbo_vcount,
						m_vbo_normals + m_vbo_vcount,
						m_vbo_colors + m_vbo_vcount * 4,
						m_vbo_indexes + m_vbo_icount);

			m_vbo_vcount += m_sphere_vcnt;
			m_vbo_icount += m_sphere_icnt;
			
		}
	}

	//{h̃Zbg
	if( m_mode_bond != MODE_BOND_NONE){
		
		int li, lj;
		for(i=0;i<dat->bcnt;i++){
			if(dat->bond[i]){
				li = dat->li[i];
				lj = dat->lj[i];

				
				SetBond(dat->r[li], dat->r[lj], 
						m_color_table[li],
						m_color_table[lj],
						m_vbo_vcount,
						m_vbo_positions + m_vbo_vcount,
						m_vbo_normals + m_vbo_vcount,
						m_vbo_colors + m_vbo_vcount*4,
						m_vbo_indexes + m_vbo_icount);
				
				m_vbo_vcount += m_bond_vcnt;
				m_vbo_icount += m_bond_icnt;
			}
		}
	}	
	
}

///////////////////////////////////////////////
//
//VBOɃ|SZbg@\
//
////////////////////////////////////////////////
	
void GLObj_MD::InitSphere(float radius, int slices, int stacks){
	int i, k;
	double daXY = 2.0*PI/double(stacks);
	double daZX = PI/double(slices);
	double angleZX;
	double angleXY;
	float cosZX, sinZX;
	float *cosXY, *sinXY;
	

	
	cosXY = new float[stacks];
	sinXY = new float[stacks];
	
	angleXY = daXY;
	cosXY[0] = 1.f;
	sinXY[0] = 0.f;
	for (i = 1; i < stacks; i++){
		cosXY[i] = (float)cos(angleXY);
		sinXY[i] = (float)sin(angleXY);
		angleXY += daXY;
	}

	m_sphere_vcnt = (slices - 1) * stacks + 2;
	delete [] m_sphere_pos;
	delete [] m_sphere_nor;
	vec3f *pos = m_sphere_pos = new vec3f[m_sphere_vcnt];
	vec3f *nor = m_sphere_nor = new vec3f[m_sphere_vcnt];


	nor->Set(0.0f, 0.0f, 1.0f);
	nor++;
	pos->Set(0.0f,0.0f,(float)radius);
	pos++;

	angleZX = daZX;
	for (i = 1; i < slices; i++){
		cosZX = (float)cos(angleZX);
		sinZX = (float)sin(angleZX);

		for (k = 0; k < stacks; k++){
			
			nor->Set(sinZX * cosXY[k], sinZX * sinXY[k], cosZX);
			pos->x = nor->x * radius;
			pos->y = nor->y * radius;
			pos->z = nor->z * radius;

			nor++;
			pos++;
		}
		angleZX += daZX;
	}
	
	nor->Set(0.0f, 0.0f, -1.0f);
	pos->Set(0.0f,0.0f, -radius);
	
	delete [] cosXY;
	delete [] sinXY;


	//CfbNXz̃Zbg
	m_sphere_icnt = (slices - 1)*stacks*6;
	delete [] m_sphere_idx;
	int* idx = m_sphere_idx = new int[m_sphere_icnt];
	int offset = 1;
	for(i=0; i < stacks; i++){
		*idx = 0;
		idx++;
		*idx = i + offset;
		idx++;
		*idx = ((i + 1) % stacks) + offset;
		idx++;
	}
	//offset += stacks;
	
	
	for (k = 0; k < slices - 2; k++){
		for(i=0; i < stacks; i++){
			*idx = i + offset;
			idx++;
			*(idx + 3) = *idx = i + offset + stacks;
			idx++;
			*(idx + 1) = *idx = ((i + 1) % stacks) + offset;
			idx+=3;
			*idx = ((i + 1) % stacks) + offset + stacks;
			idx++;
		}
		offset += stacks;
	}

	for(i=0; i < stacks; i++){
		*idx = i + offset;
		idx++;
		*idx = m_sphere_vcnt - 1;
		idx++;
		*idx = ((i + 1) % stacks) + offset;
		idx++;
	}
	
};

void GLObj_MD::SetSphere(vec3f& orgin, unsigned int onecolor, int index_offset, vec3f* positions, vec3f* normals, BYTE* colors, int* indexes){
	int i;
	unsigned int *cols = (unsigned int*)colors;
	
	for( i = 0; i < m_sphere_vcnt; i++){
		positions[i] = m_sphere_pos[i] + orgin;
		*cols = onecolor;
		cols++;		
	}
	
	memcpy(normals, m_sphere_nor, m_sphere_vcnt * sizeof(vec3f));
	
	for( i = 0; i < m_sphere_icnt; i++){
		indexes[i] = m_sphere_idx[i] + index_offset;
	}	

}



void GLObj_MD::InitBond(float radius, int stacks){
	int i, k;
	double daXY = 2.0*PI/double(stacks);
	double angleXY;
	float *cosXY, *sinXY;
	

	
	cosXY = new float[stacks];
	sinXY = new float[stacks];
	
	angleXY = daXY;
	cosXY[0] = 1.f;
	sinXY[0] = 0.f;
	for (i = 1; i < stacks; i++){
		cosXY[i] = (float)cos(angleXY);
		sinXY[i] = (float)sin(angleXY);
		angleXY += daXY;
	}

	m_bond_vcnt = stacks * 2;
	vec3f *pos = m_bond_pos = new vec3f[m_bond_vcnt];
	vec3f *nor = m_bond_nor = new vec3f[m_bond_vcnt];


	for (k = 0; k < stacks; k++){
			
		nor->Set(cosXY[k], sinXY[k], 0.f);
		pos->x = nor->x * radius;
		pos->y = nor->y * radius;
		pos->z = nor->z * radius;
		
		nor++;
		pos++;
		
	}

	memcpy(nor, m_bond_nor, sizeof(vec3f)*stacks);
	memcpy(pos, m_bond_pos, sizeof(vec3f)*stacks);

	for (k = 0; k < stacks; k++){
		pos->z += 1.f;
		pos++;
	}

	delete [] cosXY;
	delete [] sinXY;


	//CfbNXz̃Zbg
	m_bond_icnt = stacks * 6;
	int* idx = m_bond_idx = new int[m_bond_icnt];
	
	for(i=0; i < stacks; i++){
		*idx = i;
		idx++;
		*(idx + 3) = *idx = ((i + 1) % stacks);
		idx++;
		*(idx + 1) = *idx = i + stacks;
		idx+=3;
		*idx = ((i + 1) % stacks) + stacks;
		idx++;	
	}		
	
	
	
};


void GLObj_MD::InitCone(float radius, int stacks){
	int k;

	InitBond(radius, stacks);
	vec3f *pos = m_bond_pos;
	for (k = 0; k < stacks; k++){
			
		pos->x *= 3.f;
		pos->y *= 3.f;
		pos->z = ATOM_RADIUS;
		pos++;
		
	}

	for (k = 0; k < stacks; k++){
		pos->x = 0.f;
		pos->y = 0.f;
		pos->z -= ATOM_RADIUS;
		pos++;
	}

};

void GLObj_MD::SetBond(vec3f& v1, vec3f& v2, unsigned int onecolor, unsigned int othercolor, int index_offset, vec3f* positions, vec3f* normals, BYTE* colors, int* indexes){
	int i;
	//int m[16];

	unsigned int *cols = (unsigned int*)colors;
	

	vec3f axis = v2 - v1;
	double dlength = (double)(axis.x * axis.x + axis.y * axis.y);
	float sxy = (float)sqrt(dlength);
	float flength = (float)sqrt((dlength + (double)(axis.z * axis.z)));
	//flength = 

	//	memcpy(positions, m_bond_pos, m_bond_vcnt * sizeof(vec3f));
	//memcpy(normals, m_bond_nor, m_bond_vcnt * sizeof(vec3f));

	sxy /= flength;
	if (sxy < 0.00001f){	//ւ̗O
		if(axis.z < -0.f){
			for( i = 0; i < m_bond_vcnt; i++){
				positions[i].x = -m_bond_pos[i].x  + v1.x;
				positions[i].y = m_bond_pos[i].y  + v1.y;
				positions[i].z = -m_bond_pos[i].z * flength + v1.z;
				normals[i].x = -m_bond_nor[i].x;
				normals[i].y = m_bond_nor[i].y;
				normals[i].z = -m_bond_nor[i].z;
			}
		}else{
			//memcpy(positions, m_bond_pos, m_bond_vcnt * sizeof(vec3f));
			memcpy(normals, m_bond_nor, m_bond_vcnt * sizeof(vec3f));
			for( i = 0; i < m_bond_vcnt; i++){
				positions[i].x = m_bond_pos[i].x  + v1.x;
				positions[i].y = m_bond_pos[i].y  + v1.y;
				positions[i].z = m_bond_pos[i].z * flength + v1.z;
				
			}
		}
	}else{
		vec3f m1, m2, m3;
		//axis *= 1.f/flength;
		float xdsxy = axis.x / (sxy * flength); 
		float ydsxy = axis.y / (sxy * flength);
		m1.Set(axis.z / flength * xdsxy, -ydsxy, axis.x);
		m2.Set(axis.z / flength * ydsxy, xdsxy, axis.y);
		m3.Set(-sxy, 0.f, axis.z);

		for( i = 0; i < m_bond_vcnt; i++){
			positions[i].x = m1 * m_bond_pos[i] + v1.x;
			positions[i].y = m2 * m_bond_pos[i] + v1.y;
			positions[i].z = m3 * m_bond_pos[i] + v1.z;
			normals[i].x = m1 * m_bond_nor[i];
			normals[i].y = m2 * m_bond_nor[i];
			normals[i].z = m3 * m_bond_nor[i];
		}
	}

	//color̃Zbg	
	for( i = 0; i < m_bond_vcnt / 2; i++){
		*cols = onecolor;
		cols++;
	}

	for( i = 0; i < m_bond_vcnt / 2; i++){
		*cols = othercolor;
		cols++;
	}
		

	//CfbNX̃Zbg	
	for( i = 0; i < m_bond_icnt; i++){
		indexes[i] = m_bond_idx[i] + index_offset;
	}
		
	
	memcpy(normals, m_bond_nor, m_bond_vcnt * sizeof(vec3f));
	
	
}


void GLObj_MD::SetMode(int mode){
	
	switch(mode){
//q\
	case MODE_ATOM_SMALL:
		m_mode_atom = mode;
		InitSphere(ATOM_RADIUS, 6, 8);
		break;
	case MODE_ATOM_LARGE:
		m_mode_atom = mode;
		InitSphere(ATOM_RADIUS * 4, 6, 8);
		break;
	case MODE_ATOM_NONE:
		m_mode_atom = mode;
		break;
	
//{h\
	
	case MODE_BOND_PIPE:
		m_mode_bond = mode;
		InitBond( 0.05f , 8 );
		break;
	case MODE_BOND_ENERGYJ:
		m_mode_bond = mode;
		InitCone( 0.05f , 8 );
		break;
	case MODE_BOND_NONE:
		m_mode_bond = mode;
		break;
		
//\F
	case MODE_COLOR_ATOMIC:
		m_mode_color = mode;
		CheckColorByAtomKind();
		break;
	case MODE_COLOR_BONDNUM:
		m_mode_color = mode;
		CheckColorByBondNum();
		break;
	}
	m_prev_render_dat = NULL;
}
	

//qԍɃJ[vZ
void GLObj_MD::CheckColorByAtomKind(){
	
	ATOMS_DATA* dat = GetDataPointer();

	delete [] m_color_table;
	m_color_table = new unsigned int[dat->pcnt];
	
	//FQ
	int i;
	for(i = 0; i < dat->pcnt; i++){
		m_color_table[i] = *(((unsigned int*)atom_colors) + dat->knd[i]);
	}
}

//{hɃJ[vZ
void GLObj_MD::CheckColorByBondNum(){
	
	ATOMS_DATA* dat = GetDataPointer();

	delete [] m_color_table;
	m_color_table = new unsigned int[dat->pcnt];
	memset(m_color_table, 0, sizeof(unsigned int) * dat->pcnt);

	//bondvZ
	int i;
	for(i = 0; i < dat->bcnt; i++){
		m_color_table[dat->li[i]] ++;
		m_color_table[dat->lj[i]] ++;
	}
	//FQ
	for(i = 0; i < dat->pcnt; i++){
		m_color_table[i] = *(((unsigned int*)bondnum_colors) + m_color_table[i]);
	}
}

void GLObj_MD::ClearVRAM(){
	m_prev_render_dat = NULL;

}