// GLObj_MD.h: GLObj_MD NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GLObj_MD_H__077F1075_A4CA_4B91_9C2B_E76CEA228C5A__INCLUDED_)
#define AFX_GLObj_MD_H__077F1075_A4CA_4B91_9C2B_E76CEA228C5A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//#include <GL/glut.h>
#include <stdio.h>

#include "sdkwgl.h"
#include "vec3.h"
#include "mat33.h"
#include "io64.h"
#include "mod.h"

#define TXT_INITIAL_ATOM 4096
#define TXT_INITIAL_BOND 8192

const long64 READLIMIT = 4*1024*1024;	// 64M


#define KIND_ALL (255)

class ATOMS_DATA {
public:
	int frame;	//ǂݍ񂾏0CNg
	int no;
	int pcnt;
	int bcnt;
	int istep;
	float realtm;
	mat33f boxaxis;
	vec3f boxorg;
	float tempave;
	float tempvar;
	int* knd;
	int* id;
	//float* rx;    //\̃o[
    //float* ry;
    //float* rz;
	vec3f* r;
	//float* px;    //\̃o[
    //float* py;
    //float* pz;
	vec3f* p;
	int* li;
	int* lj;
	float* Jij;
	char* bond;		//0:\, 1:\
	char* info;		//ɕȂǂɎgp
	//ATOMS_DATA* prev;
	//ATOMS_DATA* next;

	ATOMS_DATA(){
		pcnt = 0;
		bcnt = 0;
		this->knd = NULL;
		this->id = NULL;
		this->r = NULL;
		this->p = NULL;
		this->li = NULL;
		this->lj = NULL;
		this->Jij = NULL;
		this->bond = NULL;
		this->info = NULL;
	};
	virtual ~ATOMS_DATA(){
		delete [] this->knd;
		delete [] this->id;
		delete [] this->r;
		delete [] this->p;
		delete [] this->li;
		delete [] this->lj;
		delete [] this->Jij;
		delete [] this->bond;
		delete [] this->info;
	};

};

template<class T> class AutoArray{
	
public:
	T* buffer;
	int size;
	int count;
private:
	int m_ratio;	//zg厞̔{
	
public:	
	AutoArray(int initial_size, int ratio);
	virtual ~AutoArray();

	void Add(T& t);
	//T* plast(){ return buffer + count - 1;};
		
};


class GLObj_MD  
{
private:

	struct FRAME_POS{
		long64 filepos;
		ATOMS_DATA* atmdat;
		int keep;
	};

	AutoArray<FRAME_POS>* m_frame_buf;
	//int m_frame_read_count;
	


/*
	struct FILEPOS_LIST{		//̍\݂̂ȂKǂ߂邱Ƃۏ. 
		long64 pos;			//t@C̃|C^. Kǂ߂. ǂݍ݂`WĂȂ|C^͕ϐunknown_pos
		ATOMS_DATA* atmdat;		//ǂݍݍς݂Ȃ|C^. [Xς݂ȂNULL.	dlɂ薢ǂ̏Ԃ͂łĂȂ
		FILEPOS_LIST* prev;	//ÕXg|C^. 擪XgȂNULL.
		FILEPOS_LIST* next;	//̃Xg|C^. ͎ǂݍ݂ȂNULL
	};
*/
	long64 m_unknown_pos;		//܂ǂݍ݂ĂȂt@Cpos. I[ĂȂLONG64_ZERO.
	//FILEPOS_LIST->next==NULL ̂Ƃ
	//	unknown_pos == LONG64_ZERO Ȃ, t@C
	//	unknown_pos != LONG64_ZERO Ȃ, ǂݍ݂
	//		ǂݍݎsȂ, t@CƂunknown_posLONG64_ZEROZbg
	//		ǂݍݐȂ, t@Cł͂Ȃ̂, Xgt, , unknown_posɐVt@C|C^Zbg.

//	FILEPOS_LIST* m_fpos_first;
//	FILEPOS_LIST* m_fpos_current;

	int readMode;//-1:not read, 0: Sēǂݍݍς, 1: datǂݍ, 2: fadǂݍ
	FILE64* fp;
	//ATOMS_DATA* fstDat;
	//ATOMS_DATA* nowDat;
	int m_frameNo;			//݂̓̃t[io[

/*	
	int stockCnt;	// 48M
	int stockIdx;	// 48M
	FILEPOS_LIST** stockFPL;
*/	
	long64 fp_pos;		//ǂݍݎɃt@C|C^ȂfBXNwbhĐݒ肵Ȃ߂̔p
	
	FILE* m_wfp;		//OpenWriteFilep
	

	int readBIN(FILE64 *fp, int mode);
	ATOMS_DATA* readFrameDAT(FILE64* fp, long64 filepos);
	ATOMS_DATA* readFrameFAD(FILE64* fp, long64 filepos);
	long64 skipFrameFAD(FILE64* fp, long64 filepos);
	int readTXT(FILE *fp, int mode);
	ATOMS_DATA* readFramePDB(FILE* fp, ATOMS_DATA* readBuf);
	ATOMS_DATA* readFrameXYZ(FILE* fp, ATOMS_DATA* readBuf);
	void clearBuffer();
	void DeleteFrame(ATOMS_DATA *dat);
	
	void Load(const TCHAR *filename);
	void UnloadStock();
	void KeepCurrentFrame();


//OpenGLp_f[^
	int m_maxAtomCount;
	int m_maxBondCount;
	int m_vbo_vcount;
	vec3f* m_vbo_positions;
	vec3f* m_vbo_normals;
	BYTE* m_vbo_colors;
	int m_vbo_icount;
	int* m_vbo_indexes;

	unsigned int *m_color_table;	//qƂ̐F

	ATOMS_DATA* m_prev_render_dat;	//O񃌃_Of[^
	void CreateSphereArray();

//|Sfp̃obt@
	vec3f* m_sphere_pos;
	vec3f* m_sphere_nor;
	int* m_sphere_idx;
	int m_sphere_vcnt, m_sphere_icnt;
	void InitSphere(float radius, int slices, int stacks);
	void SetSphere(vec3f& orgin, unsigned int onecolor, int index_offset, vec3f* positions, vec3f* normals, BYTE* colors, int* indexes);
	
	
	vec3f* m_bond_pos;
	vec3f* m_bond_nor;
	int* m_bond_idx;
	int m_bond_vcnt, m_bond_icnt;
	void InitBond(float radius, int stacks);
	void InitCone(float radius, int stacks);
	void SetBond(vec3f& v1, vec3f& v2, unsigned int onecolor, unsigned int othercolor, int index_offset, vec3f* positions, vec3f* normals, BYTE* colors, int* indexes);

	void CheckColorByBondNum();
	void CheckColorByAtomKind();
	
	//\[h
	int m_mode_atom;
#define MODE_ATOM_NONE		0x0
#define MODE_ATOM_SMALL		0x1
#define MODE_ATOM_LARGE		0x2

	int m_mode_bond;
#define MODE_BOND_NONE		0x1000
#define MODE_BOND_PIPE		0x1001
#define MODE_BOND_ENERGYJ	0x1002

	int m_mode_color;
#define	MODE_COLOR_ATOMIC	0x2000
#define	MODE_COLOR_BONDNUM	0x2001



public:
	float Jmax;

	GLObj_MD(const TCHAR *filename);
	virtual ~GLObj_MD();
	int goNext();
	int goNext(int num);
	int goPrev();
	int goPrev(int num);
	void goFirst();
	ATOMS_DATA* GetDataPointer();

	
	void openWriteFile(const TCHAR *filename);
	void writeFrameXYZ();
	void closeWriteFile();
	
	int GetFrameNum();

	void Rendering();

	void SetMode(int mode);
	void ClearVRAM();	
	
};





#endif // !defined(AFX_GLObj_MD_H__077F1075_A4CA_4B91_9C2B_E76CEA228C5A__INCLUDED_)

