
/////!=====================================================================;
////// ListupBond
////// 
////// {hƍėאڃXg̍쐬(REBOSetListǂ) 
//////
/////!=====================================================================;

#include <string.h>
#include "ListupBond.h"
	

ListupBond::ListupBond(int maxcount, double maxlength) : CellDiv(maxlength, FLAG_PERIODIC_XYZ, maxcount){

	m_ijmax = maxcount * BOND_CNT;

	m_Dmax[0] = 1.85;
	m_Dmax[1] = 1.55;
	m_Dmax[2] = 1.4;

		m_Dmax2[0] = m_Dmax[0] * m_Dmax[0];
		m_Dmax2[1] = m_Dmax[1] * m_Dmax[1];
		m_Dmax2[2] = m_Dmax[2] * m_Dmax[2];

	m_neighbor = new NEIGHBOR_LIST[m_max_count];

	m_bonding = new SIMPLE_BONDING[m_ijmax];
	

	m_bondCnt = 0;
	m_bondInsideCnt = 0;

}

ListupBond::~ListupBond(){
	delete [] m_neighbor;
	delete [] m_bonding;
}

void ListupBond::SetParticlePointers(int* kind, vec3d* positions){
	m_knd = kind;
	m_r = positions;	
}


void ListupBond::Clear(int count){
		memset(m_neighbor, 0, count * sizeof(NEIGHBOR_LIST));
}


//======================================================================;
//;
//		Subroutine SetList (olg name is BrnList);
//;
//		This routine dig up interaction partner and calculate ;
//		coordination.;
//;
//;
//									made by Atsushi I.	2004/12/20;
//======================================================================;


//void REBO::SetListOrtho(double boxx, double boxy, double boxz, CELLDIV_INFO* info){
void ListupBond::SetListOrtho(int count){
	
	// local variable ------------------------------;
		int i,j, jhead;
		int ki;
		vec3d dd;

		Clear(count);
		
		//qZɋ؂.
		PutIntoCell(count, m_r, m_knd);

		m_bondCnt = 0;
		

	//Zł̒T==============================================
		int icell;
		for( icell=0; icell < m_mcell; icell++){
				//loop over all molecules in the cell;
					i = m_first_in_cell[icell];
					while (i != -1){

						ki = m_knd[i];
						j = m_inext[i];
		
				
						//nabor loop ----;
						while (j != -1){

							dd = m_r[i] - m_r[j];
							AddBondByCutOff(i,j,ki,m_knd[j], 1,dd);	//bondǉꂽ1Ԃ.

							j = m_inext[j];
						}
						
						i = m_inext[i];		
					}

		}

	//ʂ̃ZԂł̒T==============================================
		//E1cell.
		//Eɂ܂肽݂̔B
		int index;
		for( index=0; index < m_cell_pair_index[1]; index += 2){
			
			i = m_first_in_cell[m_cell_pair[index]];
			jhead = m_first_in_cell[m_cell_pair[index+1]];
			while (i != -1){

				ki = m_knd[i];
				//nabor loop ----;
				j = jhead;
				while (j != -1){
					dd = m_r[i] - m_r[j];
					AddBondByCutOff(i,j,ki,m_knd[j],1,dd);	//bondǉꂽ1Ԃ.

					j = m_inext[j];
				}// end of nabor loop;
	
				i = m_inext[i];
			}
		}

		//EׂȂ{h̐.
		m_bondInsideCnt = m_bondCnt;

	//ȍ~͋Eׂ/////////////////////////////////////////////////////////

	//xEׂ(jxzcell)
		for( index = m_cell_pair_index[1]; index < m_cell_pair_index[2]; index += 2){
			
			
			i = m_first_in_cell[m_cell_pair[index]];
			jhead = m_first_in_cell[m_cell_pair[index+1]];
			while (i != -1){

				ki = m_knd[i];
				//nabor loop ----;
				j = jhead;
				while (j != -1){
					dd = m_r[i] - m_r[j];
					dd.x -= m_box.x;
					AddBondByCutOff(i,j,ki,m_knd[j],0,dd);	//bondǉꂽ1Ԃ.

					j = m_inext[j];
				}// end of nabor loop;
	
				i = m_inext[i];
			}
		}
	
	//yEׂ(jyzcell)
		for( index = m_cell_pair_index[2]; index < m_cell_pair_index[3]; index += 2){
			
			
			i = m_first_in_cell[m_cell_pair[index]];
			jhead = m_first_in_cell[m_cell_pair[index+1]];
			while (i != -1){

				ki = m_knd[i];
				//nabor loop ----;
				j = jhead;
				while (j != -1){
					//GetRij_periodicY(i,j, &xx, &yy, &zz);
					dd = m_r[i] - m_r[j];
					dd.y -= m_box.y;
					AddBondByCutOff(i,j,ki,m_knd[j],0,dd);	//bondǉꂽ1Ԃ.

					j = m_inext[j];
				}// end of nabor loop;
	
				i = m_inext[i];
			}
		}

	//zEׂ(jzzcell)
		for( index = m_cell_pair_index[3]; index < m_cell_pair_index[4]; index += 2){
			
			
			i = m_first_in_cell[m_cell_pair[index]];
			jhead = m_first_in_cell[m_cell_pair[index+1]];
			while (i != -1){

				ki = m_knd[i];
				//nabor loop ----;
				j = jhead;
				while (j != -1){
					//GetRij_periodicZ(i,j, &xx, &yy, &zz);
					dd = m_r[i] - m_r[j];
					dd.z -= m_box.z;
					AddBondByCutOff(i,j,ki,m_knd[j],0,dd);	//bondǉꂽ1Ԃ.

					j = m_inext[j];
				}// end of nabor loop;
	
				i = m_inext[i];
			}
		}

	//xyEׂ(҂xyɉzcell)
		for( index = m_cell_pair_index[4]; index < m_cell_pair_index[5]; index += 2){
			
			i = m_first_in_cell[m_cell_pair[index]];
			jhead = m_first_in_cell[m_cell_pair[index+1]];
			while (i != -1){

				ki = m_knd[i];
				//nabor loop ----;
				j = jhead;
				while (j != -1){
					//GetRij_periodicXY(i,j, &xx, &yy, &zz);
					//bondcount += AddBondByCutOff(i,j,ki,bondcount,xx,yy,zz);	//bondǉꂽ1Ԃ.
					dd = m_r[i] - m_r[j];
					dd.x -= m_box.x;
					dd.y -= m_box.y;
					AddBondByCutOff(i,j,ki,m_knd[j],0,dd);	//bondǉꂽ1Ԃ.

					j = m_inext[j];
				}// end of nabor loop;
	
				i = m_inext[i];
			}
		}
	//xyEׂ(O҂xzcell,҂yzcell)
		for( index = m_cell_pair_index[5]; index < m_cell_pair_index[6]; index += 2){
			
			i = m_first_in_cell[m_cell_pair[index]];
			jhead = m_first_in_cell[m_cell_pair[index+1]];
			while (i != -1){

				ki = m_knd[i];
				//nabor loop ----;
				j = jhead;
				while (j != -1){
					//GetRij_periodicXY(i,j, &xx, &yy, &zz);
					//bondcount += AddBondByCutOff(i,j,ki,bondcount,xx,yy,zz);	//bondǉꂽ1Ԃ.
					dd = m_r[i] - m_r[j];
					dd.x += m_box.x;
					dd.y -= m_box.y;
					AddBondByCutOff(i,j,ki,m_knd[j],0,dd);	//bondǉꂽ1Ԃ.

					j = m_inext[j];
				}// end of nabor loop;
	
				i = m_inext[i];
			}
		}

	//yzEׂ(҂yzɉzcell)
		for( index = m_cell_pair_index[6]; index < m_cell_pair_index[7]; index += 2){
			
			i = m_first_in_cell[m_cell_pair[index]];
			jhead = m_first_in_cell[m_cell_pair[index+1]];
			while (i != -1){

				ki = m_knd[i];
				//nabor loop ----;
				j = jhead;
				while (j != -1){
					//GetRij_periodicYZ(i,j, &xx, &yy, &zz);
					//bondcount += AddBondByCutOff(i,j,ki,bondcount,xx,yy,zz);	//bondǉꂽ1Ԃ.
					dd = m_r[i] - m_r[j];
					dd.y -= m_box.y;
					dd.z -= m_box.z;
					AddBondByCutOff(i,j,ki,m_knd[j],0,dd);	//bondǉꂽ1Ԃ.

					j = m_inext[j];
				}// end of nabor loop;
	
				i = m_inext[i];
			}
		}
	//yzEׂ(O҂yzcell,҂zzcell)
		for( index = m_cell_pair_index[7]; index < m_cell_pair_index[8]; index += 2){
			
			i = m_first_in_cell[m_cell_pair[index]];
			jhead = m_first_in_cell[m_cell_pair[index+1]];
			while (i != -1){

				ki = m_knd[i];
				//nabor loop ----;
				j = jhead;
				while (j != -1){
					//GetRij_periodicYZ(i,j, &xx, &yy, &zz);
					//bondcount += AddBondByCutOff(i,j,ki,bondcount,xx,yy,zz);	//bondǉꂽ1Ԃ.
					dd = m_r[i] - m_r[j];
					dd.y += m_box.y;
					dd.z -= m_box.z;
					AddBondByCutOff(i,j,ki,m_knd[j],0,dd);	//bondǉꂽ1Ԃ.

					j = m_inext[j];
				}// end of nabor loop;
	
				i = m_inext[i];
			}
		}
		
		
	//zxEׂ(҂zxɉzcell)
		for( index = m_cell_pair_index[8]; index < m_cell_pair_index[9]; index += 2){
			
			i = m_first_in_cell[m_cell_pair[index]];
			jhead = m_first_in_cell[m_cell_pair[index+1]];
			while (i != -1){

				ki = m_knd[i];
				//nabor loop ----;
				j = jhead;
				while (j != -1){
					//GetRij_periodicZX(i,j, &xx, &yy, &zz);
					//bondcount += AddBondByCutOff(i,j,ki,bondcount,xx,yy,zz);	//bondǉꂽ1Ԃ.
					dd = m_r[i] - m_r[j];
					dd.x -= m_box.x;
					dd.z -= m_box.z;
					AddBondByCutOff(i,j,ki,m_knd[j],0,dd);	//bondǉꂽ1Ԃ.

					j = m_inext[j];
				}// end of nabor loop;
	
				i = m_inext[i];
			}
		}
	//zxEׂ(O҂zzcell,҂xzcell)
		for( index = m_cell_pair_index[9]; index < m_cell_pair_index[10]; index += 2){
			
			i = m_first_in_cell[m_cell_pair[index]];
			jhead = m_first_in_cell[m_cell_pair[index+1]];
			while (i != -1){

				ki = m_knd[i];
				//nabor loop ----;
				j = jhead;
				while (j != -1){
					//GetRij_periodicZX(i,j, &xx, &yy, &zz);
					//bondcount += AddBondByCutOff(i,j,ki,bondcount,xx,yy,zz);	//bondǉꂽ1Ԃ.
					dd = m_r[i] - m_r[j];
					dd.x -= m_box.x;
					dd.z += m_box.z;
					AddBondByCutOff(i,j,ki,m_knd[j],0,dd);	//bondǉꂽ1Ԃ.

					j = m_inext[j];
				}// end of nabor loop;
	
				i = m_inext[i];
			}
		}

	//xyzEׂ(O҂xzcell,҂yzzcell)
		index = m_cell_pair_index[10];
		if(index < m_cell_pair_index[11]){
			
			i = m_first_in_cell[m_cell_pair[index]];
			jhead = m_first_in_cell[m_cell_pair[index+1]];
			while (i != -1){

				ki = m_knd[i];
				//nabor loop ----;
				j = jhead;
				while (j != -1){
					//GetRij(i,j, &xx, &yy, &zz);
					//bondcount += AddBondByCutOff(i,j,ki,bondcount,xx,yy,zz);	//bondǉꂽ1Ԃ.
					dd = m_r[i] - m_r[j];
					dd.x += m_box.x;
					dd.y -= m_box.y;
					dd.z -= m_box.z;
					AddBondByCutOff(i,j,ki,m_knd[j],0,dd);	//bondǉꂽ1Ԃ.

					j = m_inext[j];
				}// end of nabor loop;
	
				i = m_inext[i];
			}
		
		//(O҂yzcell,҂zxzcell)
		index +=2;
		
			i = m_first_in_cell[m_cell_pair[index]];
			jhead = m_first_in_cell[m_cell_pair[index+1]];
			while (i != -1){

				ki = m_knd[i];
				//nabor loop ----;
				j = jhead;
				while (j != -1){
					//GetRij(i,j, &xx, &yy, &zz);
					//bondcount += AddBondByCutOff(i,j,ki,bondcount,xx,yy,zz);	//bondǉꂽ1Ԃ.
					dd = m_r[i] - m_r[j];
					dd.x -= m_box.x;
					dd.y += m_box.y;
					dd.z -= m_box.z;
					AddBondByCutOff(i,j,ki,m_knd[j],0,dd);	//bondǉꂽ1Ԃ.

					j = m_inext[j];
				}// end of nabor loop;
	
				i = m_inext[i];
			}
		//(O҂zzcell,҂xyzcell)
		index +=2;
		
			i = m_first_in_cell[m_cell_pair[index]];
			jhead = m_first_in_cell[m_cell_pair[index+1]];
			while (i != -1){

				ki = m_knd[i];
				//nabor loop ----;
				j = jhead;
				while (j != -1){
					//GetRij(i,j, &xx, &yy, &zz);
					//bondcount += AddBondByCutOff(i,j,ki,bondcount,xx,yy,zz);	//bondǉꂽ1Ԃ.
					dd = m_r[i] - m_r[j];
					dd.x -= m_box.x;
					dd.y -= m_box.y;
					dd.z += m_box.z;
					AddBondByCutOff(i,j,ki,m_knd[j],0,dd);	//bondǉꂽ1Ԃ.

					j = m_inext[j];
				}// end of nabor loop;
	
				i = m_inext[i];
			}
		
		//(҂xyzzcell)
		index +=2;
		
			i = m_first_in_cell[m_cell_pair[index]];
			jhead = m_first_in_cell[m_cell_pair[index+1]];
			while (i != -1){

				ki = m_knd[i];
				//nabor loop ----;
				j = jhead;
				while (j != -1){
					//GetRij(i,j, &xx, &yy, &zz);
					//bondcount += AddBondByCutOff(i,j,ki,bondcount,xx,yy,zz);	//bondǉꂽ1Ԃ.
					dd = m_r[i] - m_r[j];
					dd.x -= m_box.x;
					dd.y -= m_box.y;
					dd.z -= m_box.z;
					AddBondByCutOff(i,j,ki,m_knd[j],0,dd);	//bondǉꂽ1Ԃ.

					j = m_inext[j];
				}// end of nabor loop;
	
				i = m_inext[i];
			}
		
		}


		
}

void ListupBond::SetListNonortho(int count){
	
	// local variable ------------------------------;
		int i,j,jhead;
		//double xx,yy,zz;
		int ki;
		vec3d dd;
		vec3d peri;

		Clear(count);

		//qZɋ؂.
		PutIntoCellNonortho(count, m_r, m_knd);

		m_bondCnt = 0;


	//Zł̒T==============================================
		int icell;
		for( icell=0; icell < m_mcell; icell++){
				//loop over all molecules in the cell;
					i = m_first_in_cell[icell];
					while (i != -1){

						ki = m_knd[i];
						j = m_inext[i];
		
				
						//nabor loop ----;
						while (j != -1){

							dd = m_r[i] - m_r[j];
							AddBondByCutOff(i,j,ki,m_knd[j], 1,dd);	//bondǉꂽ1Ԃ.

							j = m_inext[j];
						}
						
						i = m_inext[i];		
					}

		}

	//ʂ̃ZԂł̒T==============================================
		//E1cell.
		//Eɂ܂肽݂̔B
		int index;
		for( index=0; index < m_cell_pair_index[1]; index += 2){
			
			i = m_first_in_cell[m_cell_pair[index]];
			jhead = m_first_in_cell[m_cell_pair[index+1]];
			while (i != -1){

				ki = m_knd[i];
				//nabor loop ----;
				j = jhead;
				while (j != -1){
					dd = m_r[i] - m_r[j];
					AddBondByCutOff(i,j,ki,m_knd[j], 1,dd);	//bondǉꂽ1Ԃ.

					j = m_inext[j];
				}// end of nabor loop;
	
				i = m_inext[i];
			}
		}

		//EׂȂ{h̐.
		m_bondInsideCnt = m_bondCnt;

	//ȍ~͋Eׂ/////////////////////////////////////////////////////////

		//xEׂ(jxzcell)
			peri = - m_Am.a;
			for( index = m_cell_pair_index[1]; index < m_cell_pair_index[2]; index += 2){
				
				
				i = m_first_in_cell[m_cell_pair[index]];
				jhead = m_first_in_cell[m_cell_pair[index+1]];
				while (i != -1){

					ki = m_knd[i];
					//nabor loop ----;
					j = jhead;
					while (j != -1){
						dd = m_r[i] - m_r[j] + peri;
						AddBondByCutOff(i,j,ki,m_knd[j], 0,dd);	//bondǉꂽ1Ԃ.

						j = m_inext[j];
					}// end of nabor loop;
		
					i = m_inext[i];
				}
			}
		
		//yEׂ(jyzcell)
			peri = - m_Am.b;
			for( index = m_cell_pair_index[2]; index < m_cell_pair_index[3]; index += 2){
				
				
				i = m_first_in_cell[m_cell_pair[index]];
				jhead = m_first_in_cell[m_cell_pair[index+1]];
				while (i != -1){

					ki = m_knd[i];
					//nabor loop ----;
					j = jhead;
					while (j != -1){
						//GetRij_periodicY(i,j, &xx, &yy, &zz);
						dd = m_r[i] - m_r[j] + peri;
						AddBondByCutOff(i,j,ki,m_knd[j], 0,dd);	//bondǉꂽ1Ԃ.

						j = m_inext[j];
					}// end of nabor loop;
		
					i = m_inext[i];
				}
			}

		//zEׂ(jzzcell)
			peri = - m_Am.c;
			for( index = m_cell_pair_index[3]; index < m_cell_pair_index[4]; index += 2){
				
				
				i = m_first_in_cell[m_cell_pair[index]];
				jhead = m_first_in_cell[m_cell_pair[index+1]];
				while (i != -1){

					ki = m_knd[i];
					//nabor loop ----;
					j = jhead;
					while (j != -1){
						//GetRij_periodicZ(i,j, &xx, &yy, &zz);
						dd = m_r[i] - m_r[j] + peri;
						AddBondByCutOff(i,j,ki,m_knd[j], 0,dd);	//bondǉꂽ1Ԃ.

						j = m_inext[j];
					}// end of nabor loop;
		
					i = m_inext[i];
				}
			}

		//xyEׂ(҂xyɉzcell)
			peri = - m_Am.a - m_Am.b;
			for( index = m_cell_pair_index[4]; index < m_cell_pair_index[5]; index += 2){
				
				i = m_first_in_cell[m_cell_pair[index]];
				jhead = m_first_in_cell[m_cell_pair[index+1]];
				while (i != -1){

					ki = m_knd[i];
					//nabor loop ----;
					j = jhead;
					while (j != -1){
						//GetRij_periodicXY(i,j, &xx, &yy, &zz);
						//l += AddBondByCutOff(i,j,ki,l,xx,yy,zz);	//bondǉꂽ1Ԃ.
						dd = m_r[i] - m_r[j] + peri;
						AddBondByCutOff(i,j,ki,m_knd[j], 0,dd);	//bondǉꂽ1Ԃ.

						j = m_inext[j];
					}// end of nabor loop;
		
					i = m_inext[i];
				}
			}
		//xyEׂ(O҂xzcell,҂yzcell)
			peri = m_Am.a - m_Am.b;
			for( index = m_cell_pair_index[5]; index < m_cell_pair_index[6]; index += 2){
				
				i = m_first_in_cell[m_cell_pair[index]];
				jhead = m_first_in_cell[m_cell_pair[index+1]];
				while (i != -1){

					ki = m_knd[i];
					//nabor loop ----;
					j = jhead;
					while (j != -1){
						//GetRij_periodicXY(i,j, &xx, &yy, &zz);
						//l += AddBondByCutOff(i,j,ki,l,xx,yy,zz);	//bondǉꂽ1Ԃ.
						dd = m_r[i] - m_r[j] + peri;
						AddBondByCutOff(i,j,ki,m_knd[j], 0,dd);	//bondǉꂽ1Ԃ.

						j = m_inext[j];
					}// end of nabor loop;
		
					i = m_inext[i];
				}
			}

		//yzEׂ(҂yzɉzcell)
			peri = - m_Am.b - m_Am.c;
			for( index = m_cell_pair_index[6]; index < m_cell_pair_index[7]; index += 2){
				
				i = m_first_in_cell[m_cell_pair[index]];
				jhead = m_first_in_cell[m_cell_pair[index+1]];
				while (i != -1){

					ki = m_knd[i];
					//nabor loop ----;
					j = jhead;
					while (j != -1){
						//GetRij_periodicYZ(i,j, &xx, &yy, &zz);
						//l += AddBondByCutOff(i,j,ki,l,xx,yy,zz);	//bondǉꂽ1Ԃ.
						dd = m_r[i] - m_r[j] + peri;
						AddBondByCutOff(i,j,ki,m_knd[j], 0,dd);	//bondǉꂽ1Ԃ.

						j = m_inext[j];
					}// end of nabor loop;
		
					i = m_inext[i];
				}
			}
		//yzEׂ(O҂yzcell,҂zzcell)
			peri = m_Am.b - m_Am.c;
			for( index = m_cell_pair_index[7]; index < m_cell_pair_index[8]; index += 2){
				
				i = m_first_in_cell[m_cell_pair[index]];
				jhead = m_first_in_cell[m_cell_pair[index+1]];
				while (i != -1){

					ki = m_knd[i];
					//nabor loop ----;
					j = jhead;
					while (j != -1){
						//GetRij_periodicYZ(i,j, &xx, &yy, &zz);
						//l += AddBondByCutOff(i,j,ki,l,xx,yy,zz);	//bondǉꂽ1Ԃ.
						dd = m_r[i] - m_r[j] + peri;
						AddBondByCutOff(i,j,ki,m_knd[j], 0,dd);	//bondǉꂽ1Ԃ.

						j = m_inext[j];
					}// end of nabor loop;
		
					i = m_inext[i];
				}
			}
			
			
		//zxEׂ(҂zxɉzcell)
			peri = - m_Am.a - m_Am.c;
			for( index = m_cell_pair_index[8]; index < m_cell_pair_index[9]; index += 2){
				
				i = m_first_in_cell[m_cell_pair[index]];
				jhead = m_first_in_cell[m_cell_pair[index+1]];
				while (i != -1){

					ki = m_knd[i];
					//nabor loop ----;
					j = jhead;
					while (j != -1){
						//GetRij_periodicZX(i,j, &xx, &yy, &zz);
						//l += AddBondByCutOff(i,j,ki,l,xx,yy,zz);	//bondǉꂽ1Ԃ.
						dd = m_r[i] - m_r[j] + peri;
						AddBondByCutOff(i,j,ki,m_knd[j], 0,dd);	//bondǉꂽ1Ԃ.

						j = m_inext[j];
					}// end of nabor loop;
		
					i = m_inext[i];
				}
			}
		//zxEׂ(O҂zzcell,҂xzcell)
			peri = - m_Am.a + m_Am.c;
			for( index = m_cell_pair_index[9]; index < m_cell_pair_index[10]; index += 2){
				
				i = m_first_in_cell[m_cell_pair[index]];
				jhead = m_first_in_cell[m_cell_pair[index+1]];
				while (i != -1){

					ki = m_knd[i];
					//nabor loop ----;
					j = jhead;
					while (j != -1){
						//GetRij_periodicZX(i,j, &xx, &yy, &zz);
						//l += AddBondByCutOff(i,j,ki,l,xx,yy,zz);	//bondǉꂽ1Ԃ.
						dd = m_r[i] - m_r[j] + peri;
						AddBondByCutOff(i,j,ki,m_knd[j], 0,dd);	//bondǉꂽ1Ԃ.

						j = m_inext[j];
					}// end of nabor loop;
		
					i = m_inext[i];
				}
			}

		//xyzEׂ(O҂xzcell,҂yzzcell)
			peri = m_Am.a - m_Am.b - m_Am.c;
			index = m_cell_pair_index[10];
				
				i = m_first_in_cell[m_cell_pair[index]];
				jhead = m_first_in_cell[m_cell_pair[index+1]];
				while (i != -1){

					ki = m_knd[i];
					//nabor loop ----;
					j = jhead;
					while (j != -1){
						//GetRij(i,j, &xx, &yy, &zz);
						//l += AddBondByCutOff(i,j,ki,l,xx,yy,zz);	//bondǉꂽ1Ԃ.
						dd = m_r[i] - m_r[j] + peri;
						AddBondByCutOff(i,j,ki,m_knd[j], 0,dd);	//bondǉꂽ1Ԃ.

						j = m_inext[j];
					}// end of nabor loop;
		
					i = m_inext[i];
				}
			
			//(O҂yzcell,҂zxzcell)
			peri = - m_Am.a + m_Am.b - m_Am.c;
			index +=2;
			
				i = m_first_in_cell[m_cell_pair[index]];
				jhead = m_first_in_cell[m_cell_pair[index+1]];
				while (i != -1){

					ki = m_knd[i];
					//nabor loop ----;
					j = jhead;
					while (j != -1){
						//GetRij(i,j, &xx, &yy, &zz);
						//l += AddBondByCutOff(i,j,ki,l,xx,yy,zz);	//bondǉꂽ1Ԃ.
						dd = m_r[i] - m_r[j] + peri;
						AddBondByCutOff(i,j,ki,m_knd[j], 0,dd);	//bondǉꂽ1Ԃ.

						j = m_inext[j];
					}// end of nabor loop;
		
					i = m_inext[i];
				}
			//(O҂zzcell,҂xyzcell)
			peri = - m_Am.a - m_Am.b + m_Am.c;
			index +=2;
			
				i = m_first_in_cell[m_cell_pair[index]];
				jhead = m_first_in_cell[m_cell_pair[index+1]];
				while (i != -1){

					ki = m_knd[i];
					//nabor loop ----;
					j = jhead;
					while (j != -1){
						//GetRij(i,j, &xx, &yy, &zz);
						//l += AddBondByCutOff(i,j,ki,l,xx,yy,zz);	//bondǉꂽ1Ԃ.
						dd = m_r[i] - m_r[j] + peri;
						AddBondByCutOff(i,j,ki,m_knd[j], 0,dd);	//bondǉꂽ1Ԃ.

						j = m_inext[j];
					}// end of nabor loop;
		
					i = m_inext[i];
				}
			
			//(҂xyzzcell)
			peri = - m_Am.a - m_Am.b - m_Am.c;
			index +=2;
			
				i = m_first_in_cell[m_cell_pair[index]];
				jhead = m_first_in_cell[m_cell_pair[index+1]];
				while (i != -1){

					ki = m_knd[i];
					//nabor loop ----;
					j = jhead;
					while (j != -1){
						//GetRij(i,j, &xx, &yy, &zz);
						//l += AddBondByCutOff(i,j,ki,l,xx,yy,zz);	//bondǉꂽ1Ԃ.
						dd = m_r[i] - m_r[j] + peri;
						AddBondByCutOff(i,j,ki,m_knd[j], 0,dd);	//bondǉꂽ1Ԃ.

						j = m_inext[j];
					}// end of nabor loop;
		
					i = m_inext[i];
				}
			


//		}

		

		
}


int ListupBond::AddBondByCutOff(int i, int j, int ki, int kj, int innerflag, vec3d& dd){
	//innerflag: {bNXEׂłȂȂ1.
	double rd2;
	
	int iprt,jprt;
	

	
	rd2 = dd * dd;

	//int kj = m_knd[j];

//	if (rd2 <= m_Dmax2[ki + kj]) {
	if (rd2 <= m_Dmax2[0]) {
	
		
		iprt = m_neighbor[i].NbCnt;
		m_neighbor[i].NbCnt ++;		
//		if(m_neighbor[i].NbCnt >= BOND_CNT){	//ǂNI[o[t[̌
//			m_neighbor[i].NbCnt = 0;
//		}
		
		jprt = m_neighbor[j].NbCnt;
		m_neighbor[j].NbCnt ++;
//		if(m_neighbor[j].NbCnt >= BOND_CNT){	//ǂNI[o[t[̌
//			m_neighbor[j].NbCnt = 0;
//		}
	
		m_bonding[m_bondCnt].i = i;
		m_bonding[m_bondCnt].j = j;
		m_bonding[m_bondCnt].rij = dd;
		//m_bonding[m_bondCnt].view = innerflag;

//		m_neighbor[i].NbPrt[iprt] = j;
//		m_neighbor[j].NbPrt[jprt] = i;

		m_bondCnt++;
		if(m_bondCnt >= m_ijmax){
			m_bondCnt = 0;
		}
		
		return 1;
	}
	return 0;
}


void ListupBond::GetBondingPointers(int* bcnt, SIMPLE_BONDING** bonding){
	*bcnt = m_bondCnt;
	*bonding = m_bonding;
}

int ListupBond::GetInsideBondCount(){
	return m_bondInsideCnt;
}


void ListupBond::GetNeighborPointers(NEIGHBOR_LIST** neighbor){
	*neighbor = m_neighbor;
}