#ifndef __ListupBond_h__
#define __ListupBond_h__


#include "vec3.h"
#include "atomarray.h"
#include "celldiv.h"
#include "debugprint.h"


#define		BOND_CNT	12


struct NEIGHBOR_LIST{
	int NbCnt;
	//int NbPrt[BOND_CNT];
};


struct SIMPLE_BONDING{
	int i;
	int j;
	vec3d rij;
};


class ListupBond : public CellDiv {
private:
		int m_ijmax;
	
		int m_bondCnt;
		int m_bondInsideCnt;
		double m_Dmax[3];
		double m_Dmax2[3];
		
		NEIGHBOR_LIST* m_neighbor;

		SIMPLE_BONDING* m_bonding;

		inline int AddBondByCutOff(int i, int j, int ki, int kj, int innerflag, vec3d& dd);

		int* m_knd;
		vec3d* m_r;

		
	void Clear(int count);

public:

	ListupBond(int maxcount, double maxlength);
	virtual ~ListupBond();

	void SetListOrtho(int count);
	void SetListNonortho(int count);

	void SetParticlePointers(int* kind, vec3d* positions);

	void GetBondingPointers(int* bcnt, SIMPLE_BONDING** bonding);
	int GetInsideBondCount();
	void GetNeighborPointers(NEIGHBOR_LIST** neighbor);

};


#endif    // __ListupBond_h__
