
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "MDLoader.h"
//#include "AtomRendererGL.h"
#include "ListupBond.h"
#include "ai_gr.h"
//#include "ai_funcs.h"
#include "ai_molecule.h"
#include "rebojf.h"
#include "debugprint.h"

#pragma warning(disable : 4996)



int GetPairDistFunc(ATOMS_DATA *dat, int atmKind, double dr, float* nr){
//az֐߂.
//dr: qXgO̍ݕ(a)
//vZԂO(N^2)

	//int i, k;
	vec3f ri;
	vec3f rki;
	vec3f box;	// box of xyz
	vec3f bh;	// box half of xyz
	float rr, rr2;
	
	int* knd;
	vec3f* r;

	int idx;
	int cnt = 0;


	if (!dat) {return -1;}
	if (dat->pcnt <= 0) {return -2;}
	
	
	knd = dat->knd;
	r = dat->r;
	
	box.x = (dat->boxaxis.m11);
	box.y = (dat->boxaxis.m22);
	box.z = (dat->boxaxis.m33);
	bh = box / 2.0f;
	
	if (atmKind == KIND_ALL){
		for(int i = 0; i < dat->pcnt; i++){
			ri = r[i];
			cnt++;

			for(int k = i+1; k < dat->pcnt; k++){
				rki = r[k] - ri;
				
				rki.x = fabs(rki.x);
				rki.y = fabs(rki.y);
				rki.z = fabs(rki.z);

				if(rki.x > bh.x){ rki.x = box.x - rki.x;}
				if(rki.y > bh.y){ rki.y = box.y - rki.y;}
				if(rki.z > bh.z){ rki.z = box.z - rki.z;}
				
				rr2 = rki*rki;
				rr = (float)sqrt(rr2);

				//double -> int cast0֐؂̂
				idx = (int)(rr / dr + 0.5);
				nr[idx] += 2.0;
			}
		}
	}else{
		for(int i = 0; i < dat->pcnt; i++){
			if(atmKind != knd[i]) continue;
			ri = r[i];
			cnt++;

			for(int k = i+1; k < dat->pcnt; k++){
				if(atmKind != knd[k]) continue;
				rki = r[k] - ri;
				
				rki.x = fabs(rki.x);
				rki.y = fabs(rki.y);
				rki.z = fabs(rki.z);

				if(rki.x > bh.x){ rki.x = box.x - rki.x;}
				if(rki.y > bh.y){ rki.y = box.y - rki.y;}
				if(rki.z > bh.z){ rki.z = box.z - rki.z;}
				
				rr2 = rki*rki;
				rr = (float)sqrt(rr2);

				//double -> int cast0֐؂̂
				idx = (int)(rr / dr + 0.5);
				nr[idx] += 2.0;
				
			}
		}
	}

	//JEgqԂ
	return cnt;

}

/*
int AI_GetPairDistFuncPart(ATOMS_DATA *dat, char atmKind, double dr, float* nr, int sindex){

	int i, k;
	vec3f ri;
	vec3f rki;
	vec3f box;	// box of xyz
	vec3f bh;	// box half of xyz
	float rr, rr2;
	
	int* knd;
	vec3f* r;
	double FIN;

	int idx;
	int cnt = 0;


	if (!dat) {return -1;}
	if (dat->pcnt <= 0) {return -2;}
	
	FIN = sindex + 160;
	if(FIN > dat->pcnt){ FIN = dat->pcnt;}

	knd = dat->knd;
	r = dat->r;
	
	box.x = dat->boxaxis.m11;
	box.y = dat->boxaxis.m22;
	box.z = dat->boxaxis.m33;
	bh = box / 2.0f;
	
	if (atmKind == KIND_ALL){
		for(i = sindex; i < FIN; i++){
			ri = r[i];
			cnt++;

			for(k = i+1; k < FIN; k++){
				rki = r[k] - ri;
				
				rki.x = (float)fabs(rki.x);
				rki.y = (float)fabs(rki.y);
				rki.z = (float)fabs(rki.z);

				if(rki.x > bh.x){ rki.x = box.x - rki.x;}
				if(rki.y > bh.y){ rki.y = box.y - rki.y;}
				if(rki.z > bh.z){ rki.z = box.z - rki.z;}
				
				rr2 = rki*rki;
				rr = (float)sqrt(rr2);

				//double -> int cast0֐؂̂
				idx = (int)(rr / dr + 0.5);
				nr[idx] += 2.0;
			}
		}
	}else{
		for(i = sindex; i < FIN; i++){
			if(atmKind != knd[i]) continue;
			ri = r[i];
			cnt++;

			for(k = i+1; k < FIN; k++){
				if(atmKind != knd[k]) continue;
				rki = r[k] - ri;
				
				rki.x = (float)fabs(rki.x);
				rki.y = (float)fabs(rki.y);
				rki.z = (float)fabs(rki.z);

				if(rki.x > bh.x){ rki.x = box.x - rki.x;}
				if(rki.y > bh.y){ rki.y = box.y - rki.y;}
				if(rki.z > bh.z){ rki.z = box.z - rki.z;}
				
				rr2 = rki*rki;
				rr = (float)sqrt(rr2);

				//double -> int cast0֐؂̂
				idx = (int)(rr / dr + 0.5);
				nr[idx] += 2.0;
				
			}
		}
		printf("%d,%d\n",sindex,FIN);
	}

	//JEgqԂ
	return cnt;

}
*/

void WriteRadialDistFunc(double dr, ATOMS_DATA *dat, const TCHAR* spath){
	double rr = dat->boxaxis.m11 * dat->boxaxis.m11;
	rr += dat->boxaxis.m22 * dat->boxaxis.m22;
	rr += dat->boxaxis.m33 * dat->boxaxis.m33;

	int cnt = (int)(sqrt(rr) / dr) + 1;
	float *nr = new float[cnt];
	memset(nr, 0, sizeof(float)*cnt);

	//calculation of radial distribution function

	int N = GetPairDistFunc(dat,KIND_ALL,dr,nr);
	//N = AI_GetPairDistFunc(dat,KIND_C,dr,nr);
	if(N > 0){

		FILE *fp;
		double rr, gr;
		const double PI4 = 3.141592653589793 * 4.0;
		double N_d = (double)N;

		printf("N=%d\n",N);

		fp = _tfopen(spath,_T("w"));
		if( fp == NULL ){  // ֐sĂȂ
			printf( "t@C̃I[vɎs܂\n");
			return;  // ُI͂OȊOԂ
		}

		_ftprintf(fp, _T("time_step = %d\n"),dat->istep);
		_ftprintf(fp, _T("#index\t r\t g(r)\t T\n"));
		for (int i = 1; i < cnt; i++){
			rr = (dr * ((double)i));
			gr = ((double)nr[i]) / (PI4 * rr * rr * dr * N_d);
			_ftprintf(fp, _T(" %d\t%lf\t%lf\t%f\n"), i, rr, gr, dat->tempave);
		}

		fclose(fp);

	}
	delete [] nr;
}


/*
void WriteRadialDistFuncLayer(double dr, MDLoader* a_atm, int frameskip, const TCHAR* spath){
	
	ATOMS_DATA *dat = a_atm->GetDataPointer();
	int cnt = (int)(dat->boxaxis.m33 / dr) + 1;
	int precnt = (int)(dat->boxaxis.m11 / (dr*2.0)) + 1;
	float *nr = new float[cnt];

	int i, N, k;
	//int nono = 0;
	
	FILE *fp;
	double rr, gr;
	const double PI4 = 3.141592653589793 * 4.0;
	double Ni;
	double ryo;

	double grMax,rrMax;

	fp = _tfopen(spath,_T("w"));
	if( fp == NULL ){  // ֐sĂȂ
		printf( "t@C̃I[vɎs܂\n");
		return;  // ُI͂OȊOԂ
	}


	_ftprintf(fp, _T("#dr = %lf\n"), dr);
	//for (i = 1; i < precnt; i++){
	//	rr = (dr * ((double)i));
	//	_ftprintf(fp, "\t%d:%lf", i+2,rr);
	//}

	//_ftprintf(fp, "\n#index\t T\t g(r)---\n");
	_ftprintf(fp, _T("#index\t T\t r\t max(g(r))\n"));
	
	ryo = (160.0 - 8.0) / (dat->boxaxis.m11 * dat->boxaxis.m22);

	while(1){
		
		
		_ftprintf(fp, _T(" %d\t%f"), dat->istep, dat->tempave);

		//calculation of radial distribution function
		for (k=0;k<8;k++){
			
			for (i=0;i<cnt;i++){
				nr[i] = 0.0;
			}
			N = AI_GetPairDistFuncPart(dat,KIND_C,dr,nr,k*160);
			if(N <= 0){
				printf("az֐̎擾Ɏs܂\n");
				_ftprintf(fp, _T(" \t%lf\t%lf"), 0.0, 0.0);
			}else{
			

			Ni = 1.0 / (double)N;
			
			printf("step = %d,\t N=%d\n",dat->istep,N);
			
			grMax = 0.0;
			for (i = 1; i < cnt; i++){
				rr = (dr * ((double)i));
				gr = ((double)nr[i]) / (PI4 * rr * rr * dr * ryo);
				gr *= Ni;
				
				if(gr > grMax){
					grMax = gr;
					rrMax = rr;
				}
			
			}
			_ftprintf(fp, _T(" \t%lf\t%lf"), rrMax, grMax);
			//_ftprintf(fp, " %d\t%lf\t%lf\t%f\n", nono, rrMax, grMax, dat->tempave);
			//nono += 2000;
			}
		}

		_ftprintf(fp, _T("\n"), dat->istep, rrMax, grMax, dat->tempave);

		if(frameskip > 1){
			if (a_atm->goNext(frameskip) == 0){
				break;
			}
		}else{		
			if (a_atm->goNext() == 0){
				break;
			}
		}
		dat = a_atm->GetDataPointer();
	
	}
	
	fclose(fp);
	delete [] nr;
}
*/

void WriteRadialDistFuncMax(double dr, MDLoader* a_atm, int frameskip, const TCHAR* spath){
	
	ATOMS_DATA *dat = a_atm->GetDataPointer();
	int cnt = (int)(dat->boxaxis.m33 / dr) + 1;
	int precnt = (int)(dat->boxaxis.m11 / (dr*2.0)) + 1;
	float *nr = new float[cnt];
	int i, N;
	//int nono = 0;
	
	FILE *fp;
	double rr, gr;
	const double PI4 = 3.141592653589793 * 4.0;
	double Ni;

	double grMax,rrMax;

	fp = _tfopen(spath,_T("w"));
	if( fp == NULL ){  // ֐sĂȂ
		printf( "t@C̃I[vɎs܂\n");
		return;  // ُI͂OȊOԂ
	}


	_ftprintf(fp, _T("#dr = %lf\n"), dr);
	//for (i = 1; i < precnt; i++){
	//	rr = (dr * ((double)i));
	//	_ftprintf(fp, "\t%d:%lf", i+2,rr);
	//}

	//_ftprintf(fp, "\n#index\t T\t g(r)---\n");
	_ftprintf(fp, _T("#index\t r\t max(g(r))\t T\n"));
	
	while(1){
		
		for (i=0;i<cnt;i++){
			nr[i] = 0.0;
		}

		//calculation of radial distribution function
		N = GetPairDistFunc(dat,KIND_C,dr,nr);
		if(N <= 0){
			printf("az֐̎擾Ɏs܂\n");
			break;
		}
		
		Ni = 1.0 / (double)N;
		
		printf("step = %d,\t N=%d\n",dat->istep,N);
		

		//_ftprintf(fp, " %d\t%f", dat->istep, dat->tempave);
		//for (i = 1; i < precnt; i++){
		//	rr = (dr * ((double)i));
		//	gr = ((double)nr[i]) / (PI4 * rr * rr * dr);
		//	gr *= Ni;
		//	_ftprintf(fp, "\t%lf", gr);
		//
		//}
		//_ftprintf(fp, "\n");
		
		grMax = 0.0;
		for (i = 1; i < precnt; i++){
			rr = (dr * ((double)i));
			gr = ((double)nr[i]) / (PI4 * rr * rr * dr);
			gr *= Ni;
			
			if(gr > grMax){
				grMax = gr;
				rrMax = rr;
			}
		
		}
		_ftprintf(fp, _T(" %d\t%lf\t%lf\t%f\n"), dat->istep, rrMax, grMax, dat->tempave);
		//_ftprintf(fp, " %d\t%lf\t%lf\t%f\n", nono, rrMax, grMax, dat->tempave);
		//nono += 2000;

		if(frameskip > 1){
			if (a_atm->goNext(frameskip) == 0){
				break;
			}
		}else{		
			if (a_atm->goNext() == 0){
				break;
			}
		}
		dat = a_atm->GetDataPointer();
	}
	
	fclose(fp);
	delete [] nr;
}



void WriteErosionYield(double limZ, MDLoader* a_atm, int frameskip, const TCHAR* spath){
	
	ATOMS_DATA *dat = a_atm->GetDataPointer();
	int precnt;
	int i;
	int step = 0;

	FILE *fp;

	fp = _tfopen(spath,_T("w"));
	if( fp == NULL ){  // ֐sĂȂ
		printf( "t@C̃I[vɎs܂\n");
		return;  // ُI͂OȊOԂ
	}


	_ftprintf(fp, _T("#limit_z = %lf\n"), limZ);
	precnt = dat->pcnt;
	//_ftprintf(fp, "#initial carbon = %d\n", dat->pcnt);
	_ftprintf(fp, _T("#time,  num_of_particle, num_under_limZ"));
	
	while(1){
		
		int cnt = 0;
		for (i=0;i<dat->pcnt;i++){
			if(dat->knd[i] == KIND_C){
				if (dat->r[i].z <= limZ){
					cnt ++;
				}
			}
		}

		
		printf("step = %d,\t N=%d, erosion=%d\n",dat->istep,dat->pcnt,cnt);	//yield == precnt - cnt ?
		
		_ftprintf(fp, _T(" %d\t%d\t%d\n"), dat->istep, dat->pcnt, cnt);
		//_ftprintf(fp, " %d\t%lf\t%lf\t%f\n", nono, rrMax, grMax, dat->tempave);
		//nono += 2000;
		
		step+=2000*frameskip;

		if(frameskip > 1){
			if (a_atm->goNext(frameskip) == 0){
				break;
			}
		}else{		
			if (a_atm->goNext() == 0){
				break;
			}
		}
		dat = a_atm->GetDataPointer();
	}
	
	fclose(fp);
}



void WriteCoordinateC(MDLoader* a_atm, int frameskip, const TCHAR* spath){
	
	ATOMS_DATA *dat = a_atm->GetDataPointer();
	int oldcnt;
	int i;

	FILE *fp;
	int *NbCnt;
	int crdnt[12];

	fp = _tfopen(spath,_T("w"));
	if( fp == NULL ){  // ֐sĂȂ
		printf( "t@C̃I[vɎs܂\n");
		return;  // ُI͂OȊOԂ
	}


	_ftprintf(fp, _T("#Number_of_C_having_coordinate_Column\n"));
	_ftprintf(fp, _T("#step\tpcnt\tbcnt\tsolo\ttips\tsp1\tsp2\tsp3\n"));
	
	oldcnt = dat->pcnt;
	NbCnt = new int[dat->pcnt];
	for (i=0;i<(dat->pcnt);i++){
		NbCnt[i] = 0;
	}
	
	while(1){
		
		
		if(oldcnt != dat->pcnt){
			delete [] NbCnt;
			oldcnt = dat->pcnt;
			NbCnt = new int[dat->pcnt];
		}

		for (i=0;i<(dat->pcnt);i++){
			NbCnt[i] = 0;
		}

		for (SIMPLE_IJ* b = dat->bonds; b != dat->bonds + dat->bcnt; b++){
			
			//if(dat->knd[li] == KIND_H){continue;}
			//if(dat->knd[lj] == KIND_H){continue;}

			NbCnt[b->i]++;
			NbCnt[b->j]++;
		}

		memset(crdnt,0,sizeof(int)*12);

		for (i=0;i<dat->pcnt;i++){
			if(dat->knd[i] == KIND_C){
				crdnt[NbCnt[i]]++;
			}
		}

		
		printf("step = %d,\t N=%d, tip:sp1:sp2:sp3=%d:%d:%d:%d\n",
			dat->istep,dat->pcnt, crdnt[1],crdnt[2],crdnt[3],crdnt[4]);
		
		_ftprintf(fp, _T(" %d\t%d\t%d"), dat->istep, dat->pcnt, dat->bcnt);
		for (i=0;i<12;i++){
			_ftprintf(fp, _T("\t%d"),crdnt[i]);				
		}
		_ftprintf(fp, _T("\n"));

		if(frameskip > 1){
			if (a_atm->goNext(frameskip) == 0){
				break;
			}
		}else{		
			if (a_atm->goNext() == 0){
				break;
			}
		}
		dat = a_atm->GetDataPointer();
	}
	
	fclose(fp);
}


//fː
void WriteCoordinateC2(MDLoader* a_atm, int frameskip, const TCHAR* spath){
	
	ATOMS_DATA *dat = a_atm->GetDataPointer();
	int oldcnt;
	int i;

	FILE *fp;
	int *NbCnt;
	int crdnt[12];
	int bondnum[3];

	fp = _tfopen(spath,_T("w"));
	if( fp == NULL ){  // ֐sĂȂ
		printf( "t@C̃I[vɎs܂\n");
		return;  // ُI͂OȊOԂ
	}


	_ftprintf(fp, _T("#Number_of_C_having_coordinate_Column\n"));
	_ftprintf(fp, _T("#step\tIncidentH\tpcnt\tbcnt\tC-C\tC-H\tH-H\tsolo\ttips\tsp1\tsp2\tsp3\n"));
	
	oldcnt = dat->pcnt;
	NbCnt = new int[dat->pcnt];
	for (i=0;i<(dat->pcnt);i++){
		NbCnt[i] = 0;
	}
	
	int flag = 0;
	int IncidentH = 0;

	while(1){
		
		if( ( dat->istep / 2 ) * 2 != dat->istep){
			flag = 1;
		}else{
			if(flag == 1){
				IncidentH ++;
			}
			flag = 0;
		}
		
		if(oldcnt != dat->pcnt){
			delete [] NbCnt;
			oldcnt = dat->pcnt;
			NbCnt = new int[dat->pcnt];
		}

		for (i=0;i<(dat->pcnt);i++){
			NbCnt[i] = 0;
		}

	
		for (SIMPLE_IJ* b = dat->bonds; b != dat->bonds + dat->bcnt; b++){
			
			//if(dat->knd[li] == KIND_H){continue;}
			//if(dat->knd[lj] == KIND_H){continue;}

			NbCnt[b->i]++;
			NbCnt[b->j]++;
		}

		memset(crdnt,0,sizeof(int)*12);

		for (i=0;i<dat->pcnt;i++){
			if(dat->knd[i] == KIND_C){
				crdnt[NbCnt[i]]++;
			}
		}

		//C-C bond, C-H bond, H-H bond𐔂
		memset(bondnum, 0, sizeof(int) * 3);

		for (SIMPLE_IJ* b = dat->bonds; b != dat->bonds + dat->bcnt; b++){

			switch( dat->knd[b->i] ){
			case KIND_C:
				switch( dat->knd[b->j]){
				case KIND_C:
					bondnum[0] ++;
					break;
				case KIND_H:
					bondnum[1] ++;
					break;
				}
				break;
			case KIND_H:
				switch( dat->knd[b->j]){
				case KIND_C:
					bondnum[1] ++;
					break;
				case KIND_H:
					bondnum[2] ++;
					break;
				}
				break;
			}
		}
		
		printf("step = %d,\t N=%d, tip:sp1:sp2:sp3=%d:%d:%d:%d\n",
			dat->istep,dat->pcnt, crdnt[1],crdnt[2],crdnt[3],crdnt[4]);
		
		_ftprintf(fp, _T(" %d\t%d\t%d\t%d"), dat->istep, IncidentH, dat->pcnt, dat->bcnt);
		_ftprintf(fp, _T("\t%d\t%d\t%d"), bondnum[0], bondnum[1],bondnum[2]);
		for (i=0;i<12;i++){
			_ftprintf(fp, _T("\t%d"),crdnt[i]);				
		}
		_ftprintf(fp, _T("\n"));

		if(frameskip > 1){
			if (a_atm->goNext(frameskip) == 0){
				break;
			}
		}else{		
			if (a_atm->goNext() == 0){
				break;
			}
		}
		dat = a_atm->GetDataPointer();
	}
	
	fclose(fp);
}

void WriteHCRatio(MDLoader* a_atm, int frameskip, const TCHAR* spath){
	
	ATOMS_DATA *dat = a_atm->GetDataPointer();
	int i;

	FILE *fp;
	int hcnt,ccnt;

	fp = _tfopen(spath,_T("w"));
	if( fp == NULL ){  // ֐sĂȂ
		printf( "t@C̃I[vɎs܂\n");
		return;  // ُI͂OȊOԂ
	}


	_ftprintf(fp, _T("# H/C ratio\n"));
	_ftprintf(fp, _T("#step\tIncidentH\tTotal\tH-atom\tC-atom\tH/C\tT\n"));
	
	int flag = 0;
	int IncidentH = 0;

	while(1){
		
		hcnt = ccnt = 0;

		for (i=0;i<(dat->pcnt);i++){
			if(dat->knd[i] == 0){
				ccnt ++;
			}else if (dat->knd[i] == 1){
				hcnt ++;
			}
		}


		if( ( dat->istep / 2 ) * 2 != dat->istep){
			flag = 1;
		}else{
			if(flag == 1){
				IncidentH ++;
			}
			flag = 0;
		}

		
		_ftprintf(fp, _T(" %d\t%d\t%d\t%d\t%d\t%15.7lf\t%f\n"), dat->istep, IncidentH, dat->pcnt, hcnt, ccnt, ((double)hcnt)/((double)ccnt), dat->tempave);
		

		if(frameskip > 1){
			if (a_atm->goNext(frameskip) == 0){
				break;
			}
		}else{		
			if (a_atm->goNext() == 0){
				break;
			}
		}
		dat = a_atm->GetDataPointer();
	}
	
	fclose(fp);
}



int* clasifyMolecule(ATOMS_DATA *dat, int* ret_count){
//bondmolculerIDU
//߂l̔z͗qƓTCY
//z̒g͕qID(0A)


	int* mol;
	
	int* id = dat->id;
	
	vec3f r_ik;
	float rr;
	
	int* knd = dat->knd;
	vec3f* r = dat->r;
	const float bondmin[] = {1.85f*1.85f, 1.55f*1.55f, 1.4f*1.4f};
	

	int i, k;
	int molid, subid;

	//id
	mol = new int[dat->pcnt];
	for(i=0;i<dat->pcnt;i++){
		mol[i] = -i-1;	//ŌɎRŐ邽߂ɁAvZ͕l
	}

	//id̓

	for(SIMPLE_IJ* b = dat->bonds;b != dat->bonds + dat->bcnt; b++){
		
		r_ik = r[b->i] - r[b->j];
		r_ik.x = (float)fperiodic(r_ik.x, dat->boxaxis.m11);
		r_ik.y = (float)fperiodic(r_ik.y, dat->boxaxis.m22);
		r_ik.z = (float)fperiodic(r_ik.z, dat->boxaxis.m33);

		rr = r_ik * r_ik;

		if (rr <= bondmin[(knd[b->i] & 0x01) + (knd[b->j] & 0x01)] ){
			
			//molid = mol[id[li[b]]-1];	//Kidēǂ݂ɍs
			//subid = mol[id[lj[b]]-1];

			molid = mol[b->i];
			subid = mol[b->j];
			if(molid != subid){
				for(i=0;i<dat->pcnt;i++){
					if(mol[i] == subid){ mol[i] = molid;}
				}
			}
		}
	}


	//id0珇
	molid = 0;
	for(i=0;i<dat->pcnt;i++){
		if(mol[i] < 0){
			subid = mol[i];
			mol[i] = molid;

			for(k=i+1;k<dat->pcnt;k++){
				if (mol[k] == subid){ mol[k] = molid;}
			}
			//subid = molid;
			molid ++;
		}
	}

	if(ret_count){*ret_count = molid;}
	return mol;
	
}




void WriteCombineMol(MDLoader* a_atm, const TCHAR* spath){
	//قȂ镪qԂ̌JEg
	ATOMS_DATA *dat;
	
	FILE *fp;
	int *mol;
	int numDL;	//bond between different layer
	int numCC,numCH,numHH;	//C-C, C-H and H-H bonds

	fp = _tfopen(spath,_T("w"));
	if( fp == NULL ){  // ֐sĂȂ
		printf( "t@C̃I[vɎs܂\n");
		return;  // ُI͂OȊOԂ
	}

	dat = a_atm->GetDataPointer();
	//݂̏Ԃ𕪎q̕ނƂ
	mol = clasifyMolecule(dat, NULL);

	//ɖ߂
	a_atm->goFirst();
	dat = a_atm->GetDataPointer();
	


	_ftprintf(fp, _T("#Count_bond_between_different_mols\n"));
	_ftprintf(fp, _T("#step\tcount\ttotalbond\n"));
	
	
	while(1){
		
		numDL = numCC = numCH = numHH = 0;

		for (SIMPLE_IJ* b = dat->bonds; b != dat->bonds + dat->bcnt;b++){
			int li = b->i;
			int lj = b->j;
			
			if(dat->knd[li] == KIND_C){
				if(dat->knd[lj] == KIND_C){
					numCC++;
					
					if(mol[dat->id[li]-1] != mol[dat->id[lj]-1]) {numDL++;}

				}else if(dat->knd[lj] == KIND_H){
					numCH++;
				}
			}else if(dat->knd[li] == KIND_H){
				if(dat->knd[lj] == KIND_C){
					numCH++;					
				}else if(dat->knd[lj] == KIND_H){
					numHH++;
				}
			}
		}
		
		printf("step = %d, \totalbond=%d, diff-lyr=%d\n", dat->istep,dat->bcnt,numDL);
		
		_ftprintf(fp, _T(" %d\t%d\t%d\t%d\t%d\t%d\n"), dat->istep, dat->bcnt, numDL, numCC,numCH,numHH);
		
		if (a_atm->goNext() == 0){
			break;
		}
		
		dat = a_atm->GetDataPointer();
	}
	
	fclose(fp);
}




void WriteClassifiedMolecule(MDLoader* a_atm, int frameskip, const TCHAR* spath){
	
	ATOMS_DATA *dat = a_atm->GetDataPointer();
	int i;

	FILE *fp;
//	int hcnt,ccnt;
	int* mol = NULL;

	int flag = 0;
	int IncidentH = 0;
	int molid;
	int init_pcnt = dat->pcnt;

	struct FrameMolInfo{
		struct MolType *pMolType;
		MolType** ppMT;
		int injected_H;
		FrameMolInfo* next;
	};

	FrameMolInfo* frameMol_fst = new FrameMolInfo;
	FrameMolInfo* frameMol = frameMol_fst;
	frameMol_fst->next = NULL;

	//struct MolType *pMolType_fst = NULL;
	//struct MolType *pMolType = pMolType_fst;
	int molcnt;

	while(1){
				
	//fː̃JEg(Ӗsdl)
		if( ( dat->istep / 2 ) * 2 != dat->istep){
			flag = 1;
		}else{
			if(flag == 1){
				IncidentH ++;
			}
			flag = 0;
		}
//TRACE(_T("shot %d\n"), IncidentH);
	//q̕
		int *mol = clasifyMolecule(dat, &molcnt);
		frameMol->pMolType = new MolType[molcnt];
		memset(frameMol->pMolType, 0, sizeof(MolType) * molcnt);
		frameMol->ppMT = new MolType*[init_pcnt];
		
		for (i=0;i<(dat->pcnt);i++){
			molid = mol[i];
			if(dat->knd[i] == KIND_C){
				frameMol->pMolType[molid].Cn ++;
			}else if (dat->knd[i] == KIND_H){
				frameMol->pMolType[molid].Hn ++;
			}

			if(dat->id[i]-1 < init_pcnt){
				frameMol->ppMT[dat->id[i]-1] = &(frameMol->pMolType[molid]);
			}
		}

		frameMol->injected_H = IncidentH;

		delete [] mol;

		
		//_ftprintf(fp, _T(" %d\t%d\t%d\t%d\t%d\t%15.7lf\t%f\n"), dat->istep, IncidentH, dat->pcnt, hcnt, ccnt, ((double)hcnt)/((double)ccnt), dat->tempave);
		

		if(frameskip > 1){
			int dummyframe = 1;
			while(dummyframe < frameskip){
				if (a_atm->goNext(frameskip) == 0){
					dummyframe = -1;
					break;
				}else{
					//fː̃JEg(Ӗsdl)
					if( ( dat->istep / 2 ) * 2 != dat->istep){
						flag = 1;
					}else{
						if(flag == 1){
							IncidentH ++;
						}
						flag = 0;
					}
				}
				dummyframe ++;
			}

			if(dummyframe == -1){
				break;
			}
			
		}else{		
			if (a_atm->goNext() == 0){
				break;
			}
		}

		dat = a_atm->GetDataPointer();
		frameMol->next = new FrameMolInfo;
		frameMol = frameMol->next;
		frameMol->next = NULL;
		
	}
	
	//t@Cւ̏o
	
	fp = _tfopen(spath,_T("w"));
	if( fp == NULL ){  // ֐sĂȂ
		printf( "t@C̃I[vɎs܂\n");
		return;  // ُI͂OȊOԂ
	}
	
	_ftprintf(fp, _T("# CHx carbons\n"));
	_ftprintf(fp, _T("# ID, InjectedH, CH4_from\n"));

	TCHAR fname_p[MAX_PATH];
	MolType* mt;
	MolType* mt_prev = NULL;
	
	for (i=0;i<init_pcnt;i++){
		//Ĉ݂Ɖ(b)

		_tcscpy(fname_p, spath);
		//*(fname_p + _tcslen(spath) - 4) = _T('\0');
		_itot(i, fname_p + _tcslen(spath) - 4, 10);
		_tcscat(fname_p, _T(".txt"));
			
		
		FILE* fp2 = _tfopen(fname_p,_T("w"));
		_ftprintf(fp2, _T("# Molecular growth of the %d particle\n"), i);
		_ftprintf(fp2, _T("# InjectedH\tMolecule\n"), i);
		
		int flagCHx = 0;

		frameMol = frameMol_fst;
		mt_prev = NULL;
		while(frameMol){
			mt = frameMol->ppMT[i];

			_ftprintf(fp2, _T(" %d\tC%dH%d\n"), frameMol->injected_H, mt->Cn, mt->Hn);

			if((mt->Cn == 1) && (mt->Hn == 4) ){
				if(flagCHx != 4){
					_ftprintf(fp, _T("%d\t%d\tC%dH%d\n"), i,frameMol->injected_H, mt_prev->Cn, mt_prev->Hn);
					flagCHx = 4;
				}
			}else{
				flagCHx = 0;
			}

			frameMol = frameMol->next;
			mt_prev = mt;
		}
		
		
		fclose(fp2);





	}



	//_ftprintf(fp, _T("#step\tIncidentH\tTotal\tH-atom\tC-atom\tH/C\tT\n"));
	
	fclose(fp);

	//J
	
	while(frameMol = frameMol_fst){
		delete [] frameMol->ppMT;
		delete [] frameMol->pMolType;
		frameMol_fst = frameMol->next;
		delete frameMol;
	}

}





void WriteClassifiedMolecule2(MDLoader* a_atm, int frameskip, const TCHAR* spath){
	
	ATOMS_DATA *dat = a_atm->GetDataPointer();
	int i, k,s;

	FILE *fp;
//	int hcnt,ccnt;
	int* mol = NULL;
	int* mol_prev = NULL;

	int flag = 0;
	int IncidentH = 0;
	int molid;
	int init_pcnt = dat->pcnt;

	struct FrameMolInfo{
		struct MolType *pMolType;
		MolType** ppMT;
		int injected_H;
		int* molIDs;
		int molCnt;
		FrameMolInfo* next;
	};

	
	
	//t@Cւ̏o
	
	TCHAR fname[MAX_PATH];
	_tcscpy(fname, spath);
	_tcscat(fname, _T("_ch4_growth.txt"));
	fp = _tfopen(fname,_T("w"));
	if( fp == NULL ){  // ֐sĂȂ
		printf( "t@C̃I[vɎs܂\n");
		return;  // ُI͂OȊOԂ
	}
	_ftprintf(fp, _T("# CHx carbons\n"));
	_ftprintf(fp, _T("# If lifetime is 0, CH4 is created."));
	_ftprintf(fp, _T("# step, InjectedH, CH4num, C_ID, lifetime,srcMol, with 1, with 2,,,\n"));

	
	TCHAR fname2[MAX_PATH];
	_tcscpy(fname2, spath);
	_tcscat(fname2, _T("_chx.txt"));
	
	FILE* fp2 = _tfopen(fname2,_T("w"));
	_ftprintf(fp2, _T("# step, InjectedH, C, CH, CH2, CH3, CH4, CH5-,")
			_T("C2, C2H, C2H2, C2H3, C2H4, C2H5, C2H6, C2H7--\n"));

	TCHAR fname3[MAX_PATH];
	_tcscpy(fname3, spath);
	_tcscat(fname3, _T("_chx_source.txt"));
	
	FILE* fp3 = _tfopen(fname3,_T("w"));
	_ftprintf(fp3, _T("# CHx, total, C, CH, CH2, CH3, CH4, other\n"));


	FrameMolInfo* frameMol_fst = new FrameMolInfo;
	FrameMolInfo* frameMol_prev = NULL;
	FrameMolInfo* frameMol = frameMol_fst;
	frameMol_fst->next = NULL;

	ATOMS_DATA *dat_prev=NULL;
	int molcnt;
	int *flagsCH4 = new int[init_pcnt];
	memset(flagsCH4, 0, init_pcnt*sizeof(int));

	
	int C_mol;
	int C_id;
	int CH_IDs[5];
	int Hcnt;
	int C_mol_prev;
	int CH_mol_prev[5];
	int k_id;
	int CH4num = 0;
	
	int CH0_from[6];	//CH0_from[n]  CHn -> CH0 ̐
	int CH1_from[6];	//CH1_from[n]  CHn -> CH1 ̐
	int CH2_from[6];	//CH2_from[n]  CHn -> CH2 ̐
	int CH3_from[6];	//CH3_from[n]  CHn -> CH3 ̐
	int CH4_from[6];	//CH4_from[n]  CHn -> CH4 ̐
	memset(CH0_from, 0, sizeof(int) * 6);
	memset(CH1_from, 0, sizeof(int) * 6);
	memset(CH2_from, 0, sizeof(int) * 6);
	memset(CH3_from, 0, sizeof(int) * 6);
	memset(CH4_from, 0, sizeof(int) * 6);


	while(1){
				
	//fː̃JEg(Ӗsdl)
		if( ( dat->istep / 2 ) * 2 != dat->istep){
			flag = 1;
		}else{
			if(flag == 1){
				IncidentH ++;
			}
			flag = 0;
		}
//TRACE(_T("shot %d\n"), IncidentH);
	//q̕
		int *mol = clasifyMolecule(dat, &molcnt);
		frameMol->molIDs = mol;
		frameMol->molCnt = molcnt;
		frameMol->pMolType = new MolType[molcnt];
		memset(frameMol->pMolType, 0, sizeof(MolType) * molcnt);
		frameMol->ppMT = new MolType*[init_pcnt];
		memset(frameMol->ppMT, 0, sizeof(MolType*) * init_pcnt);
		
		
		for (i=0;i<(dat->pcnt);i++){
			molid = mol[i];
			if(dat->knd[i] == KIND_C){
				frameMol->pMolType[molid].Cn ++;
			}else if (dat->knd[i] == KIND_H){
				frameMol->pMolType[molid].Hn ++;
			}

			if(dat->id[i]-1 < init_pcnt){
				frameMol->ppMT[dat->id[i]-1] = &(frameMol->pMolType[molid]);
			}
		}

		frameMol->injected_H = IncidentH;

		/*
		for (i=0;i<init_pcnt;i++){
			if(frameMol->ppMT[i] == NULL){
					int ccnt = 0;
				for (k=0;k<dat->pcnt;k++){
					if(dat->knd[k] == KIND_C){
						ccnt++;
					}
					if(dat->id[k] == i + 1){
						break;					
					}
				}
				if(k == dat->pcnt){
					//frameMol->ppMT[i]->Xn = frameMol->ppMT[i]->count;
				}
			}
		}
		*/

		//CHx,C2HxJEg
		int CHxnum[6];
		int C2Hxnum[8];
		memset(CHxnum, 0, sizeof(int)*6);
		memset(C2Hxnum, 0, sizeof(int)*8);
		for (i=0;i<init_pcnt;i++){
			//͒YfƉ
			MolType* mt = frameMol->ppMT[i];	//NULLȂCsimbox狏ȂȂ
			if(mt){
				if(mt->Cn == 1){
					if (mt->Hn <= 4){
						CHxnum[mt->Hn]++;
					}else{
						CHxnum[5]++;
					}
				}else if(mt->Cn == 2){
					if (mt->Hn <= 6){
						C2Hxnum[mt->Hn]++;
					}else{
						C2Hxnum[7]++;
					}
				}
			}
		}

		_ftprintf(fp2, _T(" %d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\n"),
					dat->istep, IncidentH,
					CHxnum[0], CHxnum[1], CHxnum[2], CHxnum[3], CHxnum[4], CHxnum[5],
					C2Hxnum[0]/2, C2Hxnum[1]/2, C2Hxnum[2]/2, C2Hxnum[3]/2, 
					C2Hxnum[4]/2, C2Hxnum[5]/2, C2Hxnum[6]/2, C2Hxnum[7]/2);



		//CHx̐L^
		if(frameMol_prev){
			for (i=0;i<dat->pcnt;i++){
				
				if(dat->knd[i] != KIND_C){ continue;}

				molid = frameMol->molIDs[i];
				if(frameMol->pMolType[molid].Cn == 1){
					int Hn = frameMol->pMolType[molid].Hn;
					
					int molid_prev = frameMol_prev->molIDs[i];
					int Cn_prev = frameMol_prev->pMolType[molid_prev].Cn;
					int Hn_prev = frameMol_prev->pMolType[molid_prev].Hn;
					
					if((Cn_prev != 1) || (Hn_prev != Hn)){	//qω
						
						switch(Hn){
						case 0:
							if((Cn_prev == 1) && (Hn_prev < 5)){
								CH0_from[Hn_prev]++;
							}else{
								CH0_from[5]++;
							}
							break;
						
						case 1:
							if((Cn_prev == 1) && (Hn_prev < 5)){
								CH1_from[Hn_prev]++;
							}else{
								CH1_from[5]++;
							}
							break;
						
						case 2:
							if((Cn_prev == 1) && (Hn_prev < 5)){
								CH2_from[Hn_prev]++;
							}else{
								CH2_from[5]++;
							}
							break;
						
						case 3:
							if((Cn_prev == 1) && (Hn_prev < 5)){
								CH3_from[Hn_prev]++;
							}else{
								CH3_from[5]++;
							}
							break;
						
						case 4:
							if((Cn_prev == 1) && (Hn_prev < 5)){
								CH4_from[Hn_prev]++;
							}else{
								CH4_from[5]++;
							}
							break;
						}
					}

				}
			}
		}


		//CH4ꂽȂ
		if(frameMol_prev){
			for (i=0;i<init_pcnt;i++){
				//͒YfƉ
				MolType* mt = frameMol->ppMT[i];
				if(mt){		//NULLȂCsimbox狏ȂȂ

					if((mt->Cn == 1) && (mt->Hn == 4) ){
						
						if (flagsCH4[i] == 0){
							flagsCH4[i] = dat->istep;
							CH4num ++;

						//݃t[̏W
							//CIDindexƖ{Ɉv邩`FbN
							int realIdx = -1;
							if(dat->id[i] == i + 1){
								realIdx = i;
							}else{
								
								for (k=0;k<dat->pcnt;k++){
									if(dat->id[k] == i + 1){
										realIdx = k;
										break;
									}
								}
							}//܂łCindex

							//4HT
							C_mol = mol[realIdx];
							C_id = i + 1;
							Hcnt = 0;
							for (k=0;k<dat->pcnt;k++){
								if(mol[k] == C_mol){
									CH_IDs[Hcnt] = dat->id[k];
									Hcnt++;
								}
							}
							
									
							
						//Õt[`FbN
							//IDv̂
							C_mol_prev = -1;
							k_id;
							for(s = 0; s < 5; s++){
								CH_mol_prev[s] = -1;
							}

							for (k=0;k<dat_prev->pcnt;k++){
								k_id = dat_prev->id[k];
								if( k_id == C_id){
									C_mol_prev = mol_prev[k];
								}else {
									
									for(s = 0; s < 5; s++){
										if( k_id == CH_IDs[s]){
											CH_mol_prev[s] = mol_prev[k];
										}
									}
								}
							}

							MolType* pmt = frameMol_prev->pMolType;
							_ftprintf(fp, _T("%d\t%d\t%d\t%d\t%d\tC%dH%d"), dat->istep, IncidentH, CH4num, i, 0,
									pmt[C_mol_prev].Cn, pmt[C_mol_prev].Hn);

							for(s = 0; s < 5; s++){
								if(CH_mol_prev[s] != -1){
									if( C_mol_prev != CH_mol_prev[s]){
										_ftprintf(fp, _T("\tC%dH%d"), 
										pmt[CH_mol_prev[s]].Cn, pmt[CH_mol_prev[s]].Hn);
									}
								}
							}
							_ftprintf(fp, _T("\n"));
							
						}
					
					}else{
						if(flagsCH4[i] > 0){//CH4̔j̏ꍇ
							
							CH4num --;

							//CIDindexƖ{Ɉv邩`FbN
							int realIdx = -1;
							if(dat->id[i] == i + 1){
								realIdx = i;
							}else{
								
								for (k=0;k<dat->pcnt;k++){
									if(dat->id[k] == i + 1){
										realIdx = k;
										break;
									}
								}
							}//܂łCindex

							//4HT
							C_mol = mol[realIdx];
							MolType* pmt = frameMol->pMolType;
							_ftprintf(fp, _T("%d\t%d\t%d\t%d\t%d\tC%dH%d\n"), dat->istep, IncidentH, CH4num, i, dat->istep - flagsCH4[i],
									pmt[C_mol].Cn, pmt[C_mol].Hn);
							

						}
						flagsCH4[i] = 0;
					}
				}
			}
				

			delete [] mol_prev;
						
		}
		
		mol_prev = mol;
		dat_prev = dat;
		frameMol_prev = frameMol;

		//_ftprintf(fp, _T(" %d\t%d\t%d\t%d\t%d\t%15.7lf\t%f\n"), dat->istep, IncidentH, dat->pcnt, hcnt, ccnt, ((double)hcnt)/((double)ccnt), dat->tempave);
		

		if(frameskip > 1){
			int dummyframe = 1;
			while(dummyframe < frameskip){
				if (a_atm->goNext(frameskip) == 0){
					dummyframe = -1;
					break;
				}else{
					//fː̃JEg(Ӗsdl)
					if( ( dat->istep / 2 ) * 2 != dat->istep){
						flag = 1;
					}else{
						if(flag == 1){
							IncidentH ++;
						}
						flag = 0;
					}
				}
				dummyframe ++;
			}

			if(dummyframe == -1){
				break;
			}
			
		}else{		
			if (a_atm->goNext() == 0){
				break;
			}
		}

		dat = a_atm->GetDataPointer();
		frameMol->next = new FrameMolInfo;
		frameMol = frameMol->next;
		frameMol->next = NULL;
		
	}
		delete [] mol_prev;
	
	fclose(fp);
	fclose(fp2);

	int CH0_total = 0;
	int CH1_total = 0;
	int CH2_total = 0;
	int CH3_total = 0;
	int CH4_total = 0;
	for(i=0;i<6;i++){
		CH0_total += CH0_from[i];
		CH1_total += CH1_from[i];
		CH2_total += CH2_from[i];
		CH3_total += CH3_from[i];
		CH4_total += CH4_from[i];
	}

	_ftprintf(fp3, _T(" %d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\n"),
			0, CH0_total, CH0_from[0], CH0_from[1], CH0_from[2], CH0_from[3], CH0_from[4], CH0_from[5]);
	_ftprintf(fp3, _T(" %d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\n"),
			1, CH1_total, CH1_from[0], CH1_from[1], CH1_from[2], CH1_from[3], CH1_from[4], CH1_from[5]);
	_ftprintf(fp3, _T(" %d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\n"),
			2, CH2_total, CH2_from[0], CH2_from[1], CH2_from[2], CH2_from[3], CH2_from[4], CH2_from[5]);
	_ftprintf(fp3, _T(" %d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\n"),
			3, CH3_total, CH3_from[0], CH3_from[1], CH3_from[2], CH3_from[3], CH3_from[4], CH3_from[5]);
	_ftprintf(fp3, _T(" %d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\n"),
			4, CH4_total, CH4_from[0], CH4_from[1], CH4_from[2], CH4_from[3], CH4_from[4], CH4_from[5]);
	fclose(fp3);

	//J
	
	while(frameMol = frameMol_fst){
		delete [] frameMol->ppMT;
		delete [] frameMol->pMolType;
		frameMol_fst = frameMol->next;
		delete frameMol;
	}

}



void WriteRetention(MDLoader* a_atm, int frameskip, const TCHAR* spath, double split_z){
	
	ATOMS_DATA *dat = a_atm->GetDataPointer();
	int i;

	FILE *fp;
//	int hcnt,ccnt;
	
	int size = 0;
	struct MolType *pMolType = NULL;

	fp = _tfopen(spath,_T("w"));
	if( fp == NULL ){  // ֐sĂȂ
		printf( "t@C̃I[vɎs܂\n");
		return;  // ُI͂OȊOԂ
	}


	_ftprintf(fp, _T("# retention and H/C ratio\n"));
	_ftprintf(fp, _T("#step\tIncidentH\tz_site\tz_pos\tC-atom\tH-atom\tH/C\n"));
	
	int flag = 0;
	int IncidentH = 0;

	while(1){
		
		if( ( dat->istep / 2 ) * 2 != dat->istep){
			flag = 1;
		}else{
			if(flag == 1){
				IncidentH ++;
			}
			flag = 0;
		}


		int newsize = (int)(dat->boxaxis.m33 / split_z) + 2;
		if(newsize > size){
			size = newsize;
			delete [] pMolType;
			pMolType = new MolType[size];
		}
		memset(pMolType, 0, sizeof(MolType) * size);

		for (i=0;i<(dat->pcnt);i++){
			int idx = (int)floor((dat->r[i].z / split_z) + 0.5);
			

			if(dat->knd[i] == 0){
				pMolType[ idx + size / 2].Cn ++;
			}else if (dat->knd[i] == 1){
				pMolType[ idx + size / 2].Hn ++;
			}

		}


		for (i = 0; i< size; i++){
			if(pMolType[i].Cn > 0){
			_ftprintf(fp, _T(" %d\t%d\t%d\t%15.7lf\t%d\t%d\t%f\n"), dat->istep, IncidentH,
				i - size / 2, split_z*(double)(i - size / 2),
				pMolType[i].Cn, pMolType[i].Hn, ((float)pMolType[i].Hn)/(float)pMolType[i].Cn);
			}
		}		

		if(frameskip > 1){
			if (a_atm->goNext(frameskip) == 0){
				break;
			}
		}else{		
			if (a_atm->goNext() == 0){
				break;
			}
		}
		dat = a_atm->GetDataPointer();

		_ftprintf(fp, _T("\n"));
	}
	
	fclose(fp);
}

//͐ϕ`FbN
void WriteDeposition(MDLoader* a_atm, int frameskip, const TCHAR* spath){
	
	ATOMS_DATA *dat = a_atm->GetDataPointer();
	int i;
	int molcnt, molid;	//, molid_max, atomcnt_max, molid_2nd, atomcnt_2nd;
	MolType* pMolType = NULL;
	int Ccnt,Hcnt;

	FILE *fp;
	

	fp = _tfopen(spath,_T("w"));
	if( fp == NULL ){  // ֐sĂȂ
		printf( "t@C̃I[vɎs܂\n");
		return;  // ُI͂OȊOԂ
	}


	_ftprintf(fp, _T("# deposition and H/C ratio\n"));
	_ftprintf(fp, _T("#step\tCandH\tC-atom\tH-atom\n"));
	
	while(1){
		

		int *mol = clasifyMolecule(dat, &molcnt);
		pMolType = new MolType[molcnt];
			memset(pMolType, 0, sizeof(MolType) * molcnt);//[NA
		
		
		for (i=0;i<(dat->pcnt);i++){
			molid = mol[i];
			if(dat->knd[i] == KIND_C){
				pMolType[molid].Cn ++;
			}else if (dat->knd[i] == KIND_H){
				pMolType[molid].Hn ++;
			}
		}

		//ł傫qT(Ԗڂ)
#define MOLSIZE_THRESHOLD	100	
		Ccnt = Hcnt = 0;
		
		for (i=0;i<molcnt;i++){	
			
			if(MOLSIZE_THRESHOLD < ( pMolType[i].Cn +  pMolType[i].Hn )){
				Ccnt += pMolType[i].Cn;
				Hcnt += pMolType[i].Hn;
			}
		}
		

		_ftprintf(fp, _T(" %d\t%d\t%d\t%d\n"), dat->istep, Ccnt + Hcnt, Ccnt, Hcnt);
				
		delete [] mol;
		delete [] pMolType;

		Sleep(0);
		if(frameskip > 1){
			if (a_atm->goNext(frameskip) == 0){
				break;
			}
		}else{		
			if (a_atm->goNext() == 0){
				break;
			}
		}
		dat = a_atm->GetDataPointer();

	}
	
	fclose(fp);
}



void WriteDencity(ATOMS_DATA *dat, const TCHAR* spath, float top_z, float bottom_z){
	
	
		//AI_eraceBulk(dat, bottom_z);
		//AI_eraceUpper(dat, top_z);

		int i;
		float rz;
		int index;
		const int split_count = 16;
		double split = dat->boxaxis.m33 / (double)split_count;
		int count_array[split_count];
		memset(count_array, 0, split_count*4);

		for(i=0; i < dat->pcnt; i++){
			
			rz = dat->r[i].z + dat->boxaxis.m33 * 0.5f;
			rz = (float)fmod(rz+dat->boxaxis.m33, dat->boxaxis.m33);

			index = (int)(rz / split);
			count_array[index]++;
		}

		
//t@Co
	FILE* fp = _tfopen(spath,_T("w"));
	if( fp == NULL ){  // ֐sĂȂ
		printf( "t@C̃I[vɎs܂\n");
		return;  // ُI͂OȊOԂ
	}

	_ftprintf(fp, _T("# position, dencity\n"));

	double volume = split * dat->boxaxis.m22 * dat->boxaxis.m11;
	double dencity;
	double sum = 0.0;
	double var = 0.0;

	for(i=0; i < split_count; i++){
		dencity = count_array[i];
		dencity /= volume;
		sum += dencity;
		var += dencity*dencity;

		_ftprintf(fp, _T("%d\t%f\n"), i, dencity);
		
	}

	sum /= (double)split_count;
	_ftprintf(fp, _T("#total %f\n"), sum);
	
	var = sqrt(var/(double)split_count - sum*sum);
	_ftprintf(fp, _T("#space_variance %f\n"), var);



	
	fclose(fp);


}


void WriteBondnum(ATOMS_DATA *dat, const TCHAR* spath){
	
	


			
	
	int* color_table = new int[dat->pcnt];
	memset(color_table, 0, sizeof(int) * dat->pcnt);

	//bondvZ
	
	for (SIMPLE_IJ* b = dat->bonds; b != dat->bonds + dat->bcnt;b++){
		color_table[b->i] ++;
		color_table[b->j] ++;
	}

	int bondnum[7];
	memset(bondnum, 0, sizeof(int) * 7);

	//Ƃɗq𐔂
	for(int i = 0; i < dat->pcnt; i++){
			if(color_table[i] < 6){
				bondnum[color_table[i]]++;
			}else{
				bondnum[6] ++;
			}	
	}


//t@Co
	FILE* fp = _tfopen(spath,_T("w"));
	if( fp == NULL ){  // ֐sĂȂ
		printf( "t@C̃I[vɎs܂\n");
		return;  // ُI͂OȊOԂ
	}

	_ftprintf(fp, _T("# step, total, 0-bond, 1-bond, sp1, sp2, sp3, 5-bond, more\n"));

	_ftprintf(fp, _T("%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\n"), dat->istep, dat->pcnt,
							bondnum[0], bondnum[1], bondnum[2], bondnum[3], bondnum[4], bondnum[5], bondnum[6]);
	
	fclose(fp);

	delete [] color_table;

	
}

void WriteSp2normal(ATOMS_DATA *dat, const TCHAR* spath){
	
	REBO* rebo= new REBO(dat->pcnt);
	AtomArray* atoms = new AtomArray(dat->pcnt);
	
	atoms->count = dat->pcnt;
	for(int i=0;i<dat->pcnt;i++){
		atoms->knd[i] = dat->knd[i];
		atoms->r[i] = dat->r[i] - dat->boxorg;
	}
	rebo->SetParticlePointers(atoms);
	rebo->SetBoxsize(dat->boxaxis.m11, dat->boxaxis.m22, dat->boxaxis.m33); 
	rebo->SetListOrtho(dat->pcnt);
	REBO_PARTICLE* rp;
	rebo->GetREBOPointers(&rp);
	
	//bondvZ

	vec3d sum_normal;
	sum_normal.Clear();
	
	vec3d sum_n2;
	sum_n2.Clear();

	vec3d exy;
	exy.Set(1.0,1.0,0.0);
	exy = Unit(exy);
	vec3d ey_x;
	ey_x.Set(-1.0,1.0,0.0);
	ey_x = Unit(ey_x);
	
	int sum_count=0;
	
	REBO_PARTICLE* prp = rp;
	for(int i = 0; i < dat->pcnt; i++){
		int valid_count = 0;
		vec3d valid_r[3];
		for(int k = 0; k < prp->NbCnt; k++){
			if( prp->fc[k] >= 0.5 ){
				if(valid_count == 3){break;}//sp3ȏ.
				valid_r[valid_count] = prp->e[k];
				valid_count++;
			}
		}

		if(valid_count == 3){ //sp2̂Ƃ@T.
			vec3d normal = Cross(valid_r[1] - valid_r[0], valid_r[2] - valid_r[0]);
			normal = Unit(normal);
			double n2xy = exy * normal;
			double n2y_x = ey_x * normal;
			vec3d n2;
			n2.Set(n2xy, n2y_x, normal.z);

			atoms->p[i] = normal;
			atoms->id[i] = 1;	//sp3tO.

			normal.x *= normal.x;
			normal.y *= normal.y;
			normal.z *= normal.z;
			sum_normal += normal;

			n2.x *= n2.x;
			n2.y *= n2.y;
			n2.z *= n2.z;
			sum_n2 += n2;

			sum_count++;
		}else{
			atoms->id[i] = 0;	//sp3ȊÕtO.
		}
		prp++;

	}

	if(sum_count){ 
		sum_normal /= (double)sum_count;
		sum_n2 /= (double)sum_count;
	}


//t@Co
	FILE* fp = _tfopen(spath,_T("w"));
	if( fp == NULL ){  // ֐sĂȂ
		printf( "t@C̃I[vɎs܂\n");
		return;  // ُI͂OȊOԂ
	}

	_ftprintf(fp, _T("# step,  sp2_count, normal.x^2, normal.y^2, normal.z^2, normal.xy^2, normal.(y-x)^2, normal.z^2\n"));

	_ftprintf(fp, _T("# %d\t%d\t%.7lf\t%.7lf\t%.7lf\t%.7lf\t%.7lf\t%.7lf\n"), dat->istep, sum_count,
							sum_normal.x, sum_normal.y, sum_normal.z,
							sum_n2.x, sum_n2.y, sum_n2.z);

	_ftprintf(fp, _T("#\n#sp2atom_id, sp2atom_position(x,y,z), normal_vector(x,y,z)\n"));
	
	for(int i = 0; i <= atoms->count; i++){
		if(atoms->id[i]){
			_ftprintf(fp, _T("%d\t%.7f\t%.7f\t%.7f\t%.7lf\t%.7lf\t%.7lf\n"),
				i, atoms->r[i].x, atoms->r[i].y, atoms->r[i].z,
				atoms->p[i].x, atoms->p[i].y, atoms->p[i].z);
		}
	}


	
	fclose(fp);

	delete rebo;
	delete atoms;

	
}

void WriteBondDirection(ATOMS_DATA *dat, const TCHAR* spath){
//{h̒PʃxNg̕zo.

	//yA̐􂢏o.
	REBO* rebo= new REBO(dat->pcnt);
	AtomArray* atoms = new AtomArray(dat->pcnt);
	atoms->count = dat->pcnt;
	for(int i=0;i<dat->pcnt;i++){
		atoms->knd[i] = dat->knd[i];
		atoms->r[i] = dat->r[i] - dat->boxorg;
	}
	rebo->SetParticlePointers(atoms);
	rebo->SetBoxsize(dat->boxaxis.m11, dat->boxaxis.m22, dat->boxaxis.m33); 
	rebo->SetListOrtho(dat->pcnt);
	REBO_PARTICLE* rp;
	rebo->GetREBOPointers(&rp);
	

	//ٕ̌vZ
	int spX_count[BOND_CNT];//spX̌.
	memset(spX_count, 0, sizeof(int)*BOND_CNT);
	
	vec3d spX_dir[BOND_CNT];//spXƂ̃{ha(sp0̓{h1,قڐf), 1~: sp~
	for(vec3d* v = spX_dir; v != spX_dir + BOND_CNT; v++){
		v->Clear();
	}
	
	vec3d spX_dir2[BOND_CNT];//spXƂ̃{ha(΂߂)
	for(vec3d* v = spX_dir2; v != spX_dir2 + BOND_CNT; v++){
		v->Clear();
	}

	vec3d exy;
	exy.Set(1.0,1.0,0.0);
	exy = Unit(exy);
	vec3d ey_x;
	ey_x.Set(-1.0,1.0,0.0);
	ey_x = Unit(ey_x);
	
	int* bondnums = new int[dat->pcnt];	//qƂɐ^̌L^.
	memset(bondnums, 0, sizeof(int)*dat->pcnt);
	
	REBO_PARTICLE* prp = rp;
	for(int i = 0; i < dat->pcnt; i++){
		
		vec3d vsum;
		vec3d v2sum;
		vsum.Clear();
		v2sum.Clear();
		//vec3d valid_r[BOND_CNT];
		for(int k = 0; k < prp->NbCnt; k++){
			if( prp->fc[k] >= 0.5 ){
				vec3d inp;
				//x,y,zł̓a
				inp = prp->e[k];
				inp.x *= inp.x;
				inp.y *= inp.y;
				inp.z *= inp.z;
				vsum += inp;
				
				//(x+y),(y-x),zł̓a
				inp.Set(exy * (prp->e[k]), ey_x * (prp->e[k]), prp->e[k].z);
				inp.x *= inp.x;
				inp.y *= inp.y;
				inp.z *= inp.z;
				v2sum += inp;

				bondnums[i]++;
			}

		}

		if(bondnums[i] >= BOND_CNT){
			spX_dir[BOND_CNT-1] += vsum;
			spX_dir2[BOND_CNT-1] += v2sum;
			spX_count[BOND_CNT-1] ++;
		}else if(bondnums[i] > 0){
			spX_dir[bondnums[i]-1] += vsum;
			spX_dir2[bondnums[i]-1] += v2sum;
			spX_count[bondnums[i]-1] ++;
		}

		prp++;

	}

	//ω, g[^.
	int all_bond_count = 0;
	int all_atom_count = 0;
	vec3d all_dir;
	vec3d all_dir2;
	all_dir.Clear();
	all_dir2.Clear();
	for(int k = 0; k < BOND_CNT; k++){
		if(spX_count[k]){
			all_atom_count += spX_count[k];
			all_bond_count += spX_count[k] * (k+1);
			all_dir += spX_dir[k];
			all_dir2 += spX_dir2[k];

			spX_dir[k] /= (double)(spX_count[k] * (k+1));
			spX_dir2[k] /= (double)(spX_count[k] * (k+1));
		}
	}

	all_dir /= (double)all_bond_count;
	all_dir2 /= (double)all_bond_count;


//t@Co
	FILE* fp = _tfopen(spath,_T("w"));
	if( fp == NULL ){  // ֐sĂȂ
		printf( "t@C̃I[vɎs܂\n");
		return;  // ُI͂OȊOԂ
	}

	//spXƂ̓ȁo
	_ftprintf(fp, _T("# sp[X], bond_count atom_count, normal.x^2, normal.y^2, normal.z^2, normal.xy^2, normal.(y-x)^2, normal.z^2\n"));

	for(int k = 0; k < BOND_CNT; k++){
		_ftprintf(fp, _T("# %d\t%d\t%d\t%.7lf\t%.7lf\t%.7lf\t%.7lf\t%.7lf\t%.7lf\n"),
							k, k + 1, spX_count[k],
							spX_dir[k].x, spX_dir[k].y, spX_dir[k].z,
							spX_dir2[k].x, spX_dir2[k].y, spX_dir2[k].z);
	}

	_ftprintf(fp, _T("# total\t%d/2\t%d\t%.7lf\t%.7lf\t%.7lf\t%.7lf\t%.7lf\t%.7lf\n"),
							all_bond_count, all_atom_count,
							all_dir.x, all_dir.y, all_dir.z,
							all_dir2.x, all_dir2.y, all_dir2.z);



	//S{h̏o(qi,jœx(͋t)o͂)
	_ftprintf(fp, _T("#\n#atom_index, bond_count, atom_position(x,y,z), pair_index, bond_unit_vector(x,y,z)\n"));
	
	prp = rp;
	for(int i = 0; i <= atoms->count; i++){
		
		for(int k = 0; k < prp->NbCnt; k++){
			if( prp->fc[k] >= 0.5 ){
				_ftprintf(fp, _T("%d\t%d\t%.7lf\t%.7lf\t%.7lf\t%d\t%.7lf\t%.7lf\t%.7lf\n"),
				i, bondnums[i], atoms->r[i].x, atoms->r[i].y, atoms->r[i].z,
				prp->NbPrt[k], prp->e[k].x, prp->e[k].y, prp->e[k].z);
				
			}
		}
		
		prp++;
	}


	
	fclose(fp);

	delete rebo;
	delete atoms;

	delete [] bondnums;
	
}

void WriteBondListBase(MDLoader* a_atm, int frameskip, const TCHAR* filepath){
	
	ATOMS_DATA *dat = a_atm->GetDataPointer();
	
	//ƂȂ{h

	//a_atm->KeepCurrentFrame();

	ListupBond* listup = new ListupBond(dat->pcnt, 1.85);
	vec3d* r_d = new vec3d[dat->pcnt];
	int i;
	for(i=0;i<dat->pcnt;i++){
		r_d[i] = dat->r[i] - dat->boxorg;
	}
	listup->SetParticlePointers(dat->knd, r_d);
	
	double nonortho_term = fabs(dat->boxaxis.m12) + fabs(dat->boxaxis.m13)
					+ fabs(dat->boxaxis.m21) + fabs(dat->boxaxis.m23) 
					+ fabs(dat->boxaxis.m31) + fabs(dat->boxaxis.m32); 
	if(nonortho_term > 0.1e-6){
		mat33d Am = dat->boxaxis;
		listup->SetBoxAxis(Am); 
		listup->SetListNonortho(dat->pcnt);	//ݍpyA.
	}else{
		listup->SetBoxsize(dat->boxaxis.m11, dat->boxaxis.m22, dat->boxaxis.m33); 
		listup->SetListOrtho(dat->pcnt);	//ݍpyA.
	}
	SIMPLE_BONDING* base_bond;
	int base_bcnt;
	listup->GetBondingPointers(&base_bcnt, &base_bond);
	
	
	int delta_id = dat->id[0];	// - 0

	TCHAR sbuf[10];
	_itot(dat->no, sbuf, 10);
	int len = _tcslen(sbuf);
	TCHAR spath[MAX_PATH];
	_tcscpy(spath, filepath);
	//_tcscat(spath, _T("_bondlist000000.txt"));
	_tcsncpy(spath + _tcslen(spath) - len - 4, sbuf,len);
	FILE* fp = _tfopen(spath,_T("w"));
	if( fp == NULL ){  // ֐sĂȂ
		printf( "t@C̃I[vɎs܂\n");
		return;  // ُI͂OȊOԂ
	}

	_ftprintf(fp, _T("# list of bond position \n"));
	_ftprintf(fp, _T("# frame %d \n"), dat->no);
	
	for(SIMPLE_BONDING* b=base_bond; b != base_bond + base_bcnt;b++){
		b->rij *= -0.5;
		b->rij += r_d[b->i];	//Z^[ʒu
	}
	delete [] r_d;

	if(dat->id){//idꍇ
		for(SIMPLE_BONDING* b=base_bond; b != base_bond + base_bcnt;b++){
			b->i = dat->id[b->i];
			b->j = dat->id[b->j];
		}
	}

	for(SIMPLE_BONDING* b=base_bond; b != base_bond + base_bcnt;b++){
		_ftprintf(fp, _T("%d\t%d\t%4lf\t%4lf\t%4lf\n"), b->i, b->j, (b->rij).x, (b->rij).y, (b->rij).z);
	}
	fclose(fp);

	if(frameskip > 1){
		if (a_atm->goNext(frameskip) == 0){
			fclose(fp);
			return;
		}
	}else{		
		if (a_atm->goNext() == 0){
			fclose(fp);
			return;
		}
	}
	dat = a_atm->GetDataPointer();


//ȍ~A2t[ڂ̏o

	ListupBond* listup2;
	SIMPLE_BONDING* bonding;
	int index, k, sub_i, sub_j;
	int bcnt;

	while(1){
	

		listup2 = new ListupBond(dat->pcnt, 1.85);
		vec3d* r_d = new vec3d[dat->pcnt];
		for(i=0;i<dat->pcnt;i++){
			r_d[i] = dat->r[i] - dat->boxorg;
		}
		listup2->SetParticlePointers(dat->knd, r_d);

		double nonortho_term = fabs(dat->boxaxis.m12) + fabs(dat->boxaxis.m13)
						+ fabs(dat->boxaxis.m21) + fabs(dat->boxaxis.m23) 
						+ fabs(dat->boxaxis.m31) + fabs(dat->boxaxis.m32); 
		if(nonortho_term > 0.1e-6){
			mat33d Am = dat->boxaxis;
			listup->SetBoxAxis(Am); 
			listup->SetListOrtho(dat->pcnt);	//ݍpyA.
		}else{
			listup->SetBoxsize(dat->boxaxis.m11, dat->boxaxis.m22, dat->boxaxis.m33); 
			listup->SetListOrtho(dat->pcnt);	//ݍpyA.
		}
		listup2->GetBondingPointers(&bcnt, &bonding);
		delete [] r_d;
	
		_itot(dat->no, sbuf, 10);
		len = _tcslen(sbuf);
		_tcsncpy(spath + _tcslen(spath) - len - 4, sbuf,len);
		fp = _tfopen(spath,_T("w"));
		_ftprintf(fp, _T("# list of bond position \n"));
		_ftprintf(fp, _T("# frame %d \n"), dat->no);
	

		for(SIMPLE_BONDING* b = base_bond; b != base_bond + base_bcnt; b++){
			index = b->i - delta_id;
			if (dat->id[index] == b->i){
				sub_i = index;
			}else{
				for(k=0;k<dat->pcnt;k++){
					if(dat->id[k] == b->i){
						sub_i = k;
						break;
					}
				}
				if(k == dat->pcnt){
					continue;
				}
			}
			index = b->j - delta_id;
			if (dat->id[index] == b->j){
				sub_j = index;
			}else{
				for(k=0;k<dat->pcnt;k++){
					if(dat->id[k] == b->j){
						sub_j = k;
						break;
					}
				}
				if(k == dat->pcnt){
					continue;
				}
			}
			//̎_sub_i, sub_jԂbond邩`FbN.
			SIMPLE_BONDING* k;
			//int cc_count = 0;
			for(k=bonding; k<bonding+bcnt;k++){
				if(((k->i == sub_i) && (k->j == sub_j)) || ((k->i == sub_j) && (k->j == sub_i))) {
					_ftprintf(fp, _T("%d\t%d\t%4lf\t%4lf\t%4lf\n"), b->i, b->j, (b->rij).x, (b->rij).y, (b->rij).z);
					break;
					
				}
			}
			//if( k == bonding+bcnt){
			//	_ftprintf(fp, _T("%d\t%d\t%4lf\t%4lf\t%4lf\n"), b->i, b->j, (b->rij).x, (b->rij).y, (b->rij).z);
			//}

		}

		delete listup2;
		fclose(fp);


		Sleep(0);
		if(frameskip > 1){
			if (a_atm->goNext(frameskip) == 0){
				break;
			}
		}else{		
			if (a_atm->goNext() == 0){
				break;
			}
		}
		dat = a_atm->GetDataPointer();

	}
	
	fclose(fp);


	//delete [] r_d;
	delete listup;


}


void WriteBoundAtom(ATOMS_DATA* dat, int frameskip, const TCHAR* spath, int atmKind, int pairKind){
	//{hĂ錴q݂̂𒊏o֐.
	//atmKind ɂ͒oq̎ނw.ނōiȂƂKIND_ALLw.
	//pairKindɂ͌̎ނw.iȂƂKIND_ALLw.

	
	//ƂȂ{h

	ListupBond* listup = new ListupBond(dat->pcnt, 1.85);
	vec3d* r_d = new vec3d[dat->pcnt];
	int i;
	for(i=0;i<dat->pcnt;i++){
		r_d[i] = dat->r[i] - dat->boxorg;
	}
	listup->SetParticlePointers(dat->knd, r_d);

	double nonortho_term = fabs(dat->boxaxis.m12) + fabs(dat->boxaxis.m13)
					+ fabs(dat->boxaxis.m21) + fabs(dat->boxaxis.m23) 
					+ fabs(dat->boxaxis.m31) + fabs(dat->boxaxis.m32); 
	if(nonortho_term > 0.1e-6){
		mat33d Am = dat->boxaxis;
		listup->SetBoxAxis(Am); 
		listup->SetListOrtho(dat->pcnt);	//ݍpyA.
	}else{
		listup->SetBoxsize(dat->boxaxis.m11, dat->boxaxis.m22, dat->boxaxis.m33); 
		listup->SetListOrtho(dat->pcnt);	//ݍpyA.
	}
	SIMPLE_BONDING* base_bond;
	int base_bcnt;
	listup->GetBondingPointers(&base_bcnt, &base_bond);

	
	
	
	FILE* fp = _tfopen(spath,_T("w"));
	if( fp == NULL ){  // ֐sĂȂ
		printf( "t@C̃I[vɎs܂\n");
		return;  // ُI͂OȊOԂ
	}
	_ftprintf(fp, _T("# list of adsorbed position \n"));

	_ftprintf(fp, _T("# frame %d \n"), dat->no);
	
	BYTE* bflags = new BYTE[dat->bcnt];
	memset(bflags, 0, sizeof(BYTE) * dat->pcnt);

	if(pairKind == KIND_ALL){
		for(SIMPLE_BONDING* b=base_bond; b != base_bond + base_bcnt;b++){
			bflags[b->i] ++;
			bflags[b->j] ++;
		}

	}else{	//𔻒.
		for(SIMPLE_BONDING* b=base_bond; b != base_bond + base_bcnt;b++){
			if(dat->knd[b->j] == pairKind){ bflags[b->i] ++;}
			if(dat->knd[b->i] == pairKind){ bflags[b->j] ++;}
		}
	}

	delete listup;

	if(atmKind != KIND_ALL){
		for(int i = 0; i < dat->pcnt; i++){
			if(dat->knd[i] != atmKind){ bflags[i] = 0;}
		}
	}

	vec3d* pr = r_d;
	for(int i = 0; i < dat->pcnt; i++){
		if( bflags[i] ){
			_ftprintf(fp, _T("%d\t%7lf\t%7lf\t%7lf\n"), i, pr->x, pr->y, pr->z);
		}
		pr++;
	}


	
	fclose(fp);
	delete [] bflags;
	delete [] r_d;


}
