
#include <windows.h>


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "ai_molecule.h"
#include "ListupBond.h"

#pragma warning(disable : 4996)


void AI_ResetBond(ATOMS_DATA *dat){
	//{hČvZ

	double boxexist = dat->boxaxis.m11 * dat->boxaxis.m22 * dat->boxaxis.m33;
	if (boxexist < 1.0e-6){
		return;
	}


	delete [] dat->bonds;


////ԑ===============================
//LARGE_INTEGER start_pc,end_pc,freq_pc;
//double sec_pc[10];
//QueryPerformanceFrequency(&freq_pc);
//QueryPerformanceCounter(&start_pc);
////ԑ===============================

	ListupBond* listup = new ListupBond(dat->pcnt, 1.85);
	vec3d* r_d = new vec3d[dat->pcnt];
	int i;
	for(i=0;i<dat->pcnt;i++){
		r_d[i] = dat->r[i] - dat->boxorg;
		//if(r_d[i].z < 0.0){
		//	r_d[i].z += dat->boxaxis.m33;
		//}

	}
	
	
//QueryPerformanceCounter(&end_pc);
//sec_pc[0] = (double)(end_pc.QuadPart - start_pc.QuadPart)/(double)freq_pc.QuadPart;
//start_pc = end_pc;

	listup->SetParticlePointers(dat->knd, r_d);
	
	double nonortho_term = fabs(dat->boxaxis.m12) + fabs(dat->boxaxis.m13)
					+ fabs(dat->boxaxis.m21) + fabs(dat->boxaxis.m23) 
					+ fabs(dat->boxaxis.m31) + fabs(dat->boxaxis.m32); 
	if(nonortho_term > 0.1e-6){
		mat33d Am = dat->boxaxis;
		listup->SetBoxAxis(Am); 
		listup->SetListNonortho(dat->pcnt);	//ݍpyA.
	}else{
		listup->SetBoxsize(dat->boxaxis.m11, dat->boxaxis.m22, dat->boxaxis.m33); 
		listup->SetListOrtho(dat->pcnt);	//ݍpyA.
	}
	
//QueryPerformanceCounter(&end_pc);
//sec_pc[1] = (double)(end_pc.QuadPart - start_pc.QuadPart)/(double)freq_pc.QuadPart;
//start_pc = end_pc;

	SIMPLE_BONDING* bonding;		//{h̉p̏.
	listup->GetBondingPointers(&(dat->bcnt), &bonding);
	dat->bondInsideCnt = listup->GetInsideBondCount();
	dat->bonds = new SIMPLE_IJ[dat->bcnt];
	
//QueryPerformanceCounter(&end_pc);
//sec_pc[2] = (double)(end_pc.QuadPart - start_pc.QuadPart)/(double)freq_pc.QuadPart;
//start_pc = end_pc;
	
	for(i=0;i<dat->pcnt;i++){
		dat->r[i] = (vec3f)(r_d[i]) + dat->boxorg;
	}
	
//QueryPerformanceCounter(&end_pc);
//sec_pc[3] = (double)(end_pc.QuadPart - start_pc.QuadPart)/(double)freq_pc.QuadPart;
//start_pc = end_pc;

	for (SIMPLE_IJ* b = dat->bonds; b != dat->bonds + dat->bcnt;b++){
		b->i = bonding->i;
		b->j = bonding->j;

		bonding++;
	}

//QueryPerformanceCounter(&end_pc);
//sec_pc[4] = (double)(end_pc.QuadPart - start_pc.QuadPart)/(double)freq_pc.QuadPart;
//start_pc = end_pc;

	delete [] r_d;
	delete listup;
	
//QueryPerformanceCounter(&end_pc);
//sec_pc[5] = (double)(end_pc.QuadPart - start_pc.QuadPart)/(double)freq_pc.QuadPart;
//start_pc = end_pc;


////ԑ=============================== 
//	printf("%lf\n",sec_pc);
//
//	FILE* fp = fopen("time.txt", "w");
//	for(int i = 0; i < 10; i++){
//		fprintf(fp, "routine %d: %lf sec\n", i, sec_pc[i]);
//	}
//	fclose(fp);
//
////ԑ===============================
}


int* AI_CreateMolList(ATOMS_DATA *dat){
	//MolList̎dl
	//ꕪqqԍ`F[ƂȂĂB
	//iԖڂ̗vfɂ͗qiq鎟̗q̔ԍB
	//A`F[̌qڂƂāAŌ㗱q̏ꍇ
	// - (̗qԍ + 1) < 0
	//vfƂB
	//`F[̓擾ɂ́A̒lvfTA
	//̒lɑ΂A̋tϊ
	// - (̒l) - 1
	//̗qԍƂȂB
	
	int *pNext;
	int i, li, lj, head;
	

	pNext = new int[dat->pcnt];
	for (i = 0; i < dat->pcnt; i++){
		pNext[i] = -(i+1);
	}	
	
	//
	//`F[\̍쐬
	//
	
	for (SIMPLE_IJ* b = dat->bonds; b != dat->bonds + dat->bcnt;b++){
		li = b->i;
		lj = b->j;
		
		//printf("check %d: (%d -- %d)", i, li, lj);
		
		
		//liƌqĂŌ̌q擾
		while ( pNext[li] >= 0){
			li = pNext[li];
		}
		
		//printf("--");
		
		//ljƌqĂŌ̌q擾
		while ( pNext[lj] >= 0){
			lj = pNext[lj];
		}


		if (li == lj){
		//	printf("--> same molecule\n");
			continue;
		}
		
		head = -pNext[lj] -1;
		pNext[lj] = pNext[li];
		pNext[li] = head;
		
		//printf("--> (%d -- %d)\n", pNext[lj], lj);
		
	}

	//printf("finish to classify\n");

	return pNext;
	
}



MolType* CreateMolType(ATOMS_DATA *dat){
	//MolListɁAq\(MolType)̃Xg
	int *pNext;
	int i, li, head;
	//
	//ʂ̕\
	//
	int cntC = 0;
	int cntH = 0;
	int cntX = 0;
	int molCnt = 0;

	
	
	MolType* fstMT = NULL;
	MolType* a = NULL;
	

	pNext = AI_CreateMolList(dat);

	for (i = 0; i < dat->pcnt; i++){
		//Ȃhead̔ԍŕ𕉂ɂl
		if (pNext[i] >=0){ continue;}
		
		molCnt ++;
		cntC = 0;
		cntH = 0;
		cntX = 0;

		//qĂ錴q\
		head = -pNext[i] -1;
		for (li = head; li >= 0; li = pNext[li]){
			//printf(" %d,", li);
			switch( dat->knd[li] ){
			case KIND_H:
				cntH ++;
				break;
			case KIND_C:
				cntC ++;
				break;
			default:
				cntX ++;
				break;
			}
		}

		
		if(fstMT==NULL){
			fstMT = a = new MolType;
			a->next = NULL;
			a->Cn = cntC;
			a->Hn = cntH;
			a->Xn = cntX;
			a->count = 1;
		}else{
			a = fstMT;
			while (a){
				if( (a->Cn == cntC) && (a->Hn == cntH) && (a->Xn == cntX) ){
					a->count++;
					break;
				}
				
				if (a->next==NULL){
					a->next = new MolType;
					a = a->next;
					a->next = NULL;
					a->Cn = cntC;
					a->Hn = cntH;
					a->Xn = cntX;
					a->count = 1;
					break;
				}
				a = a->next;
			}
		}

	}

	delete [] pNext;

	return fstMT;


}

int AI_WriteClassifyMolecule(ATOMS_DATA *dat, const TCHAR* filename){
	//MolListɁAqo
	//
	//ʂ̕\
	//
	FILE *fp;
	

	MolType* fstMT = CreateMolType(dat);
	if (fstMT==NULL){
		return 0;
	}
	


	fp = _tfopen(filename, _T("w"));
	if (fp == NULL){
		printf("error; open file\n");
		return 0;
	}

		
	

	MolType* a = fstMT;
	while (a){

		printf("%d ", a->count);
		_ftprintf(fp, _T("%d "), a->count);
		
		if (a->Cn){
			printf("C%d", a->Cn);
			_ftprintf(fp, _T("C%d"), a->Cn);
		}
		if(a->Hn){
			printf("H%d", a->Hn);
			_ftprintf(fp, _T("H%d"), a->Hn);
		}
		if(a->Xn){
			printf("X%d", a->Xn);
			_ftprintf(fp, _T("X%d"), a->Xn);
		}
		printf("\n");
		_ftprintf(fp, _T("\n"));
		a = a->next;
	}

	fclose(fp);

	DeleteMolType(fstMT);

	return 1;
}



int AI_nearestAtom(ATOMS_DATA *dat, float x, float y, float z, float limit_r){
	//q̈ꂩ甼alimit_rȓNbNꍇɂ͗qԍԂ
	//KqȂƂɂ-1Ԃ
	
	int i;
	float dr2Min = limit_r*limit_r;
	float dr2;
	int idxMin=-1;
	vec3f* r;
	

	if (dat == NULL) {return -1;}

	r=dat->r;
	

	/*glColor3f(0.0, 0.7, 0.0);*/
	//glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,atomc[g_knd[i]]);
	for(i=0;i<dat->pcnt;i++){
		dr2 = (r[i].x-x)*(r[i].x-x) + (r[i].y-y)*(r[i].y-y) + (r[i].z-z)*(r[i].z-z);
		
		if (dr2 <= dr2Min){
			dr2Min = dr2;
			idxMin = i;
		}
	}
	
	return idxMin;

}


void WriteAdsH(MDLoader* a_atm, int frameskip, const char* spath){
	
	ATOMS_DATA *dat = a_atm->GetDataPointer();
	ATOMS_DATA *bfr_dat;
	int i,k;
	int* ml;
	int molCnt;
	int over2Cnt;	//2qqȏ̐
	int CmolCnt;	//Cq1ȏ܂ޕq̐
	int cntC,cntH,cntX;
	int adsH,lrgC;
	int head;

	int bfr_idx;
	int* vns_head;
	int* vns_no;
	int* vns_C;
	int* vns_H;
	int vns_cnt;
	int vns_CmolCnt=0;
	int vns_over2Cnt=0;
	int vanishflag;
	
	FILE *fp;

	
	if(dat->id == NULL){
		printf("data does not has index array\n");
		return;
	}

	

	fp = fopen(spath,"w");
	if( fp == NULL ){  // ֐sĂȂ
		printf( "t@C̃I[vɎs܂\n");
		return;  // ُI͂OȊOԂ
	}

	//nočsq̋Lp
	vns_head = new int[dat->pcnt];
	vns_no = new int[dat->pcnt];
	vns_C = new int[dat->pcnt];
	vns_H = new int[dat->pcnt];
	vns_cnt =0;



	while(1){
		
		ml = AI_CreateMolList(dat);
		adsH = 0;
		molCnt = 0;
		lrgC = 0;
		over2Cnt=0;
		CmolCnt=0;
		
		for (i = 0; i < dat->pcnt; i++){
			//qXg̖[Ȃ畉̒l
			if (ml[i] >=0){ continue;}
			molCnt ++;
			//printf("Molecule %d: ", molCnt);
			cntC = 0;
			cntH = 0;
			cntX = 0;

			//qĂ錴qJEg
			head = -ml[i] -1;
			for (k = head; k >= 0; k = ml[k]){
				
				switch( dat->knd[k] ){
				case KIND_H:
					cntH ++;
					break;
				case KIND_C:
					cntC ++;
					break;
				default:
					cntX ++;
					break;
				}
			}

			if (cntC >= 100) {
				lrgC++;
				adsH += cntH;
			}

			if(cntC + cntH + cntX >=2){
				over2Cnt++;
			}

			if(cntC >0){
				CmolCnt++;
			}


		}

		//-------------------------
		//qo̓f[^ɉ
		//-------------------------



		//-------------------------
		//f[^o
		//-------------------------

		printf("time = %d,\t N=%d, adsorbedH=%d\n",dat->istep,dat->pcnt,adsH);
		
		_ftprintf(fp, _T(" %d\t%d\t%d\t%d\t%d\t%d\t%d\t%f8.3\n"),
				dat->istep,		//timestep
				dat->pcnt,		//q
				molCnt,			//Sq(Pꌴq܂)
				adsH,			//zfq
				lrgC,			//C100ȏ̕q̐
				over2Cnt + vns_over2Cnt,		//2qqȏ̐
				CmolCnt + vns_CmolCnt,		//Yfqȏ܂ޕq̐
				dat->tempave);	//x
		

		if(frameskip > 1){
			if (a_atm->goNext(frameskip) == 0){
				
				delete [] ml;
				break;
			}
		}else{		
			if (a_atm->goNext() == 0){
				
				delete [] ml;
				break;
			}
		}
		bfr_dat = dat;
		dat = a_atm->GetDataPointer();


		
		//-----------------------------
		//q̃XgAbv
		//-----------------------------
		for(i=0;i<bfr_dat->pcnt;i++){
			bfr_idx = bfr_dat->id[i];
			vanishflag = 1;
			for(k=0;k<dat->pcnt;k++){
				if(bfr_idx == dat->id[k]){
					vanishflag = 0;
				}
			}

			//očsq̋L
			if(vanishflag){

				///qhead̑{
				head = i;
				while(ml[head]>=0){
					head = ml[head];
				}
				head = ml[head];

				//qLĂȂ`FbN
				vanishflag = 1;
				for (k=vns_cnt-1;k!=0;k--){
					if (vns_no[k] != dat->no){
						break;
					}
					if(head == vns_head[k]){
						vanishflag=0;
					}
				}
				//q̋L
				if(vanishflag){
					vns_head[vns_cnt] = head;
					vns_no[vns_cnt] = dat->no;

					cntC = 0;
					cntH = 0;
					cntX = 0;
					head = -head -1;
					if(head==1267){
						ml[head] = ml[head];
					}
					for (k = head; k >= 0; k = ml[k]){
						
						switch( dat->knd[k] ){
						case KIND_H:
							cntH ++;
							break;
						case KIND_C:
							cntC ++;
							break;
						default:
							cntX ++;
							break;
						}
					}

					
					if(cntC + cntH + cntX >=2){
						vns_over2Cnt++;
					}

					if(cntC >0){
						vns_CmolCnt++;
					}


					vns_C[vns_cnt] = cntC;
					vns_H[vns_cnt] = cntH;
					vns_cnt++;

				}

			}
		}
			
				


		
		delete [] ml;
	}
	
	fclose(fp);
}



int AI_WriteAdsorbedH(MDLoader* a_atm, int frameskip, const TCHAR* filename){
	//MolListɁAqo
	//
	//ʂ̕\
	//
	FILE *fp;
	
#define MATERIAL_DEFINITION		(20)

	if(a_atm==NULL) { return 0;}

	


	fp = _tfopen(filename, _T("w"));
	if (fp == NULL){
		printf("error; open file\n");
		return 0;
	}
	_ftprintf(fp, _T("# step, adsorbed_H, T \n"));

	ATOMS_DATA *dat = a_atm->GetDataPointer();
	while(dat){
		
		int adsHcount = 0;


		MolType* fstMT = CreateMolType(dat);
		MolType* a = fstMT;
		while (a){

			if (a->Cn >= MATERIAL_DEFINITION){
				adsHcount += (a->Hn * a->count);
			}
			a = a->next;
		}
		DeleteMolType(fstMT);

		printf("adsorbed H: %d step, ads-H %d atoms, T = %7.3lf K\n", dat->istep,  adsHcount, dat->tempave);
		_ftprintf(fp,_T("%d\t%d\t%7.3lf\n"), dat->istep,  adsHcount, dat->tempave);


		if(frameskip > 1){
			if (a_atm->goNext(frameskip) == 0){
				break;
			}
		}else{		
			if (a_atm->goNext() == 0){
				break;
			}
		}
		dat = a_atm->GetDataPointer();
	}

	fclose(fp);


	return 1;
}



void DeleteMolType(MolType* moltype_fst){
	MolType* moltype = moltype_fst;
	while (moltype){
		moltype_fst = moltype;
		moltype = moltype->next;

		delete moltype_fst;
	}
}


void AI_eraceBulk(ATOMS_DATA *dat, float limit_z){
//wzWȉ̗q
	

	int i;    //ɒׂ
	int k;    //~ɒׂ
	//float dz;
		
	i = 0;
	k = dat->pcnt-1;
		
	while(1){
	
		//Ƀ{bNXO̗qT
		while (i <= k){
				
			if (dat->r[i].z < limit_z){
				break;
			}

			i = i + 1;
		}
			
		//~Ƀ{bNX̗qT
		while (k > i){
			if (dat->r[k].z >= limit_z){
				break;
			}
			k = k - 1;
		}	
		
		if (i >= k) {
			break;
		}
			
		//qւ
		dat->r[i] = dat->r[k];
		dat->p[i] = dat->p[k];
		dat->knd[i] = dat->knd[k];
			
		i = i + 1;
		k = k - 1;
	}
		
	dat->pcnt = i;
	
}
	


void AI_eraceUpper(ATOMS_DATA *dat, float limit_z){
//wzWȉ̗q
	

	int i;    //ɒׂ
	int k;    //~ɒׂ
	//float dz;
		
	i = 0;
	k = dat->pcnt-1;
		
	while(1){
	
		//Ƀ{bNXO̗qT
		while (i <= k){
				
			if (dat->r[i].z >= limit_z){
				break;
			}

			i = i + 1;
		}
			
		//~Ƀ{bNX̗qT
		while (k > i){
			if (dat->r[k].z < limit_z){
				break;
			}
			k = k - 1;
		}	
		
		if (i >= k) {
			break;
		}
			
		//qւ
		dat->r[i] = dat->r[k];
		dat->p[i] = dat->p[k];
		dat->knd[i] = dat->knd[k];
			
		i = i + 1;
		k = k - 1;
	}
		
	dat->pcnt = i;
	
}
	


double fperiodic(double a, double size){
	double res;
	
	res = fmod(a,size);
	if (res*2.0>size){
		res -= size;
	}else if(res * -2.0 > size){
		res += size;
	}
	return res;

}

float fperiodic(float a, float size){
	float res;
	
	res = (float)fmod(a,size);
	if (res*2.0>size){
		res -= size;
	}else if(res * -2.0 > size){
		res += size;
	}
	return res;

}