
#include <math.h>
#include <string.h>
#include "analyze_ring.h"


double fperiodic(double a, double size){
	double res;
	
	res = fmod(a,size);
	if (res*2.0>size){
		res -= size;
	}else if(res * -2.0 > size){
		res += size;
	}
	return res;

}

/*
int funcSmallArg(int a, int b, struct ATOMS_DATA *dat,int* NbCnt, int** NbPrt){
	double arg = - 2.0;
	int prt2;
	int c;
	int minc = -1;
	

	// (III)
	for (prt2 = 0; prt2 < NbCnt[b];prt2++){
		c = NbPrt[b][prt2];
		if (c != a){
			double v1_x, v1_y, v2_x, v2_y;
			double outer,inner;

			//b
			double box_x = 1.42 * sqrt(3.0) * 8.0;
			double box_y = 1.42 * 3.0 * 5.0;
			
			if (dat->boxx > 0.0) { box_x = dat->boxx;}
			if (dat->boxy > 0.0) { box_y = dat->boxy;}
			
			v1_x = dat->rx[b] - dat->rx[a];
			v1_y = dat->ry[b] - dat->ry[a];
			v2_x = dat->rx[c] - dat->rx[b];
			v2_y = dat->ry[c] - dat->ry[b];
			v1_x = fperiodic(v1_x, box_x);
			v1_y = fperiodic(v1_y, box_y);
			v2_x = fperiodic(v2_x, box_x);
			v2_y = fperiodic(v2_y, box_y);
			
			
			outer = v1_x * v2_y - v1_y * v2_x;
			inner = v1_x * v2_x + v1_y * v2_y;
			inner /= sqrt(v1_x * v1_x + v1_y * v1_y);
			inner /= sqrt(v2_x * v2_x + v2_y * v2_y);
			
			if (outer > 0.0) {
				inner = - inner + 2.0;
			}
			
			if (inner > arg) {
				arg = inner;
				minc = c;
			}
		}
	}

	return minc;
}


void funcRemovePrt(int a, int b, int* NbCnt, int** NbPrt){
	//remove from Nb*
	int prt;

	for (prt = 0;prt < NbCnt[a];prt++){
		if (NbPrt[a][prt] == b){
			NbCnt[a] --;
			NbPrt[a][prt] = NbPrt[a][NbCnt[a]];
			break;
		}
	}
}

void funcAddRing(int* rings, int *s, int cnt){
	//add to rings
	*rings = cnt;
	memcpy(rings + 1, s, sizeof(int) * cnt);
	*(rings + cnt + 1) = 0;
}

void funcAddString(int* rings, int *s, int cnt){
	//add to rings
	*rings = cnt;
	memcpy(rings + 1, s, sizeof(int) * cnt);
	*(rings + cnt + 1) = 0;
}

void funcAddBranch(int* rings, int *s, int cnt){
	//add to branch
	//qɂȂ
	*rings = -cnt;
	memcpy(rings + 1, s, sizeof(int) * cnt);
	*(rings + cnt + 1) = 0;
}

int funcCheckChiral(int *s, int cnt, struct ATOMS_DATA *dat){
	//ring Ẽ`FbN
	//߂l: (), (E)
	//̌Ăꍇ͐,,zerôǂɂłȂ蓾B
	double arg = - 2.0;
	int i;
	int chiral = 0;
	int minc = -1;
	double v1_x, v1_y, v2_x, v2_y, v0_x, v0_y;
	double outer,lastouter;
	
	//b
	double box_x = 1.42 * sqrt(3.0) * 8.0;
	double box_y = 1.42 * 3.0 * 5.0;
	
	if (dat->boxx > 0.0) { box_x = dat->boxx;}
	if (dat->boxy > 0.0) { box_y = dat->boxy;}
	
	
	v2_x = dat->rx[s[1]] - dat->rx[s[0]];
	v2_y = dat->ry[s[1]] - dat->ry[s[0]];
	v2_x = fperiodic(v2_x, box_x);
	v2_y = fperiodic(v2_y, box_y);
	v0_x = v2_x;
	v0_y = v2_y;
	lastouter = 0.0;

	for (i = 1; i < cnt - 1;i++){
			
		v1_x = v2_x;
		v1_y = v2_y;

		v2_x = dat->rx[s[i+1]] - dat->rx[s[i]];
		v2_y = dat->ry[s[i+1]] - dat->ry[s[i]];
		v2_x = fperiodic(v2_x, box_x);
		v2_y = fperiodic(v2_y, box_y);
		
		
		outer = v0_x * v2_y - v0_y * v2_x;	// +: chiral-left, -: chiral-right
		
		if (outer < 0.0) {
			if (lastouter >= 0.0){
				if( v1_x * v2_y - v1_y * v2_x > 0.0){
					chiral ++;
				}
			}
		}else if(outer > 0.0){
			if (lastouter <= 0.0){
				if( v1_x * v2_y - v1_y * v2_x < 0.0){
					chiral --;
				}
			}
		}
		
		
		lastouter = outer;
		

		
	}

	return chiral;
}
*/

int* AI_FindRing(struct ATOMS_DATA *dat){
	//ring, stringT
	//̂Ƃbranchstring̋ʂȂ
	//fʂȂ
	//ring

	int i,b;

	//int *ringList = new int[dat->bcnt * 2];//܂ꂭ炢ő邾낤B

//initialization ==============================
	//set as REBO programs
	const int BOND_CNT = 12;
	int *NbCnt = new int[dat->pcnt];
	int **NbPrt,**NbLIdx;
	
	NbPrt = new_int2D(dat->pcnt,BOND_CNT);
	NbLIdx = new_int2D(dat->pcnt,BOND_CNT);

	for (i=0;i<(dat->pcnt);i++){
		NbCnt[i] = 0;
	}
	
	for (b=0;b<dat->bcnt;b++){
		int li = dat->li[b];
		int lj = dat->lj[b];
		
		//if(dat->knd[li] == KIND_H){continue;}
		//if(dat->knd[lj] == KIND_H){continue;}

		NbLIdx[li][NbCnt[li]] = b;
		NbLIdx[lj][NbCnt[lj]] = b;
		NbPrt[li][NbCnt[li]] = lj;
		NbPrt[lj][NbCnt[lj]] = li;
		NbCnt[li]++;
		NbCnt[lj]++;

	}
	

//main routine ==============================

	int *rings = new int[dat->bcnt * 3];
	int s0, cnt;
	int s[1024];
	int r;
	int prt;

	rings[0]=0;
	r = 0;
	
	//܂AstringT(낢ǂ̕yۂ)
	//̂ǁANbPrtyA
	for (s0 = 0; s0 < (dat->pcnt); s0++){
		if (NbCnt[s0]==1){
			//find the edge of string
			
			s[0] = s0;
			i = 1;
			s[i] = NbPrt[s0][0];
			
			
			while(i<1024){
				
				//remove from Nb*
				funcRemovePrt(s[i],s[i-1],NbCnt,NbPrt);	//Е폜
				NbCnt[s[i-1]] = 0;		//t폜


				if(NbCnt[s[i]] == 1){
					// sequence string
					s[i+1] = NbPrt[s[i]][0];
					i++;
				}else if(NbCnt[s[i]] == 0){// find the other edge of string
					cnt = i + 1;
					funcAddString(rings + r, s, cnt);
					r += cnt + 1;
					break;

				}else{
					//if(NbCnt[s[i]] >= 2) find a branch
					cnt = i + 1;
					funcAddBranch(rings + r, s, cnt);
					r += cnt + 1;
					break;
					
				}
			}
		}

	}

	
	//ringTBłstringׂ͂ďĂ͂B

	//(I)
	for (s0 = 0; s0 < (dat->pcnt); s0++){
		
		/*
		if(NbCnt[s0] == 1){
			//error
			printf("error: finding string\n");
			return NULL;
		}
		*/

		//(II)
		for (prt=0; prt < NbCnt[s0];prt++){
			
			s[0]=s0;
			i=1;
			s[1] = NbPrt[s0][prt];
			
			funcRemovePrt(s0,s[1],NbCnt,NbPrt);	//Е폜
			//if(func1(s0,s[1],rings)){ continue;}
			
			
			//(III)
			while(i<1024){
				
				//ring mode
				s[i+1] = funcSmallArg(s[i-1],s[i],dat,NbCnt,NbPrt);
				
				if (s[i+1] == -1){
					//find the edge of string
					printf("error: finding string\n");
					NbCnt[s[i]];
					{
						int m=0,kk;
						int cntcnt;
						while(rings[m]){
							if (rings[m] <0){
								cntcnt = - rings[m];
							}else{
								cntcnt = rings[m];
							}
							for (kk = m + 1; kk <= m + cntcnt; kk++){
								if(rings[kk] == s[i]){
									rings[m+1];
									rings[m+2];
									rings[m+3];
									rings[m+4];
									rings[m+5];
									rings[m+6];
									rings[m+7];
									rings[m+8];
									rings[m+9];
									rings[m+10];
									rings[m+11];
									rings[m+12];
									printf("err: %d,%d\n",m, rings[m]);
									

								}
							}
							m += cntcnt + 1;
						}



						}
					delete_int2D(NbPrt, dat->pcnt);
					delete_int2D(NbLIdx, dat->pcnt);
					delete [] NbCnt;
					delete [] rings;
					return NULL;
				}
				
				funcRemovePrt(s[i],s[i+1],NbCnt,NbPrt);	//Е폜
				//if (func1(s[i],s[i+1],rings)){break;}
							
				if (s0==s[i+1]){
					//find to rings
					cnt = i + 1 + 1;
					funcAddRing(rings + r, s, cnt);
					r += cnt + 1;
					break;
				}
				
				i++;
			}
		}

	}
	
	delete_int2D(NbPrt, dat->pcnt);
	delete_int2D(NbLIdx, dat->pcnt);
	delete [] NbCnt;
	return rings;
}


void checkRing1(ATOMS_DATA* dat){


	int* rings;
	int ringcnt;
	int stringcnt;
	int branchcnt;
	int rnums[2048];
	int chiral;
	int k,i;
	
	for (i=0;i<2048;i++){
		rnums[i] = 0;
	}

	rings = AI_FindRing(dat);
	if(rings==NULL){return;}

	i = 0;
	ringcnt = 0;
	stringcnt = 0;
	branchcnt = 0;
	while(rings[i]){
		if(rings[i] < 0){
			branchcnt++;
			i += -rings[i] + 1;
		}else{
			if(rings[i+1]==rings[i + rings[i]]){
				ringcnt++;
				rnums[rings[i] + 1024]++;
				
				chiral = funcCheckChiral(rings + i + 1,rings[i],dat);
				if (chiral != 1){
					printf("Chiral = %d\n", chiral);
					for(k=i+1;k<= i + rings[i];k++){
						printf("%d, ", rings[k]);
					}
					printf("\n\n");
				}
			}else{
				stringcnt++;
				//printf("string : ");
				//for(k=i+1;k<= i + rings[i];k++){
				//		printf("%d, ", rings[k]);
				//	}
				//	printf("\n\n");
				rnums[ - rings[i] + 1024]++;
			}
			i += rings[i] + 1;
		}
		
	}
	delete [] rings;
	
	printf("frame = %d\n",dat->no);
	printf("num of rings = %d\n",ringcnt);
	printf("num of strings = %d\n",stringcnt);
	printf("num of branchs = %d\n",branchcnt);
}


int cmpRing(int *s1, int *s2){
	//ring̔r
	//߂lF1=, 0=قȂ
	
	int i,cnt;

	if(s1[0]!=s2[0]){return 0;}
	
	if (s1[0] < 0){
		cnt = - s1[0];
	}else{
		cnt = s1[0];
	}

	for(i=1;i <= s1[0]; i++){
		if(s1[i] != s2[i]){
			return 0;
		}
	}
	return 1;
	
}

int findBranchPosition(int* rings, int idx, int* blen){
	int m=0;
	int cnt;
	int tbcnt=0;
	int i;

	while(rings[m]){
		if(rings[m]<0){
			cnt = - rings[m];
			
			for(i=m + 1;i<=m+cnt;i++){
				if(rings[i] == idx){
					//branch̐[Ȃ1AȂcntA
					*blen = cnt;
					return i-m;
				}
			}
		
		}else{
			cnt = rings[m];
		}

		m += cnt + 1;
	}
	*blen = 0;
	return 0;
}




void output1(GLObj_MD* atm){
			FILE *fp;
			int* rings;
			int ringcnt;
			int stringcnt;
			int branchcnt;
			int rnums[2048];
			int i;

			
			fp = fopen(".\\rings.txt","w");
			if( fp == NULL ){  /* ֐sĂȂ */
				printf( "t@C̃I[vɎs܂\n");
				return;  /* ُI͂OȊOԂ */
			}
			
			for (i=0;i<2048;i++){
				rnums[i] = 0;
			}
			atm->goFirst();
			branchcnt=0;
			while(atm->GetDataPointer()){
				rings = AI_FindRing(atm->GetDataPointer());
				if(rings == NULL){
					atm->goNext();
					continue;
				}
				i = 0;
				ringcnt = 0;
				stringcnt = 0;
				while(rings[i]){
					if(rings[i] < 0){
						branchcnt++;
						//rnums[rings[i] + 1024]++;
						i += -rings[i] + 1;
					}else if(rings[i] < 1024){
						if(rings[i+1]==rings[i + rings[i]]){
							ringcnt++;
							rnums[rings[i] + 1024]++;
						}else{
							stringcnt++;
							rnums[ - rings[i] + 1024]++;
						}
						i += rings[i] + 1;
					}
					
				}
				delete [] rings;

				for (i=0;i<2048;i++){
					if(rnums[i] > 0){
						if(i >= 1024){
							fprintf(fp, " %d  %f %d %d\n",atm->GetDataPointer()->no, atm->GetDataPointer()->tempave, i - 1024, rnums[i]);
						}else{
							fprintf(fp, " %d  %f %d %d\n",atm->GetDataPointer()->no, atm->GetDataPointer()->tempave, i - 1024, rnums[i]);
						}
						rnums[i] = 0;
					}
				}
				//printf("frame = %d\n",atm->GetDataPointer()->no);
				//printf("num of rings = %d\n",ringcnt);
				//printf("num of strings = %d\n",stringcnt);
				if(atm->goNext() == 0){
					break;
				}
			}
			fclose(fp);
		}

int getRingCount(int* rings){
	int i = 0;
	int ringcnt = 0;
	int stringcnt = 0;
	int branchcnt = 0;
	while(rings[i]){
		if(rings[i] < 0){
			branchcnt++;
			i += -rings[i] + 1;
		}else{
			if(rings[i+1]==rings[i + rings[i]]){
				ringcnt++;
			
			}else{
				stringcnt++;
			}
			i += rings[i] + 1;
		}
		
	}
	return ringcnt;
}

int output2_sub(ATOMS_DATA* dat,FILE* fp,FILE* fp2){
	static int* old_li = NULL;
	static int* old_lj = NULL;
	static int old_bcnt = 0;
	static int* old_rings = NULL;
	//static int old_ringcnt = 0;
	
	if(old_rings == NULL){
		old_bcnt = dat->bcnt;
		old_li = new int[old_bcnt];
		old_lj = new int[old_bcnt];
		memcpy(old_li, dat->li,sizeof(int)*old_bcnt);
		memcpy(old_lj, dat->lj,sizeof(int)*old_bcnt);

		old_rings = AI_FindRing(dat);
		if (old_rings){
			return getRingCount(old_rings);
		}else{
			return 0;
		}
	}

	int* &li = dat->li;
	int* &lj = dat->lj;
	int &bcnt = dat->bcnt;
	
	int i,oi, k, m, cnt;
	int broken_kind;
	int* rings;
	
	int r1m,r2m;

	//int ret;
	
	rings = AI_FindRing(dat);
	if(rings==NULL){return 0;}
	
	//؂ꂽ{hT----------------------------------

	for(i = 0; i < bcnt; i ++){
		for(oi = 0; oi < old_bcnt; oi ++){
			if(li[i] == old_li[oi]){
				if(lj[i] == old_lj[oi]){
					old_li[oi] = old_lj[oi] = -1;
					break;
				}
			}else if(li[i] == old_lj[oi]){
				if(lj[i] == old_li[oi]){
					old_li[oi] = old_lj[oi] = -1;
					break;
				}
			}
		}
		if(oi == old_bcnt){	
			// New bond is found, which is between li[i] and lj[i].
			//̂ƂɉȂ

		}
	}

	
	for(oi = 0; oi < old_bcnt; oi ++){
		if((old_li[oi] >= 0) || (old_lj[oi] >= 0)){
			// Broken bond is found, which is between old_li[oi] and old_lj[oi].
			//؂ꂽ{h----------------------------------

			printf("broken bond :%d - %d\n", old_li[oi], old_lj[oi]);
			
			broken_kind = 0;
			m = 0;
			r1m=-1;
			while(old_rings[m]){
				if(old_rings[m]<0){
					cnt = - old_rings[m];
				}else{
					cnt = old_rings[m];
				}

				for(k = m + 1; k < m + cnt; k++){
					if( ((old_rings[k+1] == old_li[oi]) && (old_rings[k] == old_lj[oi]))
						|| ((old_rings[k] == old_li[oi]) && (old_rings[k+1] == old_lj[oi])) ){
						//old_li[oi]-old_lj[oi]{h(͍lȂ)܂ring or string̔
							
						if (old_rings[m + 1] == old_rings[m + cnt]){
							//ring
							broken_kind += 100;
							if(r1m==-1){
								r1m = m;
							}else{
								r2m = m;								
							}

							for(i = m + 1; i <= m + cnt; i++){
								printf("%d, ", old_rings[i]);
							}
							printf(".\n");

						}else if (old_rings[m] < 0){
							//branch
							broken_kind += 10;

							//Ő؂ꂽH
							fprintf(fp, " %d  %f %d %d %d\n", dat->no, dat->tempave, broken_kind, cnt - 1, k - m - 1);
							//frame, x, branch = 10, ̃u`̒, łR̒

				

						}else{
							//string
							broken_kind += 1;
						}
					}
				}
				m += cnt + 1;
			}

			//printf("broken_kind = %d\n", broken_kind);
			switch (broken_kind){
			case 0:
				printf("error\n");
				break;
			case 1:
				printf("broken string\n");
				break;
			case 2:
				printf("broken string 2\n");
				break;
			case 10:
				printf("broken branch\n");
				
				break;
			case 20:
				printf("broken branch 2\n");
				break;
			case 100:
				printf("broken ring\n");
				break;
			case 200:	//̃Ǒ
				{
					int ret1, ret2,blen1,blen2;
					ret1 = findBranchPosition(rings, old_li[oi], &blen1);
					ret2 = findBranchPosition(rings, old_lj[oi], &blen2);
					
					fprintf(fp2, " %d  %f %d %d %d %d %d %d %d\n", dat->no, dat->tempave, broken_kind, old_rings[r1m], old_rings[r2m], blen1, blen2, ret1, ret2);
					//frame, x, ring * 2 = 200, ring1̃TCY, ring2̃TCY, branch1̒, branch2̒, branch1lïʒu, branch1lj̈ʒu([1)
					

				//	fprintf("broken ring 2 --> new branch %d",tbcnt);
				}

				break;
			default:
				printf("other number\n");

			}
			printf("\n");

		}
	}
	

	//obt@̕ۑ

	delete [] old_li;
	delete [] old_lj;
	delete [] old_rings;

		old_bcnt = dat->bcnt;
		old_li = new int[old_bcnt];
		old_lj = new int[old_bcnt];
		memcpy(old_li, dat->li,sizeof(int)*old_bcnt);
		memcpy(old_lj, dat->lj,sizeof(int)*old_bcnt);
		old_rings = rings;

	return getRingCount(rings);
}




void output2(GLObj_MD* atm){
	FILE *fp, *fp2;
	int fst_ringcnt = 0;
	int now_ringcnt = 0;

	fp = fopen("yield_string.txt","w");
	if( fp == NULL ){  /* ֐sĂȂ */
		printf( "t@C̃I[vɎs܂\n");
		return;  /* ُI͂OȊOԂ */
	}
	
	fp2 = fopen("yield_branch.txt","w");
	if( fp == NULL ){  /* ֐sĂȂ */
		printf( "t@C̃I[vɎs܂\n");
		return;  /* ُI͂OȊOԂ */
	}
	
	atm->goFirst();
	while(atm->GetDataPointer()){
		if(fst_ringcnt==0){
			fst_ringcnt = output2_sub(atm->GetDataPointer(), fp, fp2);
		}else{
			now_ringcnt = output2_sub(atm->GetDataPointer(), fp, fp2);
			if(now_ringcnt){
				if(now_ringcnt * 2 <= fst_ringcnt){
					printf("half rings desconnected. %d\n",(atm->GetDataPointer())->no);
					break;

				}
			}
		}
		

					
		if(atm->goNext() == 0){
			
			break;
		}
	}
	fclose(fp);
	printf("finish : create string\n");
}


int** new_int2D(int x, int y){
	int **a;
	int i;

	a = new int*[x];
	for (i = 0; i < x; i++){
		a[i] = new int[y];
	}
	
	return a;
}

void delete_int2D(int **a, int x){
	int i;
	
	for (i = 0; i < x; i++){
		delete [] a[i];
	}
	delete [] a;
	
}

