
#define _CRT_SECURE_NO_DEPRECATE

#include "instanceRenderer.h"
#define PI		(3.141529f)

///////////////////////////////////////////////////////////////////////////////////////////////
//   V`
/////////////////////////////////////////////////////////////////////////////////////////////////


InstanceRenderer::InstanceRenderer(ROW_CORE* dx_com, UINT vertexBufSz, UINT indexBufSz)
	: BasicRenderer(dx_com,vertexBufSz,indexBufSz){

	
	m_instanceBufSz = 0;
	m_pInstanceBuffer = NULL;

	UpdateInstanceBuffer(NULL, 200, sizeof(vec3f));


};

InstanceRenderer::~InstanceRenderer(){
	SAFE_RELEASE(m_pInstanceBuffer);
}


HRESULT InstanceRenderer::InitShader(){
	TCHAR filepath[MAX_PATH];
	GetAttachedFileName(filepath, _T("shader02.fx"));

//Vertex Shader--------------------------------------

    // Define the input layout
    D3D11_INPUT_ELEMENT_DESC layout[] =
    {//namae, buffer̃CfbNX, `, obt@, 擪̊i[ꏊ, _orCX^X, CX^X̌JԂ.
        { "POSITION", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 0, D3D11_INPUT_PER_VERTEX_DATA, 0 },
		{ "NORMAL", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 12, D3D11_INPUT_PER_VERTEX_DATA, 0 },
        { "INS_POS", 0, DXGI_FORMAT_R32G32B32_FLOAT, 1, 0, D3D11_INPUT_PER_INSTANCE_DATA, 1 }
    };
	UINT numElements = ARRAYSIZE( layout );
	m_pVertexShader = m_dx_com->comShader->LoadVertexShader( filepath, "VS_INSTANCE", "vs_4_0", layout, numElements, &m_pVertexLayout);


//Pixel Shader-----------------------------------------
    //hr = CompilePixelShader( L"shader02.fx", "PS", "ps_4_0");
	m_pPixelShader = m_dx_com->comShader->LoadPixelShader(filepath, "PS_INSTANCE", "ps_4_0");

//------------------------------------------------------------
//Vertex buffer̍쐬.


    D3D11_BUFFER_DESC bd;
    bd.ByteWidth = m_vertexBufSz;
    bd.Usage = D3D11_USAGE_DEFAULT;
    bd.BindFlags = D3D11_BIND_VERTEX_BUFFER;
	bd.CPUAccessFlags = 0;
	bd.MiscFlags = 0;
	bd.StructureByteStride=0;
	

    HRESULT hr = m_dx_com->pd3dDevice->CreateBuffer( &bd, NULL, &m_pVertexBuffer );
    if( FAILED( hr ) )
        return hr;

    // Set vertex buffer
    //m_vertex_stride = sizeof( VERTEX_3V2 );
/*
//------------------------------------------------------------
//Vertex buffer (INSTANCE)̍쐬.

	m_instance_count = 2;
	vec3f* instance_pos = new vec3f[2];
	instance_pos[0].Set(1.0f, 0.0f, 0.0f);
	instance_pos[1].Set( -1.0f, 0.0f, 0.0f);
	
    //D3D11_BUFFER_DESC bd;
    bd.ByteWidth = sizeof( vec3f ) * m_instance_count;
    bd.Usage = D3D11_USAGE_DEFAULT;
    bd.BindFlags = D3D11_BIND_VERTEX_BUFFER;
	bd.CPUAccessFlags = 0;
	bd.MiscFlags = 0;
	bd.StructureByteStride=0;

    D3D11_SUBRESOURCE_DATA instanceSD;
    instanceSD.pSysMem = instance_pos;
    instanceSD.SysMemPitch = 0;
    instanceSD.SysMemSlicePitch = 0;
	

    hr = m_dx_com->pd3dDevice->CreateBuffer( &bd, &instanceSD, &m_pInstanceBuffer );
    if( FAILED( hr ) )
        return hr;

    // Set vertex buffer
    stride = sizeof( vec3f );
    offset = 0;
    m_dx_com->pd3dDC->IASetVertexBuffers( 1, 1, &m_pInstanceBuffer, &stride, &offset );
*/
//---------------------------------------------------------
//Index buffer̍쐬.


	bd.ByteWidth = m_indexBufSz;
    bd.Usage = D3D11_USAGE_DEFAULT;
    bd.BindFlags = D3D11_BIND_INDEX_BUFFER;
	bd.CPUAccessFlags = 0;
	bd.MiscFlags = 0;
	bd.StructureByteStride=0;
	

    hr = m_dx_com->pd3dDevice->CreateBuffer( &bd, NULL, &m_pIndexBuffer );
    if( FAILED( hr ) )
        return hr;

//	if(idxsz == 2){
//		m_index_format = DXGI_FORMAT_R16_UINT;
//	}else{
//		m_index_format = DXGI_FORMAT_R32_UINT;
//	}

    // Set primitive topology
    m_dx_com->pd3dDC->IASetPrimitiveTopology( D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST );


//-----------------------------------------------------------------------
//Constant buffer̍쐬
//constant bufferƂ́AJʒu⃏[hϊsȂ,
//CPUGPŮeXbhɃANZXobt@.
//[hs:fglobalԂɐݒuƂ̈ʒu(sړ)(])Zbgs.
//r[s:J猩Wn֕ϊ.
//ˉes:2W֕ϊ


	//projection, view, world matrixes
	bd.ByteWidth = sizeof( mat44f )*3 + sizeof(float)*4;
    bd.Usage = D3D11_USAGE_DYNAMIC;
    bd.BindFlags = D3D11_BIND_CONSTANT_BUFFER;
	bd.CPUAccessFlags = D3D11_CPU_ACCESS_WRITE;	//CPȔ
	bd.MiscFlags = 0;
	bd.StructureByteStride=0;
	//SUBRESOURCEɂ鏉l͐ݒ肵Ȃ

    hr = m_dx_com->pd3dDevice->CreateBuffer( &bd, NULL, &m_pWVPBuffer );
    if( FAILED( hr ) )
        return hr;

/*	//Light position.
	bd.ByteWidth = sizeof( float )*4;	
	hr = pd3dDevice->CreateBuffer( &bd, NULL, &m_pLightBuffer );
    if( FAILED( hr ) )
        return hr;
*/	

    return S_OK;
}



void InstanceRenderer::UpdateInstanceBuffer(LPVOID pBuffer, UINT count, UINT stride){
	
	

	if(count * stride > m_instanceBufSz){
		//CX^Xobt@̍쐬ETCYύX


		//łɃobt@ꍇ͋LĂ,
		//Vobt@GPUɃZbgĂÂقRelease	
		ID3D11Buffer* m_pOldBuffer = NULL;
		if(	m_pInstanceBuffer ){
			m_pOldBuffer = m_pInstanceBuffer;
		}

		m_instanceBufSz = count * stride;
		
		D3D11_BUFFER_DESC bd;
		bd.ByteWidth = stride * count;
		bd.Usage = D3D11_USAGE_DEFAULT;		//D3D11_USAGE_DYNAMIC;
		bd.BindFlags = D3D11_BIND_VERTEX_BUFFER;
		bd.CPUAccessFlags = 0;				//D3D11_CPU_ACCESS_WRITE;
		bd.MiscFlags = 0;
		bd.StructureByteStride=0;

		HRESULT hr = m_dx_com->pd3dDevice->CreateBuffer( &bd, NULL, &m_pInstanceBuffer );
		if( FAILED( hr ) )
			return;
	
		if(m_pOldBuffer) m_pOldBuffer->Release();

	}///obt@̍쐬I

	if(pBuffer == NULL){//NULL̏ꍇ̓obt@쐬ďI.
		return;
	}

	UINT offset = 0;
    //m_dx_com->pd3dDC->IASetInputLayout( m_pVertexLayout );
    m_dx_com->pd3dDC->IASetVertexBuffers( 1, 1, &m_pInstanceBuffer, &stride, &offset );
	
	
	D3D11_BOX destRegion;
	destRegion.left = 0;
	destRegion.right = stride * count;
	destRegion.top = 0;
	destRegion.bottom = 1;
	destRegion.front = 0;
	destRegion.back = 1;
	m_dx_com->pd3dDC->UpdateSubresource( m_pInstanceBuffer, 0, &destRegion, pBuffer, 0, 0);

	return;

}


void InstanceRenderer::Draw(UINT indexCountParOne, UINT instanceCount){

	//ϊs
	mat44f world_matrix;
	world_matrix.SetIdentity();
	
	//Blendݒ///////////////////////////////
	//ftHg̃uhXe[g.
	ID3D11BlendState*		org_pBlendState;
	FLOAT org_BlendFactor[4];
	UINT org_SampleMask;
	if(m_blend_enable){
		
		//BlendStateIuWFNgT.
		ID3D11BlendState* pBlendState = m_blend_master.find(m_BlendDesc);
		//BlendStateIuWFNg쐬ȂVK쐬
		if(pBlendState == NULL){
			HRESULT hr = m_dx_com->pd3dDevice->CreateBlendState(&m_BlendDesc, &pBlendState);
		}
		//BlendStateIuWFNgݒ.
		if(pBlendState){
			m_dx_com->pd3dDC->OMGetBlendState(&org_pBlendState, org_BlendFactor, &org_SampleMask);
			m_dx_com->pd3dDC->OMSetBlendState(pBlendState, org_BlendFactor, org_SampleMask);
		}
	}
	//XeVݒ////////////////////////////////////
	//ftHg̃XeVXe[g.
//	ID3D11DepthStencilState*		org_pDepthStencilState;
//	UINT org_StencilRef;

	/////////////////////////////////////////////////

	// Set the input layout
    m_dx_com->pd3dDC->IASetInputLayout( m_pVertexLayout );
	
    // Set primitive topology
    m_dx_com->pd3dDC->IASetPrimitiveTopology( D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST );

	//萔obt@̏.
	D3D11_MAPPED_SUBRESOURCE mappedResource;
	m_dx_com->pd3dDC->Map( m_pConstantBuffers[0], 0, D3D11_MAP_WRITE_DISCARD, 0,&mappedResource);
	CopyMemory(mappedResource.pData, &world_matrix, sizeof(mat44f));
	CopyMemory((float*)mappedResource.pData + 16, m_pViewMatrix, sizeof(mat44f));
	CopyMemory((float*)mappedResource.pData + 32, m_pProjectionMatrix, sizeof(mat44f));
	CopyMemory((float*)mappedResource.pData + 48, m_ambient_color, sizeof(float)*4);
	m_dx_com->pd3dDC->Unmap( m_pConstantBuffers[0], 0);

	//obt@̃Zbg.	
    UINT offset = 0;
    m_dx_com->pd3dDC->IASetVertexBuffers( 0, 1, &m_pVertexBuffer, &m_vertex_stride, &offset );
	m_dx_com->pd3dDC->IASetIndexBuffer( m_pIndexBuffer, m_index_format, 0 );

    // CX^Xvertex buffer
    UINT stride = sizeof( vec3f );
    m_dx_com->pd3dDC->IASetVertexBuffers( 1, 1, &m_pInstanceBuffer, &stride, &offset );


    // Render materials
	m_dx_com->pd3dDC->VSSetShader( m_pVertexShader, NULL, 0 );
	m_dx_com->pd3dDC->VSSetConstantBuffers(0, 1, m_pConstantBuffers);
	
	
	m_dx_com->pd3dDC->GSSetShader( NULL, NULL, 0 );

	m_dx_com->pd3dDC->PSSetShader( m_pPixelShader, NULL, 0 );	//Untex
	m_dx_com->pd3dDC->PSSetConstantBuffers(0, 1, m_pConstantBuffers);

	m_dx_com->pd3dDC->DrawIndexedInstanced( indexCountParOne, instanceCount, 0, 0, 0);

	//Blendݒ///////////////////////////////
	if(m_blend_enable){
		m_dx_com->pd3dDC->OMSetBlendState(org_pBlendState, org_BlendFactor, org_SampleMask);
	}
//	if(m_pDepthStencilState){
//		m_dx_com->pd3dDC->OMSetDepthStencilState(org_pDepthStencilState, org_StencilRef);
//	}

}


void CreatePolygonSphere(float radius, int slices, int stacks, vec3f** ppVertex, int* pVertexCount, WORD** ppIndex, int* pIndexCount){

	int i, k;
	double daXY = 2.0*PI/double(stacks);
	double daZX = PI/double(slices);
	double angleZX;
	double angleXY;
	float cosZX, sinZX;
	float *cosXY, *sinXY;
	

	//_f[^̃Zbg.
	cosXY = new float[stacks];
	sinXY = new float[stacks];
	
	angleXY = daXY;
	cosXY[0] = 1.f;
	sinXY[0] = 0.f;
	for (i = 1; i < stacks; i++){
		cosXY[i] = (float)cos(angleXY);
		sinXY[i] = (float)sin(angleXY);
		angleXY += daXY;
	}

	int vertex_count = (slices - 1) * stacks + 2;
	VERTEX_3V2* ver = new VERTEX_3V2[vertex_count];
	*ppVertex = (vec3f*)ver;


	ver->position.Set(0.0f,0.0f,(float)radius);
	ver->normal.Set(0.0f, 0.0f, 1.0f);
	ver++;

	angleZX = daZX;
	for (i = 1; i < slices; i++){
		cosZX = (float)cos(angleZX);
		sinZX = (float)sin(angleZX);

		for (k = 0; k < stacks; k++){
			
			ver->normal.Set(sinZX * cosXY[k], sinZX * sinXY[k], cosZX);
			ver->position = ver->normal * radius;

			ver++;
		}
		angleZX += daZX;
	}
	
	ver->position.Set(.0f,0.0f, -radius);
	ver->normal.Set(0.0f, 0.0f, -1.0f);
	
	delete [] cosXY;
	delete [] sinXY;


	//CfbNXz̃Zbg.
	int index_count = (slices - 1)*stacks*6;
	WORD* idx = new WORD[index_count];
	*ppIndex = idx;
	int offset = 1;
	for(i=0; i < stacks; i++){
		*idx = 0;
		idx++;
		*idx = i + offset;
		idx++;
		*idx = ((i + 1) % stacks) + offset;
		idx++;
	}
	//offset += stacks;
	
	
	for (k = 0; k < slices - 2; k++){
		for(i=0; i < stacks; i++){
			*idx = i + offset;
			idx++;
			*(idx + 3) = *idx = i + offset + stacks;
			idx++;
			*(idx + 1) = *idx = ((i + 1) % stacks) + offset;
			idx+=3;
			*idx = ((i + 1) % stacks) + offset + stacks;
			idx++;
		}
		offset += stacks;
	}

	for(i=0; i < stacks; i++){
		*idx = i + offset;
		idx++;
		*idx = vertex_count - 1;
		idx++;
		*idx = ((i + 1) % stacks) + offset;
		idx++;
	}
	
//	*ppVertex = (vec3f*)ver;
	*pVertexCount = vertex_count;
//	*ppIndex = idx;
	*pIndexCount = index_count;
};
