//=====================================
// CX^X\NX
//
//
// 
//=====================================

#ifndef __InstanceRenderer_h__
#define __InstanceRenderer_h__


#pragma once

#define WIN32_LEAN_AND_MEAN             // Windows wb_[gpĂȂO܂B
#include <windows.h>

#include <stdio.h>
#include <tchar.h>
#include <string.h>
#include <math.h>

#include <d3d11.h>
#include <d3dx11.h>
#include <d3dcompiler.h>

#include "vec3.h"
#include "mat44.h"


#include "rowdog.h"
#include "BasicRenderer.h"
#include "debugprint.h"

/*
class SphereInstanceDX11{
private:

//DX11pO[oIuWFNg--------------------
	ROW_CORE* m_dx_com;

//DX11 shader---------------------------------------

	ID3D11VertexShader*     m_pVertexShader;
	ID3D11PixelShader*      m_pPixelShader;
	//ID3D11PixelShader*      m_pPixelShaderUntex;
	ID3D11InputLayout*      m_pVertexLayout;
	ID3D11Buffer*           m_pVertexBuffer;
	ID3D11Buffer*           m_pInstanceBuffer;
	ID3D11Buffer*           m_pIndexBuffer;


	UINT			m_vertex_stride;
	DXGI_FORMAT		m_index_format;
	
	mat44f* m_pViewMatrix;
	mat44f* m_pProjectionMatrix;

	union {
		ID3D11Buffer* m_pConstantBuffers[2];
		struct {
			ID3D11Buffer*			m_pWVPBuffer;
			ID3D11Buffer*			m_pLightBuffer;
		};
	};
	
//	ID3D11ShaderResourceView**           m_pTextureRVArray;	//eNX`.
//	ID3D11SamplerState*                 m_pSampler;

	HRESULT CompileShaderFromFile( WCHAR* szFileName, LPCSTR szEntryPoint, LPCSTR szShaderModel, ID3DBlob** ppBlobOut );

	
	struct VERTEX_3V2 {
		vec3f position;
		vec3f normal;
	};
	VERTEX_3V2* m_vertex;
	UINT m_vertex_count;

	WORD* m_index;
	UINT m_index_count;

	UINT m_instance_count;

	mat44f CreateViewMatrix(vec3f* target, vec3f* origin, vec3f* up);
	mat44f CreateProjectionPerspectiveMatrix(float angle, float wph, float z_near, float z_far);

	void InitData(float radius, int slices, int stacks);
	HRESULT InitShader();
	void DeleteShader();

public:
	
	SphereInstanceDX11(ROW_CORE* dx_com);
	virtual ~SphereInstanceDX11();
	
	void SetInstanceCount(int count);
	void Render(vec3f* positions, int count);

	void SetViewMatrixPointer(mat44f* pViewMatrix );
	void SetProjectionMatrixPointer(mat44f* pProjectionMatrix );

};
*/

struct VERTEX_3V2 {
	vec3f position;
	vec3f normal;
};

class InstanceRenderer : public BasicRenderer{
private:

	UINT m_instanceBufSz;
	ID3D11Buffer*           m_pInstanceBuffer;

	
public:
	InstanceRenderer(ROW_CORE* dx_com, UINT vertexBufSz, UINT indexBufSz);
	virtual ~InstanceRenderer();

	//VF[_[ǂݍ݂̃I[o[Ch.
	HRESULT InitShader();	


	void UpdateInstanceBuffer(LPVOID pBuffer, UINT count, UINT stride);
	void Draw(UINT indexCountParOne, UINT instanceCount);

};


void CreatePolygonSphere(float radius, int slices, int stacks, vec3f** ppVertex, int* pVertexCount, WORD** ppIndex, int* pIndexCount);


#endif    // __InstanceRenderer_h__


