

#define _CRT_SECURE_NO_WARNINGS

#include <stdio.h>
#include <string.h>
#include "plugSSCoordinate.h"
#include "ai_molecule.h"
#include "debugprint.h"



void plugFrameSS_Coordinate(const TCHAR* filepath, int dirlen, ATOMS_DATA *dat){

//t@C///////////////////////////////////////
	TCHAR* myfilepath = new TCHAR[dirlen + 20];

	_tcsncpy(myfilepath,filepath, dirlen);
	_tcscpy(myfilepath + dirlen, _T("coordinate.txt"));

	FILE* fp = _tfopen(myfilepath, _T("w"));
	delete [] myfilepath;

	
	_ftprintf(fp,_T("#atom\tbond\tcoord[0]\tcoord[1]...\n"));

//C//////////////////////////

	//Ԃ̍Ĕ
	if(dat->bcnt==0){ AI_ResetBond(dat);}

	int count = dat->pcnt;

	int* coord = new int[count];
	memset(coord, 0, sizeof(int) * count);

	//{h[v
	SIMPLE_IJ* bond_end = dat->bonds + dat->bcnt;
	for(SIMPLE_IJ* bonds = dat->bonds; bonds != bond_end; bonds++){
		coord[bonds->i] ++;
		coord[bonds->j] ++;
	}
	
	int num_atom_coord[20] = {0};

	int valid_count=0;
/*
	//q[v
	int* knd = dat->knd;
	for(int i = 0; i < count; i++){
		if(knd[i] > 1){
			num_atom_coord[coord[i]] ++;
			valid_count++;
		}
	}
*/

	//q[v
	int* id= dat->id;
	bool *flags = new bool[count+1];
	memset(flags, 0, sizeof(bool) * (count+1));
	for(int i = 0; i < count; i++){
		if(flags[id[i]]){
			num_atom_coord[coord[i]] ++;
			valid_count++;
		}else{
			flags[id[i]] = true;
		}
	}
	delete [] flags;

	delete [] coord;

	//t@Co
	_ftprintf(fp,_T("%d\t%d"), valid_count, dat->bcnt);
	for(int i = 0; i < 20; i++){
		_ftprintf(fp,_T("\t%d"), num_atom_coord[i]);
	}
	
//t@CI//////////////////////////

	fclose(fp);
	fp = NULL;

}
