#define _CRT_SECURE_NO_WARNINGS

#include <stdio.h>
#include <string.h>
#include "plugTDCoordinate.h"
#include "ai_molecule.h"
#include "debugprint.h"

static FILE* fp = NULL;


static int framenum = 0;


void plugReadyTD_Coordinate(const TCHAR* filepath, int dirlen){

	TCHAR* myfilepath = new TCHAR[dirlen + 20];

	_tcsncpy(myfilepath,filepath, dirlen);
	_tcscpy(myfilepath + dirlen, _T("tdcoordinate.txt"));

	fp = _tfopen(myfilepath, _T("w"));
	delete [] myfilepath;

	
	_ftprintf(fp,_T("#atom\tbond\tcoord[0]\tcoord[1]...\n"));

	framenum=0;

}


void plugFrameTD_Coordinate(ATOMS_DATA *dat){
	
	//Ԃ̍Ĕ
	if(dat->bcnt==0){ AI_ResetBond(dat);}

	int count = dat->pcnt;

	int* coord = new int[count];
	memset(coord, 0, sizeof(int) * count);

	//{h[v
	SIMPLE_IJ* bond_end = dat->bonds + dat->bcnt;
	for(SIMPLE_IJ* bonds = dat->bonds; bonds != bond_end; bonds++){
		coord[bonds->i] ++;
		coord[bonds->j] ++;
	}
	
	int num_atom_coord[20] = {0};

	//q[v
	for(int i = 0; i < count; i++){
		num_atom_coord[coord[i]] ++;
	}

	delete [] coord;

	//t@Co
	_ftprintf(fp,_T("%d\t%d\t%d"), framenum, count, dat->bcnt);
	for(int i = 0; i < 20; i++){
		_ftprintf(fp,_T("\t%d"), num_atom_coord[i]);
	}
	_ftprintf(fp,_T("\n"));
	
	framenum++;
}

void plugFinishTD_Coordinate(ATOMS_DATA *dat){
	//datɂ͍ŏIt[.

	
	fclose(fp);
	fp = NULL;


}

double GetSurface(ATOMS_DATA* dat){
	//MolListɁA傫qoNƔFĕ\ʍWԂ
	//
	
	
	double max_z = -1.0E100;

	if(dat->bcnt==0){ AI_ResetBond(dat);}
	
	int *pNext = AI_CreateMolList(dat);

	for (int i = 0; i < dat->pcnt; i++){
		//Ȃhead̔ԍŕ𕉂ɂl
		if (pNext[i] >=0){ continue;}

		//ɐi񂾏ꍇ͕q̐擪̌q.
		int count = 0;
		double mol_max_z = -1.0E100;


		//qĂ錴q̃[v
		int head = -pNext[i] -1;
		for (int li = head; li >= 0; li = pNext[li]){

			count ++;
			if(mol_max_z < dat->r[li].z) mol_max_z = dat->r[li].z;
		}

		//傫ȕqȂ\ʂ̍XV
		if(count > 50){
			if(max_z < mol_max_z) max_z = mol_max_z;
		}
		

	}

	delete [] pNext;

	return max_z;

}
