//////////////////////////////////////////////////////////////
//
//		Rough Wrapper of DirectX and OpenGl (rowdog)
//
//////////////////////////////////////////////////////////////

#ifndef __rowdog_h__
#define __rowdog_h__


#pragma once



#include "vec3.h"
#include "mat44.h"


#ifdef _USE_GL

typedef	UINT ROW_TEXTURE;

struct ROW_CORE{
//	ID3D11Device*			pd3dDevice;
//	ID3D11DeviceContext*	pd3dDC;
//	CommonShader*			comShader;
//	CommonTexture*			comTexture;
};

#else


////////////////////////////////////////////
//DirectXwb_[
#include <d3d11.h>
#include <d3dx11.h>
#include <d3dcompiler.h>

#pragma comment( lib, "d3d11.lib" )
#if defined(DEBUG) || defined(_DEBUG)
#pragma comment( lib, "d3dx11d.lib" )
#else
#pragma comment( lib, "d3dx11.lib" )
#endif
#pragma comment( lib, "dxerr.lib" )
#pragma comment( lib, "dxgi.lib" )

//d3dx11_43.dllKxǂݍ݂ɂ邱.
//dll̖̐SDKƃ^C̃o[WɈˑ.


/////////////////////////////////////

#include "CommonShader.h"
#include "CommonTexture.h"

#define SAFE_RELEASE(p) if(p){(p)->Release(); (p)=NULL;}

typedef ID3D11ShaderResourceView*	ROW_TEXTURE;

struct ROW_CORE{
	ID3D11Device*			pd3dDevice;
	ID3D11DeviceContext*	pd3dDC;
	IDXGISwapChain*			pSwapChain;
	ID3D11RenderTargetView*	pRenderTargetView;
	ID3D11DepthStencilView*	pDepthStencilView;	// [x/XeVEr[

	CommonShader*			comShader;
	CommonTexture*			comTexture;
};

#endif



struct TEXTURE_INFO{
	int					width;
	int					height;
};



///////////////////////////////////////////////////////////////////
//ϊspCu
///////////////////////////////////////////////////////////////////

void SetViewMatrix(vec3f* target, vec3f* origin, vec3f* up, mat44f* pViewMatrix);
void SetProjectionPerspectiveMatrix(float angle, float wph, float z_near, float z_far, mat44f* pProjectionMatrix);

/////////////////////////////
//݊pp[^
#define DOG_BLEND                          0x0BE2

#define DOG_ZERO                           0
#define DOG_ONE                            1
#define DOG_SRC_COLOR                      0x0300
#define DOG_ONE_MINUS_SRC_COLOR            0x0301
#define DOG_SRC_ALPHA                      0x0302
#define DOG_ONE_MINUS_SRC_ALPHA            0x0303
#define DOG_DST_ALPHA                      0x0304
#define DOG_ONE_MINUS_DST_ALPHA            0x0305
#define DOG_DST_COLOR                      0x0306
#define DOG_ONE_MINUS_DST_COLOR            0x0307
#define DOG_SRC_ALPHA_SATURATE             0x0308


#define DOG_FRONT                          0x0404
#define DOG_BACK                           0x0405
#define DOG_FRONT_AND_BACK                 0x0408

#define DOG_AMBIENT                        0x1200
#define DOG_AMBIENT_AND_DIFFUSE            0x1602



#endif	//__rowdog_h__