///////////////////////////////////////////////
//
//		ver. 20100413
//
///////////////////////////////////////////////


#include "sdkwgl.h"
#include "debugprint.h"


////VBȌ----g֐

PFNGLGENBUFFERSPROC glGenBuffers;
PFNGLISBUFFERPROC glIsBuffer;
PFNGLBINDBUFFERPROC glBindBuffer;
PFNGLBUFFERDATAPROC glBufferData;
PFNGLDELETEBUFFERSPROC glDeleteBuffers;

PFNGLACTIVETEXTUREPROC glActiveTexture;
PFNGLCLIENTACTIVETEXTUREPROC glClientActiveTexture;

PFNWGLCHOOSEPIXELFORMATARBPROC wglChoosePixelFormatARB;

int g_swapInterval = 0;
int g_refleshRate = 60;
int g_fpscounter = 0;
int g_zeroTm = 0;

//==============================
//WGL֐̏
//
//(1) hWndhDC擾
//(2) hDC̃sNZtH[}bgOpenGLpɕύX
//(3) hDCcompatibleOpenGL̃ReLXg(hRC)𔭍s
//(4) hDCƂhRC֘At
//(5) hDC̊JȂII(CS_OWNDC)
//
// WM_CREATEbZ[WnhŌĂяo
// hWndɎw肷
//==============================
HDC GetWGLDC(HWND hWnd){
	return GetWGLDCbyPixelFormat(hWnd, 0);
}

HDC GetWGLDCbyPixelFormat(HWND hWnd, int pixelFormat){
	
	int res;
	HDC hDC;

	PIXELFORMATDESCRIPTOR pfd = { 
		sizeof(PIXELFORMATDESCRIPTOR),   // size of this pfd 
		1,                     // version number 
		PFD_DRAW_TO_WINDOW |   // support window 
		//PFD_DRAW_TO_BITMAP |   // support bitmap 
		PFD_SUPPORT_OPENGL |   // support OpenGL 
		PFD_DOUBLEBUFFER,	   // double buffered 
		PFD_TYPE_RGBA,         // RGBA type 
		32,                    // 24-bit color depth 
		0, 0, 0, 0, 0, 0,      // color bits ignored 
		8,                     // no alpha buffer 
		0,                     // shift bit ignored 
		0,                     // no accumulation buffer 
		0, 0, 0, 0,            // accum bits ignored 
		16,                    // 32-bit z-buffer 
		0,                     // no stencil buffer 
		0,                     // no auxiliary buffer 
		PFD_MAIN_PLANE,        // main layer 
		0,                     // reserved 
		0, 0, 0                // layer masks ignored 
	}; 

	hDC = GetDC(hWnd);

	//hDCɓxȏSetPixelĂ͂Ȃ
	if(pixelFormat <= 0){
		pixelFormat=ChoosePixelFormat(hDC,&pfd);
	}
	res = SetPixelFormat(hDC,pixelFormat,&pfd);
	
    return hDC;

}



HGLRC CreateRC(HDC hDC){
	HGLRC hRC=wglCreateContext(hDC);
	wglMakeCurrent(hDC,hRC);
	return hRC;
}

void ReleaseRC(HGLRC hRC){

	wglMakeCurrent(0, 0);
	wglDeleteContext(hRC);
}

void Set2D(int scrW, int scrH, int scaling){
	glViewport(0, 0, scrW * scaling, scrH * scaling);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity(); // ϊs̏
	//2DȂ̂glOrthoŕ`͈͎w
	glOrtho(0.0f, (float)scrW, (float)scrH, 0.0f, 1.0f,-1.0f);
}

void SetScreen2D(int screen_x, int screen_y, int screen_w, int screen_h, float camera_w, float camera_h){
	glViewport(screen_x, screen_y, screen_w, screen_h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity(); // ϊs̏
	//2DȂ̂glOrthoŕ`͈͎w
	glOrtho(0.0f, camera_w, camera_h, 0.0f, 1.0f,-1.0f);
}


BOOL SetSwapInterval(int interval){
	//g֐󂯎֐|C^
	BOOL (WINAPI *wglSwapIntervalEXT)(int) = NULL;

	//g֐WGL_EXT_swap_controlT|[gĂ邩ׂ
	if( strstr( (char*)glGetString( GL_EXTENSIONS ), "WGL_EXT_swap_control") == 0)
	{
		//WGL_EXT_swap_controlT|[gĂȂ
		return 0;
	}
	
	//API擾Ďs
	wglSwapIntervalEXT = (BOOL (WINAPI*)(int))wglGetProcAddress("wglSwapIntervalEXT");
	if( wglSwapIntervalEXT ){
		return wglSwapIntervalEXT(interval);
		//TRACE(L"(setVSYNC: %d\n", bres);
	}

	return 0;
}


int GetSwapInterval(void){
	//g֐󂯎֐|C^
	int (WINAPI *wglGetSwapIntervalEXT)() = NULL;

	//g֐WGL_EXT_swap_controlT|[gĂ邩ׂ
	//:glGetStringhdcReleaseDCĂNULLԂ
	if( strstr( (char*)glGetString( GL_EXTENSIONS ), "WGL_EXT_swap_control") == 0)
	{
		//WGL_EXT_swap_controlT|[gĂȂ
		return 0;
	}

	wglGetSwapIntervalEXT = (int (WINAPI*)())wglGetProcAddress("wglGetSwapIntervalEXT");
	if(wglGetSwapIntervalEXT){
		return wglGetSwapIntervalEXT();
	}

	return 0;
}



int InitWaitVsync(){
	//gꍇɌĂяo
	//SwapIntervalݒGetSwapInterval̖߂l̂܂ܕԂ
	//܂A߂l1̂Ƃ
	

	HDC hdc = wglGetCurrentDC();
	if (hdc==NULL){
		return 0;
	}

	
	int def_vreflesh = GetDeviceCaps(hdc, VREFRESH);
	TRACE(TEXT("Vreflesh = %d Hz\n"), def_vreflesh);
	g_refleshRate = def_vreflesh;
	
	
	g_swapInterval = GetSwapInterval();
	TRACE(TEXT("Default Swap Interval = %d\n"), g_swapInterval);

	//Zbg
	if (g_swapInterval != 1){
		SetSwapInterval(1);	//ȓd̓[hł͖߂ltruełݒłĂȂꍇ
		g_swapInterval = GetSwapInterval();
		TRACE(TEXT("Swap Interval = %d\n"), g_swapInterval);
	}
	
	return g_swapInterval;
}


int InitWait(int refleshRate){
	//gȂꍇɌĂяo
	//SwapIntervalݒGetSwapInterval̖߂l̂܂ܕԂ
	//܂A߂l0̂Ƃ̉ɐ
	

	g_refleshRate = refleshRate;
	
	g_swapInterval = GetSwapInterval();
	TRACE(TEXT("Default Swap Interval = %d\n"), g_swapInterval);

	//
	if (g_swapInterval != 0){
		SetSwapInterval(0);	//ȓd̓[hł͖߂ltruełݒłĂȂꍇ
		g_swapInterval = GetSwapInterval();
		TRACE(TEXT("Swap Interval = %d\n"), g_swapInterval);
	}

	return g_swapInterval;
}


//KvԂX[v
//߂lFPS
double WaitSleep( int *r_sleepTm){
	//60t[̋؂̎
	//ȊÔƂ0Ԃ
	static int s_sleepTm = 0;		//60t[(1000msɃX[v)
	int tm;


////=========================================
	if (g_zeroTm == 0){
		Sleep(0);
		g_zeroTm = timeGetTime();
		g_fpscounter = 0;
		s_sleepTm = 0;

//:ON================================
	}else if (g_swapInterval){
		Sleep(0);		//Sleep(0)ׂ
		tm = timeGetTime();
		s_sleepTm = 0;
		g_fpscounter ++;
		
//:OFF================================
	}else{
		
		g_fpscounter ++;
		//FrameԂ̎Ԃ̌vZ
		double dtm = 1000.0 * ((double)g_fpscounter) / ((double)g_refleshRate);
		
		tm = timeGetTime();
		
		int sleepTm = g_zeroTm + (int)dtm - tm;
		
		if ( sleepTm > 1){
			//TRACE(TEXT("waitTm %d\n"), sleepTm);
			Sleep(sleepTm);
			tm = timeGetTime();
			s_sleepTm += sleepTm;
		}else{
			Sleep(0);
		}

	}


//fpsv(counter͂܂łɃCNgĂ)
	
	if (g_fpscounter >= g_refleshRate){
		double fps_dbl = (double)(g_fpscounter * 1000) / (double)(tm - g_zeroTm);
		g_zeroTm = tm;
		g_fpscounter = 0;
		*r_sleepTm = s_sleepTm;
		s_sleepTm = 0;
		return fps_dbl;

	}

	return 0.0;
	
}

//fpsZbg
void ResetWait(){
	g_zeroTm = 0;
	g_fpscounter = 0;
}


void LoadGLEXT(){
	
	//VBO
	glGenBuffers = (PFNGLGENBUFFERSPROC)wglGetProcAddress("glGenBuffers");
	glIsBuffer = (PFNGLISBUFFERPROC)wglGetProcAddress("glIsBuffer");
	glBindBuffer = (PFNGLBINDBUFFERPROC)wglGetProcAddress("glBindBuffer");
	glBufferData = (PFNGLBUFFERDATAPROC)wglGetProcAddress("glBufferData");
	glDeleteBuffers = (PFNGLDELETEBUFFERSPROC)wglGetProcAddress("glDeleteBuffers");

	//MultiTexture
	glActiveTexture = (PFNGLACTIVETEXTUREPROC)wglGetProcAddress("glActiveTexture");
	glClientActiveTexture = (PFNGLCLIENTACTIVETEXTUREPROC)wglGetProcAddress("glClientActiveTexture");

	//multisample
};

//}`TvȂOpenGLgT|[gPixelFormat擾
//擾ɂOpenGLgp\ȏ(wglMakeCurrentς)Ŗ΂ȂȂB
//SetPixelFormatɂύX̓EBhEɑ΂Ĉx肵ȂׁA
//_~[̃EBhEĂƂ肠PixelFormatOpenGLgp\ɂA
//wglChoosePixelFormatARBgpĊgΉPixelFormatTB
//ŌɃ_~[̃EBhE폜Ċ֐𔲂
int GetPixelFormatByDummy(HINSTANCE hInstance){

#ifdef UNICODE
#define SDKWGL_DUMMYCLASSNAME	L"sdkwgldummywnd"
#else
#define SDKWGL_DUMMYCLASSNAME	"sdkwgldummywnd" 
#endif
	
	//_~[EBhE̍쐬
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= DefWindowProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= NULL;
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= SDKWGL_DUMMYCLASSNAME;
	wcex.hIconSm		= NULL;

	RegisterClassEx(&wcex);

	
	RECT rc = { 0, 0, 320, 320};
	AdjustWindowRect(&rc, WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX | WS_CLIPCHILDREN, TRUE); // EBhEX^C	|WS_CLIPCHILDREN
	
	HWND hWnd = CreateWindow(SDKWGL_DUMMYCLASSNAME, NULL,
				WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX | WS_CLIPCHILDREN, 
				CW_USEDEFAULT, 0, rc.right - rc.left, rc.bottom - rc.top,
				NULL, NULL, hInstance, NULL);

	//Ƃ肠PixelFormatIŃ_~[EBhEOpenGLgp\ɂ
	HDC hDC = GetWGLDC(hWnd);
	HGLRC hRC = CreateRC(hDC);

	//wglChoosePixelFormatARBDLL烍[h
	wglChoosePixelFormatARB = (PFNWGLCHOOSEPIXELFORMATARBPROC)wglGetProcAddress("wglChoosePixelFormatARB");
	if( ! wglChoosePixelFormatARB ){
		ReleaseRC(hRC);
		ReleaseDC(hWnd, hDC);
		DestroyWindow(hWnd);

		return 0;
	}
	
	//GLg@\ɑΉPixelFormatT
	int		pixelFormat;
	int		valid;
	UINT	numFormats;
	float	fAttributes[] = {0,0};

	// These Attributes Are The Bits We Want To Test For In Our Sample
	// Everything Is Pretty Standard, The Only One We Want To 
	// Really Focus On Is The SAMPLE BUFFERS ARB And WGL SAMPLES
	// These Two Are Going To Do The Main Testing For Whether Or Not
	// We Support Multisampling On This Hardware.
	int iAttributes[] =
	{
		WGL_DRAW_TO_WINDOW_ARB,GL_TRUE,
		WGL_SUPPORT_OPENGL_ARB,GL_TRUE,
		WGL_ACCELERATION_ARB,WGL_FULL_ACCELERATION_ARB,
		WGL_COLOR_BITS_ARB,24,
		WGL_ALPHA_BITS_ARB,8,
		WGL_DEPTH_BITS_ARB,16,
		WGL_STENCIL_BITS_ARB,0,
		WGL_DOUBLE_BUFFER_ARB,GL_TRUE,
		WGL_SAMPLE_BUFFERS_ARB,GL_TRUE,
		WGL_SAMPLES_ARB,4,
		0,0
	};

	// First We Check To See If We Can Get A Pixel Format For 4 Samples
	valid = wglChoosePixelFormatARB(hDC,iAttributes,fAttributes,1,&pixelFormat,&numFormats);
	
	// If We Returned True, And Our Format Count Is Greater Than 1
	if (valid && numFormats >= 1)
	{
		return pixelFormat;
	}


	//finalize
	ReleaseRC(hRC);
	ReleaseDC(hWnd, hDC);
	DestroyWindow(hWnd);
	return 0;

}




///////////////////////////////////////////////////////////////////////////////
//
//_OReLXg(RC)ShareLists֘ÅǗ
//
//dl:
//OpenGLł̓EBhEƂRCB
//eNX`LEBhÉAKxhWnd{Cuɓo^B
//(RC̎g܂킵͂ȂBvistapintelhCoŏ肭Ȃ)
//ŏɓo^hWndRC}X^[ƂāA
//ShareListsœԖڈȍ~RC֘At
//SẴeNX`̓}X^[RCɐ
//
///////////////////////////////////////////////////////////////////////////////
struct SDLWGL_RC_LIST{
	HWND hWnd;
	HGLRC hRC;
};

SDLWGL_RC_LIST *g_rc_list = NULL;
int g_rc_count = 0;
int g_rc_size = 0;

//EBhEo^
void RegisterSharedRC(HWND hWnd, HGLRC hRC){
	SDLWGL_RC_LIST* rclist;

	if(g_rc_list){
		if( g_rc_size == g_rc_count){//obt@g
			g_rc_size *= 2;
			rclist = g_rc_list;
			g_rc_list = new SDLWGL_RC_LIST[g_rc_size];
			CopyMemory(g_rc_list, rclist, sizeof(SDLWGL_RC_LIST) * g_rc_count);
			delete [] rclist;
		}
	}else{
		g_rc_size = 4;
		g_rc_count = 0;
		g_rc_list = new SDLWGL_RC_LIST[g_rc_size];
	}
	rclist = g_rc_list + g_rc_count;
	g_rc_count++;

	//Wnd̓o^
	rclist->hWnd = hWnd;
	rclist->hRC = hRC;
		
								
	if(rclist != g_rc_list){
		
		//wglShareLists̑OɃJgZbgĂȂ
		//4ȏRCgpɕ\oO(intel)
		HDC hDC = GetDC(hWnd);
		wglMakeCurrent(hDC,rclist->hRC);			
		wglShareLists(g_rc_list->hRC, rclist->hRC);	//eNX`L
		ReleaseDC(hWnd, hDC);
	}
	return;
}


void ReleaseSharedRC(){
	
	wglMakeCurrent(NULL,NULL);
	int i;
	SDLWGL_RC_LIST* rclist = g_rc_list;
	for (i = 0; i < g_rc_count; i++){
		wglDeleteContext(rclist->hRC);
		rclist++;
	}
	delete [] g_rc_list;
	g_rc_list = NULL;
	g_rc_count = 0;
	g_rc_size = 0;

}

//hWndɊ֘AÂRCԂ
HGLRC GetSharedRC(HWND hWnd){
	
	int i;
	SDLWGL_RC_LIST* rclist = g_rc_list;
	for (i = 0; i < g_rc_count; i++){
		if(hWnd == rclist->hWnd){
			return rclist->hRC;
		}
		rclist++;
	}
	return NULL;
}
